2025-07-27  Nick Clifton  <nickc@redhat.com>

	Oops - test files accidentally omitted from previous deltas

2025-07-27  Indu Bhagat  <indu.bhagat@oracle.com>

	[PATCH] doc: sframe: mention errata 1 of SFrame version 2
	With the changes of an added flag SFRAME_F_FDE_FUNC_START_PCREL, s390x
	support and new section type SHT_GNU_SFRAME, indicate that this document
	specifies the errata 1 of SFrame version 2.  This will help distinguish
	the document / specification better from previous releases.

	libsframe/doc/
		* sframe-spec.texi: Mention errata 1 of SFrame version 2.

2025-07-27  Indu Bhagat  <indu.bhagat@oracle.com>

	[PATCH] readelf: objdump: sframe: fix dumping with section name
	Fix PR binutils/33186 - No SFrame dump if section name is not .sframe

	When the section name is not ".sframe", ensure that readelf and objdump
	are able to dump a section of type SHT_GNU_SFRAME and not fail if the
	user specifies the new section name.

	For objdump, in dump_dwarf_section (), use the match string of ".sframe"
	to find the corresponding debug_displays[] item for SFrame section.
	Doing this ensures that any call to dump_dwarf_section () with the
	section pointing to the SFrame section (with name possibly different
	from ".sframe") will successfully dump the SFrame section.

	If the SFrame section is named anything but ".sframe", and user does not
	specify the name of the SFrame section either, the documented behaviour
	is that the default section name is assumed to be ".sframe".  So the
	following (albeit counter intuitive) is expected at this time:

	$ readelf -S sort | grep sframe
	  [NN] .sframe2          GNU_SFRAME       0000000000NNNNNN  0000NNNN

	(Note section name .sframe2).

	$ objdump --sframe sort

	sort:     file format elf64-x86-64

	No .sframe section present

	(Similarly for readelf as well).

	For objdump, set dump_sframe_section_name to ".sframe" if user specifies
	no section name.  In the error checking done in dump_sframe_section, add
	the case when user specifies a valid section name but one that does not
	contain SFrame section data.  For sections generated with Binutils >=
	2.45, this can be checked with section type of SHT_GNU_SFRAME.
	Previously these sections were SHT_PROGBITS with name ".sframe".

	Similar changes in readelf.

	Add a test each for objdump and readelf to dump a renamed section.  Use
	gas_sframe_check to limit the execution of these tests only when a gas
	supporting SFrame format is present.

	binutils/
		PR binutils/33186
		* objdump.c (dump_dwarf_section): Set match to ".sframe" which
		corresponds to the name in the debug_displays[] entry for
		SFrame section.
		(dump_sframe_section): Check if the user specified section name
		contains SFrame data.
		(main): Set default section name to ".sframe".
		* readelf.c (display_debug_section): Adjust checks to find the
		debug_diplays[] item for the input arg SFrame section.
		Use id instead of i, as it is more readable.

	binutils/testsuite/
		PR binutils/33186
		* binutils-all/x86-64/objdump-sframe-01.d: New test.
		* binutils-all/x86-64/readelf-sframe-01.d: New test.
		* binutils-all/x86-64/sframe-func.s: New test.

2025-07-27  Indu Bhagat  <indu.bhagat@oracle.com>

	[PATCH] gas: sframe: command line option takes precedence over gas directive to emit .sframe section.
	Fix PR gas/33175 sframe: --gsframe=no does not disable when .cfi_sections directive with .sframe

	--gsframe=no should also disable generation of SFrame section when explicit CFI directive: .cfi_sections .sframe is specified in the input.
	This means we need to track whether SFrame generation was explicitly disabled by the user.
	Introduce a new enum to facilitate disambiguation between GEN_SFRAME_DEFAULT_NONE and GEN_SFRAME_DISABLED.
	While fixing the bug by adding the enum, keep the upcoming requirement in mind: we will also need to disambiguate between --enable-default-sframe and user-specified --gsframe/--gsframe=yes.
	The intent is to not display SFrame related warnings or errors like:   as_bad (_(".sframe not supported for target")); for unsupported targets if --enable-default-sframe is in effect.
	This implies we need to have a four state enum ( GEN_SFRAME_DEFAULT_NONE, GEN_SFRAME_CONFIG_ENABLED, GEN_SFRAME_DISABLED, GEN_SFRAME_ENABLED) gas

2025-07-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-25  Alice Carlotti  <alice.carlotti@arm.com>

	gas/NEWS: Add AArch64 updates

2025-07-25  Alice Carlotti  <alice.carlotti@arm.com>

	gas/doc: Update AArch64 Architecture Extensions
	Add faminmax, move a couple of misplaced entries, and improve a few
	other entries.

	The documentation now lists every recognised extension name, with the
	exception of a couple of aliases that are deliberately undocumented.

2025-07-25  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Fix sve2p2/sme2p2 dependencies
	Change dependency on sve2/sme2 to sve2p1/sme2p1.

2025-07-25  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	ld: Force SHELL=/bin/bash in ld for Solaris [PR32580]
	As described in PR ld/32580, when using SHELL=/bin/sh or /bin/ksh on
	Solaris, the generated linker scripts get corrupted.  So far, the only
	workaround is to enforce /bin/bash instead.

	This is a major nuisance for developers and users alike, so this patch
	automates this by overriding SHELL in ld/configure.ac.

	Tested on amd64-pc-solaris2.11 in three configurations:

	* CONFIG_SHELL unset

	* CONFIG_SHELL=/bin/ksh

	* CONFIG_SHELL='/bin/bash --norc'

	In the first two cases, SHELL was set to /bin/bash as desired, while in
	the third it was left unchanged.

	2025-07-24  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

		ld:
		PR ld/32580
		* configure.ac <*-*-solaris2*>: Enforce SHELL=/bin/bash.
		* configure: Regenerate.

	(cherry picked from commit 96ad2fd3c0c0414110fe58ed4ee511f49768fa3d)

2025-07-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-24  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: sframe: fix PR gas/33170
	SFrame generation code assumes that since DW_CFA_restore means
	restoration of the state of the register to the one at the beginning of
	the function, there must be a state to restore to (hence the gas_assert
	(cie_fre)).

	This assumption needs adjustment.  DW_CFA_restore may be present in the
	very beginning of a (e.g., cold) function, with no initialized state for
	SFrame functions to restore to.

	gas/
		PR gas/33170
		* gas/gen-sframe.c (sframe_xlate_do_restore): Use current FRE if
		CIE FRE is not yet setup.
	gas/testsuite/
		PR gas/33170
		* gas/cfi-sframe/cfi-sframe.exp: New test.
		* gas/cfi-sframe/cfi-sframe-x86_64-pr33170.d: New test.
		* gas/cfi-sframe/cfi-sframe-x86_64-pr33170.s: New test.

	(cherry picked from commit 83eeaf917873a550656faf9a38cd14e0f4c521b1)

2025-07-24  H.J. Lu  <hjl.tools@gmail.com>

	strip: Properly handle LLVM IR bitcode
	commit 717a38e9a02109fcbcb18bb2ec3aa251e2ad0a0d
	Author: H.J. Lu <hjl.tools@gmail.com>
	Date:   Sun May 4 05:12:46 2025 +0800

	    strip: Add GCC LTO IR support

	added "-R .gnu.lto_.*" to strip to remove all GCC LTO sections.  When
	"-R .gnu.lto_.*" is used, the plugin target is ignored so that all LTO
	sections are stripped as the regular sections.  It works for the slim
	GCC LTO IR since the GCC LTO IR is stored in the regular sections.  When
	the plugin target is ignored, the GCC LTO IR can be recognized as the
	normal object files.  But it doesn't work for the slim LLVM IR which
	is stored in a standalone file.

	1. Add bfd_check_format_matches_lto and bfd_check_format_lto to take an
	argument, lto_sections_removed, to indicate if all LTO sections should
	be removed.
	2. Update strip to always enable the plugin target so that the plugin
	target is enabled when checking for bfd_archive.
	3. Update strip to ignore the plugin target for bfd_object when all LTO
	sections should be removed.  If the object is unknown, copy it as an
	unknown file without any messages.
	4. Treat the "-R .llvm.lto" strip option as removing all LTO sections.

	bfd/

		PR binutils/33198
		* format.c (bfd_check_format_lto): New function.
		(bfd_check_format): Call bfd_check_format_matches_lto.
		(bfd_check_format_matches): Renamed to ...
		(bfd_check_format_matches_lto): This.  Add an argument,
		lto_sections_removed, to indicate if all LTO sections should be
		removed and don't match the plugin target if lto_sections_removed
		is true.
		(bfd_check_format_matches): Call bfd_check_format_matches_lto.
		* bfd-in2.h: Regenerated.

	binutils/

		PR binutils/33198
		* objcopy.c (copy_archive): Call bfd_check_format_lto, instead
		of bfd_check_format, and pass lto_sections_removed.  Remove the
		non-fatal message on unknown element since it will be copied as
		an unknown file.
		(copy_file): Don't check lto_sections_removed when enabling LTO
		plugin in strip.
		(copy_file): Ignore the plugin target first if all LTO sections
		should be removed.  Try with the plugin target next if ignoring
		the plugin target failed to match the format.
		(strip_main): Also set lto_sections_removed for -R .llvm.lto.
		* testsuite/binutils-all/x86-64/pr33198.c: New file.
		* testsuite/binutils-all/x86-64/x86-64.exp (run_pr33198_test):
		New.
		Run binutils/33198 tests.
		* testsuite/lib/binutils-common.exp (llvm_plug_opt): New.
		(CLANG_FOR_TARGET): New.  Set to "clang" for native build if
		"clang -v" reports "clang version".

	(cherry picked from commit f752be8f916efa70aea9c2e4f664c75690fd136c)

2025-07-24  Alan Modra  <amodra@gmail.com>

	PR 33197 [AVR] Incorrect syntax in generated ldscript
	Rearrange scripttempl/avr.sc to avoid oddities of shells expanding
	${RELOCATING+stuff} in here documents where "stuff" contains quoted
	strings.  Also I think it is better to avoid multi-line "stuff" as it
	can be tricky to spot the ending brace.

	(cherry picked from commit ae114fb523efe908f9e807359e2f494ee64d2801)

2025-07-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-22  Nick Clifton  <nickc@redhat.com>

	Updated translations for various sub-directories

2025-07-22  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	ld: Rename a file on Windows fails if target already exists
	To rename a file on Windows, the target name cannot exist. Removing file
	prior to renaming ensures this is handled.
	To remove a file on Windows, the file cannot be open. Closing the bfd
	handle ensures this is handled.
	Moved call to free on isympp / osympp to after bfd is closed to align
	with comment earlier in the cmdline_add_object_only_section function.

	(cherry picked from commit 233cd5946413108bf4902b22a9cb23ad0a468f5e)

2025-07-21  Dmitrii Bordukov  <dabordukov@gmail.com>

	gprofng: do not skip weak symbols
	PR gprofng/33151

	gprofng ignores functions that are compiled as weak symbols. This
	heavily affects C++ class methods that are always compiled by g++
	and clang++ as weak symbols. In this case 'gprofng display text'
	just displays <static>@ADDRESS(<FILENAME>) instead of proper method
	name.

	The bug has been introduced in the commit 470a0288a818.

2025-07-18  Alan Modra  <amodra@gmail.com>

	Remove sframe relocs against discarded sections
	Commit d7f343eaad3f testsuite change resulted in a regression for
	s390x-linux.  This extends the x86_64 fix to other targets.

		PR ld/33156
		* elf-bfd.h (RELOC_AGAINST_DISCARDED_SECTION): Remove .sframe
		relocs too.

	(cherry picked from commit fcf7470408aa0508fbe99abb99547757a348383d)

2025-07-17  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: relax the assertion limit for fre_start_addr
	Fix PR ld/33131 Failed assertion when linking gccgo

	Make amendments in both sframe_decoder_get_fre and
	sframe_encoder_add_fre.

	Since GNU as and the dw2gencfi code generally accepts such CFI, its best
	to allow in SFrame FREs too.

	libsframe/
		PR ld/33131.
		* sframe.c (sframe_decoder_get_fre): Relax the assertion a bit.
		(sframe_encoder_add_fre): Likewise.

	(cherry picked from commit 387efef5fef727cbe52099dcd5012905c4205be3)

2025-07-16  Sam James  <sam@gentoo.org>

	gas: improve --gsframe documentation
	I omitted documentation in 8aad677a12832885acd5be1de8f41e740b8e713d in
	error. Rectify that with:
	1) changing ---help to mention bare `--gsframe` too, as we're not
	   getting rid of that;

	2) adding the new --gsframe=[no|yes] form to as.texi.

		PR gas/33125
		* gas/as.c (parse_args): Tweak --gsframe= help text.
		* gas/doc/as.texi: Document --gsframe=[no|yes].

	(cherry picked from commit 50c1c57426db6e1c7b44b4d05f0b07fcba91f890)

2025-07-16  H.J. Lu  <hjl.tools@gmail.com>

	gas: Re-indent case OPTION_SFRAME:
		PR gas/33125
		* gas/as.c (parse_args): Re-indent case OPTION_SFRAME:

	(cherry picked from commit 1535d2a0ce4e474f1a42e8b8720de01b7dc1f656)

2025-07-16  Sam James  <sam@gentoo.org>

	gas: support --gsframe=no
	Being able to explicitly disable SFrames on the command line is useful,
	especially when looking at a gas that enables SFrames by default. The
	binutils testsuite will benefit from this as there's testcases that don't
	expect their presence.

	In summary:
	* Nothing is passed       => no SFrames (no change from before)
	* --gsframe is passed     => SFrames    (no change from before)
	* --gsframe=yes is passed => SFrames    (previously rejected)
	* --gsframe-no  is passed => no SFrames (previously rejected)

		PR gas/33125
		* gas/as.c (parse_args): Accept --gsframe=no, --gsframe=yes.

	(cherry picked from commit 8aad677a12832885acd5be1de8f41e740b8e713d)

2025-07-16  H.J. Lu  <hjl.tools@gmail.com>

	x86-64: Remove sframe relocs against discarded sections
	Since unlike eh_frame editing code, sframe editing code keeps
	R_X86_64_NONE reloc as is, its r_offset is wrong, we must not
	generate R_X86_64_NONE reloc in sframe section against discarded
	sections for "ld -r".

	bfd/

		PR ld/33156
		* elf64-x86-64.c (elf_x86_64_relocate_section): Also remove
		sframe relocations against discarded sections for "ld -r".

	ld/

		PR ld/33156
		* testsuite/ld-elf/eh-group.exp (as_gsframe): New.
		Assemble eh-group.o with $as_gsframe.

	(cherry picked from commit d7f343eaad3f34c76657b9996e6253b4f9a218d5)

2025-07-16  H.J. Lu  <hjl.tools@gmail.com>

	sframe: Allow input R_*_NONE relocations
	"ld -r" generates R_*_NONE relocations in sframe section if input
	relocations in sframe section are against discarded section.  Allow
	input R_*_NONE relocations if there are more relocation entries than
	SFrame entries, instead of assuming number of SFrame entries == number
	of relocation entries.

	bfd/

		PR ld/33127
		* elf-sframe.c (sframe_decoder_init_func_bfdinfo): Allow input
		R_*_NONE relocations if there are more relocation entries than
		SFrame entries.

	ld/

		PR ld/33127
		* testsuite/ld-x86-64/sframe-reloc-2a.s: New file.
		* testsuite/ld-x86-64/sframe-reloc-2b.s: Likewise.
		* testsuite/ld-x86-64/x86-64.exp: Run PR ld/33127 tests.

	(cherry picked from commit 5f9bf0cf711a153a0a20d6ff88181e9a6775bdba)

2025-07-16  H.J. Lu  <hjl.tools@gmail.com>

	ld: Clear map_head_is_link_order for .gnu_object_only
	Clear map_head_is_link_order when generating .gnu_object_only section so
	that lang_add_section can add new sections and .sframe sections will be
	properly merged by _bfd_elf_merge_section_sframe.

		PR ld/33146
		* ldlang.c (cmdline_emit_object_only_section): Clear
		map_head_is_link_order.
		* testsuite/ld-plugin/lto.exp (as_gsframe): New.
		(lto_link_tests): Add $as_gsframe to compile lto-4b.o and
		lto-4c.o.

	(cherry picked from commit 939eb467b21de5d18ee703755fb9704a525cfe21)

2025-07-16  Alan Modra  <amodra@gmail.com>

	Re: gas: Move gas_sframe_check to binutils-common.exp
	PR ld/33146

	Correct TCL errors trying to access error output file in commit
	ef7a634dc01d.  In fact, get rid of the output file test entirely since
	gas exit status is sufficient.

	Also there is no need to firstly check for ELF support.

	Set check_as_sframe_result, and remove ld-lib.exp check_as_sframe.

	(cherry picked from commit a57a3a169ea9ec79977949c9c8dccd3a2a615fae)

2025-07-16  H.J. Lu  <hjl.tools@gmail.com>

	gas: Move gas_sframe_check to binutils-common.exp
	Move gas_sframe_check to binutils-common.exp so that it can be used in
	linker tests to check if a target assembler supports --gsframe.

	binutils/

		PR ld/33146
		* testsuite/lib/binutils-common.exp (gas_sframe_check): Moved
		from cfi-sframe.exp.  Replace gas_host_run with remote_exec.

	gas/

		PR ld/33146
		* testsuite/gas/cfi-sframe/cfi-sframe.exp (gas_sframe_check):
		Moved to binutils-common.exp.

	(cherry picked from commit ef7a634dc01df3d78f208c93316b52937d3fe8f4)

2025-07-15  Alan Modra  <amodra@gmail.com>

	s390x sframe regressions
	Commit 6ab3f09a682a resulted in regressions.
	s390x-linux-gnu  FAIL: SFrame simple link
	s390x-linux-gnu  FAIL: SFrame for plt0 and pltN

	Commit 939eb467b21d exposed the problem further.
	s390x-linux-gnu  FAIL: LTO 4a
	s390x-linux-gnu  FAIL: LTO 4c
	s390x-linux-gnu  FAIL: LTO 4d

		* elf64-s390.c (elf_s390_create_dynamic_sections): Set plt_sframe
		ELF section type.

	Reviewed-by: Jens Remus <jremus@linux.ibm.com>
	(cherry picked from commit 168c017e206894effdefa919bff29880165fae13)

2025-07-15  Nick Clifton  <nickc@redhat.com>

	Updated translations for various sub-directories

2025-07-15  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	Only parse attributes in ELF sections with the SHT_GNU_ATTRIBUTES type if the OS is not Solaris.  Set the is_solaris flag for Sparc solaris architectures
	PR 33153

2025-07-14  Nick Clifton  <nickc@redhat.com>

	Updated Ukranian translation for the opcodes sub-directory

	Updated Ukranian translation for the binutils sub-directory

	Updated Spanish translation for the gas sub-directory

2025-07-14  Nelson Chu  <nelson@rivosinc.com>

	gas/NEWS: Corrected the information about mapping symbol $x for risc-v

2025-07-14  Aaron Griffith  <aargri@gmail.com>

	gas: accept leading zeros on dollar local labels in z80 sdcc compat mode
	SDCC assembly output uses 5-digit numeric dollar sign labels, padded
	with zeros. Commit 226749d made these invalid, and broke the Z80 SDCC
	compatibility mode in GAS.

	https://sourceware.org/git/?p=binutils-gdb.git;a=commit;h=226749d5a6ff0d5c607d6428d6c81e1e7e7a994b

	This restores SDCC compatibility by replacing the leading zeros with
	spaces when inside dollar local labels and when SDCC compatibility is
	enabled. It also restores the SDCC test case to represent actual
	syntax emitted by SDCC, and adds a note explaining the purpose of
	the test.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33030

2025-07-13  Nick Clifton  <nickc@redhat.com>

	Fix compile time warning message about optarg parameter shadowing global variable

	Update version number on 2.45 branch

	Add markers for 2.45 branch

2025-07-13  Tom de Vries  <tdevries@suse.de>

	[gdb/build] Work around GCC ipa-modref bug
	PR mi/32571 reports the following problem:
	...
	$ gdb -q -batch -ex "b bla.c:100"
	<random output>
	Make breakpoint pending on future shared library load? (y or [n]) \
	  [answered N; input not from terminal]
	...
	while this is expected:
	...
	$ gdb -q -batch -ex "b bla.c:100"
	No symbol table is loaded.  Use the "file" command.
	Make breakpoint pending on future shared library load? (y or [n]) \
	  [answered N; input not from terminal]
	...

	A few factors in reproducing this are building gdb using gcc 14,
	"-O2 -flto=auto" and --disable-nls.  For more details, see the PR.

	This turns out to be caused by a GCC PR [1], more specifically a problem in
	ipa-modref.

	Work around this by disabling ipa-modref for GCC versions 12-15 and 16.0,
	assuming the GCC 16.1 release will contain a fix.

	Tested on aarch64-linux and x86_64-linux.

	Approved-By: Andrew Burgess <aburgess@redhat.com>

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=32571

	[1] https://gcc.gnu.org/bugzilla/show_bug.cgi?id=120987

2025-07-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-12  Aaron Griffith  <aargri@gmail.com>

	gdb: add Aaron Griffith to gdb/MAINTAINERS

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	ld/aarch64elf: add support for DT_AARCH64_MEMTAG_STACK dynamic tag
	Add new command line option -z memtag-stack for aarch64 elf.  This
	option instructs the linker to generate the necessary dynamic tag
	DT_AARCH64_MEMTAG_STACK, which the dynamic loader can then use to
	protect the stack memory with PROT_MTE.  Linker issues an
	'unrecognized option' error when -z memtag-stack is specified for
	non-aarch64 based emulations.

	readelf displays the dynamic tag when present:

	$ readelf -d <exectutable>
	Dynamic section at offset 0xfdd8 contains XX entries:
	Tag        Type                         Name/Value
	0x0000000000000001 (NEEDED)             Shared library: [libc.so.6]
	0x000000000000000c (INIT)               0x400520
	0x000000000000000d (FINI)               0x400b64
	0x0000000000000019 (INIT_ARRAY)         0x41fdc8
	...                 ...                 ...
	0x000000007000000c (AARCH64_MEMTAG_STACK) 0x1
	...                 ...                 ...

	ChangeLog:

	        * bfd/elfnn-aarch64.c (elfNN_aarch64_late_size_sections): Emit
		DT_AARCH64_MEMTAG_STACK dynamic tag.
	        * bfd/elfxx-aarch64.h (struct aarch64_memtag_opts): Add new
		member for tracking whether stack access uses MTE insns.
	        * binutils/readelf.c (get_aarch64_dynamic_type): Handle
		DT_AARCH64_MEMTAG_STACK.
	        * ld/emultempl/aarch64elf.em: Add new command line option.
	        * ld/ld.texi: Add documentation for -z memtag-stack.
	        * ld/testsuite/ld-aarch64/aarch64-elf.exp: Add new test.
	        * ld/testsuite/ld-aarch64/dt-memtag-stack.d: New test.

	include/ChangeLog:

	        * elf/aarch64.h (DT_AARCH64_MEMTAG_STACK): New definition.

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	ld/aarch64elf: add support for DT_AARCH64_MEMTAG_MODE dynamic tag
	Add new command line option -z memtag-mode=<mode> to aarch64 elf,
	where <mode> can be one of none, sync, or async.  For mode of sync or
	async, a DT_AARCH64_MEMTAG_MODE dynamic tag with a value of 0 or 1
	respectively is emitted.

	readelf displays the dynamic tag when present:

	$ readelf -d <exectutable>
	Dynamic section at offset 0xfdd8 contains XX entries:
	  Tag        Type                         Name/Value
	 0x0000000000000001 (NEEDED)             Shared library: [libc.so.6]
	 0x000000000000000c (INIT)               0x400520
	 0x000000000000000d (FINI)               0x400b64
	 0x0000000000000019 (INIT_ARRAY)         0x41fdc8
	 ...                 ...                 ...
	 0x0000000070000009 (AARCH64_MEMTAG_MODE) 0x1
	 ...                 ...                 ...

	Note that this patch doesn't add support for the "asymm" MTE mode,
	which is an Armv8.7 extension.

	ChangeLog:

	        * bfd/elfnn-aarch64.c (struct elf_aarch64_link_hash_table): Add
		new member for memtag properties.
	        (bfd_elfNN_aarch64_set_options): New argument to pass memtag
		properties.
		(elfNN_aarch64_late_size_sections): Emit DT_AARCH64_MEMTAG_MODE
		dynamic tag.
	        * bfd/elfxx-aarch64.h: New definition for the various memtag
		properties.
	        * binutils/readelf.c (get_aarch64_dynamic_type): Handle
		DT_AARCH64_MEMTAG_MODE.
	        * ld/emultempl/aarch64elf.em: Likewise.
	        * ld/ld.texi: Add documentation for the new option
		-z memtag-mode.
	        * ld/testsuite/ld-aarch64/aarch64-elf.exp: New test.
	        * ld/testsuite/ld-aarch64/dt-memtag.d: New test.
	        * ld/testsuite/ld-aarch64/dt-memtag-mode.s: New test.

	include/ChangeLog:

	        * elf/aarch64.h (DT_AARCH64_MEMTAG_MODE): New definition.

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	ld: aarch64: make EH Frame parsing aware of augmentation char 'G'
	As per the DWARF for the Arm 64-bit Architecture (AArch64)
	specification, the augmentation char 'G' indicates that associated
	frames may modify MTE tags on the stack space they use.

	Add knowledge of the 'G' augmentation char to the EH Frame parsing
	code.

	ChangeLog:

	        * bfd/elf-eh-frame.c (_bfd_elf_parse_eh_frame): Accommodate
		augmentation char 'G'.
	        * ld/testsuite/ld-aarch64/aarch64-elf.exp: New test.
	        * ld/testsuite/ld-aarch64/mte-tagged-frame-bar.s: New test.
	        * ld/testsuite/ld-aarch64/mte-tagged-frame-foo.s: New test.
	        * ld/testsuite/ld-aarch64/mte-tagged-frame.d: New test.

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: aarch64: suppport CFI directive .cfi_mte_tagged_frame
	Process a new aarch64-specific CFI directive: .cfi_mte_tagged_frame
	(LLVM uses this CFI directive already).  The CFI directive, when
	present for a function, indicates that the stack frame for the
	function may modify the MTE tags of the stack space it uses.  The
	assembler emits char 'G' in the CIE augmentation string to indicate
	the same.

	ChangeLog:

	        * gas/config/tc-aarch64.c (s_aarch64_mte_tagged_frame): New
		definition.
	        * gas/config/tc-aarch64.h (tc_fde_entry_extras): Add
		memtag_frame_p.
	        (tc_cie_entry_extras): Likewise.
	        (tc_fde_entry_init_extra): Likewise.
	        (tc_cie_fde_equivalent_extra): Likewise.
	        (tc_cie_entry_init_extra): Likewise.
	        * gas/doc/c-aarch64.texi: Add documentation for
		.cfi_mte_tagged_frame directive.
	        * gas/testsuite/gas/aarch64/mte_tagged_stack.d: New test.
	        * gas/testsuite/gas/aarch64/mte_tagged_stack.s: New test.

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	binutils: make read_cie aware of new augmentation char 'G'
	This allows objdump/readelf to dump DWARF/EH Frame info when the stack
	frame makes use of MTE tagging.

	ChangeLog:

	        * binutils/dwarf.c (is_aarch64_augmentation): Add handling for augmentation
		char 'G'.

	---
	[No change in V3]

2025-07-12  Jose E. Marchesi  <jose.marchesi@oracle.com>

	bfd: fix recognition of arch-specific augmentations
	This patch fixes _bfd_elf_parse_eh_frame so it will not recognize
	machine/architecture specific augmentation characters in EH Frame
	CFIs.

	Regtested in x86_64-linux-gnu and aarch64-linux-gnu.

	bfd/ChangeLog:

		* elf-eh-frame.c (_bfd_elf_parse_eh_frame): Recognize augmentation
		'B' only if targetting aarch64.

2025-07-12  Jose E. Marchesi  <jose.marchesi@oracle.com>

	binutils: factorize handling of arch-specific DWARF augmentations
	This patch factorizes the handling of architecture/machine specific
	augmentation characters in CIEs.

	Based on an idea proposed by Richard Earnshaw.

	binutils/ChangeLog:

		* dwarf.c (is_mach_augmentation_ftype): New type.
		(is_mach_augmentation): New variable.
		(is_nomach_augmentation): New function.
		(is_aarch64_augmentation): Likewise.
		(init_dwarf_by_elf_machine_code): Set is_mach_augmentation as
		appropriate.
		(init_dwarf_by_bfd_arch_and_mach): Likewise.
		(read_cie): Handle architecture-specific augmentation characters
		in a generic way.

2025-07-12  Jose E. Marchesi  <jose.marchesi@oracle.com>

	binutils: generalize init_dwarf_regnames_by_* functions
	This patch renames the functions:

	  init_dwarf_regnames_by_elf_machine_code
	  init_dwarf_regnames_by_bfd_arch_and_mach

	to

	  init_dwarf_by_elf_machine_code
	  init_dwarf_by_bfd_arch_and_mach

	The idea is to start using these functions to perform general
	architecture/machine specific initializations beyond register names.

	Regtested in x86_64-linux-gnu and aarch64-linux-gnu targets.

	binutils/ChangeLog:

		* dwarf.c (init_dwarf_regnames_by_elf_machine_code): Rename to
		init_dwarf_by_elf_machine_code.
		(init_dwarf_regnames_by_bfd_arch_and_mach): Rename to
		init_dwarf_by_bfd_arch_and_mach.
		* dwarf.h: Adjust prototypes accordingly.
		* readelf.c (process_file_header): Adjust call to
		init_dwarf_regnames_by_elf_machine_code accordingly.
		* objdump.c (dump_dwarf): Adjust call to
		init_dwarf_regnames_by_bfd_arch_and_mach accordingly.

2025-07-12  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Add support for --march=armv9.6-a

2025-07-12  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Disable sysreg guards by default
	Add a new flag -menable-sysreg-checking to restore previous behaviour.
	This existing behaviour is quite inconsistent, so the gating will
	probably be updated in the future.  (In particular, many system
	registers are currently gated with the architecture version they were
	released with instead of the lower architecture version that they
	actually require).

	This patch retains the +d128 requirement for msrr/mrrs.

	Co-Authored-By: Srinath Parvathaneni <srinath.parvathaneni@arm.com>

2025-07-12  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Add missing F_STRICT flags
	By default, NIL qualifiers are treated as matching any qualifier when
	checking operand constraints.  For many SVE instructions, this would
	allow operands with missing type suffixes to be assembled as if they had
	any explicit type specified.  To prevent this, the F_STRICT flag is used
	to specify that NIL qualifiers should match only NIL qualifiers.

	Unfortunately, several SVE instructions incorrectly omitted this
	F_STRICT flag.  The bug has existed in the *MATMUL_SVE* macros since
	they were added in 2019.  The macro LUT_SVE2_INSN was added last year,
	and the other incorrect macros are new in this release.

	LUTv2_SME2_INSN and LUTv2_SME2p1_INSN were not actually broken, because
	we reject untyped vector lists already during parsing.  However, I have
	added the F_STRICT flag here anyway, since this is more consistent and
	would be more robust if those operands start accepting untyped vector
	lists in the future.  The new luti4 tests are the only ones that were
	already rejected before this change.

	BFLOAT16_SVE_INSN has been unused since it was originally added, so I
	just deleted the macro.

	The SVE LUT instructions were using the lut instruction class, which
	has special handling only for SIMD operands, and isn't recognised by
	aarch64_decode_variant_using_iclass (which sets the qualifiers during
	decode for most SVE instructions).  To prevent these instructions
	failing to disassemble, I changed their instruction class to sve_misc.

2025-07-12  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Remove redundant feature requirements
	Many instructions explicitly specified SVE/SVE2/SME/SME2 as a required
	feature when it was already implied by another required feature (at
	least while the SME->SVE2 implication is retained internally).  These
	redundant features were used to determine both the valid symbol names
	for immediate operands, and the choice of error message for invalid
	movprfx sequences.  Those two scenarios no longer use architecture
	features, so the redundant features are now truly redundant.

2025-07-12  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Use operand class to select movprfx error
	Previously the choice of error message for an invalid movprfx sequence
	used the architecture requirements to determine whether an instruction
	was an SVE instruction or not.  This meant specifying SVE or SVE2 as an
	explicit architecture requirement for all SVE instructions, even when
	this was already implied by another feature.  As more architecture
	features are added and with the partial removal of the SME->SVE2
	dependency, these extra feature requirements were getting messier and
	easier to forget.

	Instead, we now look at the operand types.  If there is an SVE_REG,
	SVE_REGLIST or PRED_REG operand, then we treat the instruction as an SVE
	instruction.  This does change behaviour slightly, but it only affects
	the choice of error message and the new choice should be a bit more
	consistent.

	There is one testsuite update required, because Ezra's SVE_AES2 patch
	temporarily broke classification of FEAT_SVE_AES instructions.  This
	patch restores the original behaviour.

2025-07-12  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Refactor exclusion of reg names in immediates
	When parsing immediate values, register names should not be
	misinterpreted as symbols.  However, for backwards compatibility we need
	to permit some newer register names within older instructions.  The
	current mechanism for doing so depends on the list of explicit
	architecture requirements for the instructions, which is fragile and
	easy to forget, and grows increasingly messy as more architecture
	features are added.

	This patch add explicit flags to each opcode to indicate which set of
	register names is disallowed in each instance.  These flags are
	mandatory for all opcodes with immediate operands, which ensures that
	the choice of disallowed names will always be deliberate and explicit.

	This patch should have no functional change.

2025-07-12  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Remove redundant ORs with 0

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: bump version to 2.0
	Remove LIBSFRAME_1.1, LIBSFRAME_1.0 nodes and add a new LIBSFRAME_2.0
	node (non-inheritance version) to create new global versioned symbols.
	Also announce libsframe.so.2 in NEWS.

	New APIs:
	     sframe_decoder_get_flags;
	     sframe_decoder_get_offsetof_fde_start_addr;
	     sframe_encoder_get_flags;
	     sframe_encoder_get_offsetof_fde_start_addr;

	Removed APIs: (already deprecated since X-2 release)
	     sframe_get_funcdesc_with_addr;

	APIs with changed semantics:
	     sframe_decoder_get_funcdesc_v2;
	     sframe_encoder_add_funcdesc_v2;
	     sframe_encoder_write;

	lisbframe/
		* libsframe.ver: Define new LIBSFRAME_2.0.
		* libtool-version: Bump the 'current' numeral to indicate a binary
		incompatible release.
	include/
		* sframe-api.h (sframe_get_funcdesc_with_addr): Remove
		deprecated interface.
	libsframe/
		* sframe.c (sframe_get_funcdesc_with_addr): Likewise.
	binutils/
		* NEWS: Announce new versioned release of libsframe.

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: fixup comment and minor style issues
	Also, use ATTRIBUTE_UNUSED consistently.

	libsframe/
		* sframe.c (sframe_encoder_add_funcdesc): Fix function-level
		comment and use ATTRIBUTE_UNUSED consistently.
		(sframe_encoder_add_funcdesc_v2): Use ATTRIBUTE_UNUSED
		consistently.

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: elf: binutils: add new section type SHT_GNU_SFRAME
	So far, SFrame sections were of type SHT_PROGBITS.

	As per ELF specification, SHT_PROGBITS indicates that the section holds
	information defined by the program, whose format and meaning are
	determined solely by the program.

	On the linker side, SHT_PROGBITS should be reserved for the simple "cat
	contents after applying relocs" semantics.

	Currently, the only way to know that a section contains SFrame stack
	trace data is if consumer checks for section name.  Such a check for
	section name is not quite conformant to ELF principles.

	Some of this was discussed here
	https://sourceware.org/pipermail/binutils/2025-March/140181.html

	With this change, the SFrame sections generated by gas, ld will have
	section type set to SHT_GNU_SFRAME.   The new section type is defined in
	the SHT_LOOS/SHT_HIOS space.  The SFrame parsing routine
	_bfd_elf_parse_sframe () now admits sections only when the the section
	type is SHT_GNU_SFRAME.

	No special handling / validation is done at the moment for the case of
	manual creation of SFrame sections via obj_elf_section ().  Add function
	level comments for now to add a note about this.

	Although the default handling for (sh_type >= SHT_LOOS && sh_type <=
	SHT_HIOS) is sufficient when SHT_GNU_SFRAME is in that range, it makes
	sense to add it as a case of its own.

	bfd/
		* elf-sframe.c (_bfd_elf_parse_sframe): Check if section type is
		SHT_GNU_SFRAME.
		(_bfd_elf_set_section_sframe): Set SHT_GNU_SFRAME for output
		SFrame section.
		* elflink.c (obj_elf_section): Use section type for check
		instead of section name.
		* elfxx-x86.c: Set SHT_GNU_SFRAME for SFrame sections for
		.plt* sections.
		* elf.c (bfd_section_from_shdr): Add case for SHT_GNU_SFRAME.
	binutils/
		* readelf.c (get_os_specific_section_type_name): Add
		SHT_GNU_SFRAME.
	gas/
		* NEWS: Announce emitted SFrame sections have SHT_GNU_SFRAME
		set.
		* config/obj-elf.c (obj_elf_attach_to_group): Add comments to
		indicate no special handling for SFrame yet.
		* dw2gencfi.c (cfi_finish): Set SHT_GNU_SFRAME for emitted
		SFrame section.
	ld/
		* NEWS: Announce emitted SFrame sections have SHT_GNU_SFRAME
		set.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe.exp: Add new test.
		* gas/cfi-sframe/cfi-sframe-common-1b.d: New test.
		* gas/cfi-sframe/cfi-sframe-common-1b.s: New test.
	include/
		* elf/common.h (SHT_GNU_SFRAME): Add new section type for SFrame
		stack trace information.
	libsframe/doc/
		* sframe-spec.texi: Add expected ELF section type.

2025-07-12  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: sframe: guard block with support_sframe_p
	SFrame is generated for ELF targets only.  Guard the block with
	support_sframe_p like others for consistency.

	Also, in a later commit, we would like to do a:
	  elf_section_type (sframe_seg) = SHT_GNU_SFRAME;

	This cannot be done for non-ELF targets, hence the need to guard with
	some pre-processor conditional to enable it for only OBJ_ELF.  Guarding
	with support_sframe_p works for now, because those targets that support
	SFrame define support_sframe_p:
	  - x86_64 and aarch64 define support_sframe_p when OBJ_ELF is defined
	  - s390x has no non-LEF target.

	We continue to issue an error on targets where SFrame is not supported:
	    .sframe not supported for target

	gas/
		* dw2gencfi.c (cfi_finish): Guard with support_sframe_p.
		(support_sframe_p): Remove stub to define to false for backends
		not supporting SFrame.

2025-07-12  WANG Xuerui  <git@xen0n.name>

	{binutils, gas, ld}/NEWS: Announce LoongArch changes in 2.45

2025-07-12  WANG Xuerui  <git@xen0n.name>

	LoongArch: Un-skip cross-segment alignment compensation during relax pass 2
	It turned out wrong to skip compensating for segment alignment if the
	current section is closed for deletion, as my recent system update with
	binutils trunk revealed link failures of many high-profile packages such
	as ffmpeg, numpy and wxGTK -- the dreaded "relocation truncated to fit"
	errors regarding improperly produced R_LARCH_PCREL20_S2.

	As it's near 2.45 branching time, revert the problematic change and
	XFAIL the original test case for now.

	Suggested-by: Xi Ruoyao <xry111@xry111.site>

2025-07-12  Alan Modra  <amodra@gmail.com>

	MIPS: Fix linker for REL TLS HI16/LO16 relocs
	With REL targets TLS HI16/LO16 relocations need to combine the low part
	with the high part just as all the remaining HI16/LO16 relocations, so
	as to determine the borrow in calculation correctly.

	2025-07-12  Alan Modra  <amodra@gmail.com>

	bfd/
		PR 19977
		* elfxx-mips.c (tls_hi16_reloc_p): New function.
		(mips_elf_add_lo16_rel_addend): Handle tls relocs.
		(_bfd_mips_elf_relocate_section): Likewise.

	2025-07-12  Maciej W. Rozycki  <macro@orcam.me.uk>

	ld/
		PR 19977
		* testsuite/ld-mips-elf/pr19977.d: New test.
		* testsuite/ld-mips-elf/pr19977-mips16.d: New test.
		* testsuite/ld-mips-elf/pr19977-micromips.d: New test.
		* testsuite/ld-mips-elf/pr19977-r.d: New test.
		* testsuite/ld-mips-elf/pr19977-r-mips16.d: New test.
		* testsuite/ld-mips-elf/pr19977-r-micromips.d: New test.
		* testsuite/ld-mips-elf/pr19977-r.s: New test source.
		* testsuite/ld-mips-elf/pr19977.ld: New test linker script.
		* testsuite/ld-mips-elf/mips-elf.exp: Run the new tests.

2025-07-12  Alan Modra  <amodra@gmail.com>

	MIPS: Correct HI/LO rel reloc howto special_function entries
	This corrects the DTPREL_HI16/LO16 and TPREL_HI16/LO16 howtos to use
	_bfd_mips_elf_{hi,lo}16_reloc special functions, in order to support
	addends outside the range [0,32767] on these relocations.

	R_MIPS_GOT_HI16, R_MIPS_GOT_LO16, R_MIPS_CALL_HI16 and R_MIPS_CALL_LO16
	are left alone as it seems that we (quite reasonably) only support
	zero addends for those relocs.

		PR 19977
	bfd/
		* elf32-mips.c (elf_mips_howto_table_rel): Set special_function
		to _bfd_mips_elf_hi16_reloc for R_MIPS_TLS_DTPREL_HI16 and
		R_MIPS_TLS_TPREL_HI16.  Set special_function to
		_bfd_mips_elf_lo16_reloc for R_MIPS_TLS_DTPREL_LO16 and
		R_MIPS_TLS_TPREL_LO16
		(elf_mips16_howto_table_rel): Likewise for
		R_MIPS16_TLS_DTPREL_HI16, R_MIPS16_TLS_DTPREL_LO16,
		R_MIPS16_TLS_TPREL_HI16 and R_MIPS16_TLS_TPREL_LO16.
		(elf_micromips_howto_table_rel): Likewise for
		R_MICROMIPS_TLS_DTPREL_HI16, R_MICROMIPS_TLS_DTPREL_LO16,
		R_MICROMIPS_TLS_TPREL_HI16 and R_MICROMIPS_TLS_TPREL_LO16.
		* elf64-mips.c (mips_elf64_howto_table_rel): Similarly.
		(mips16_elf64_howto_table_rel): Similarly.
		(micromips_elf64_howto_table_rel): Similarly.
		* elfn32-mips.c: As for elf64-mips.c.
	gas/
		* testsuite/gas/mips/pr19977.d,
		* testsuite/gas/mips/pr19977.s: New test.
		* testsuite/gas/mips/mips.exp: Run it.

2025-07-12  Maciej W. Rozycki  <macro@orcam.me.uk>

	PR 19977: MIPS: Add missing pairing for REL PCHI/PCLO relocations
	Just as with all HI/LO 16-bit partial relocations the newly-introduced
	MIPSr6 PC-relative R_MIPS_PCHI16 and R_MIPS_PCLO16 relocations require
	pairing for correct borrow propagation from the low part to the high
	part with REL targets, another case for PR 19977.

	Unlike with absolute relocation, there is a complication here in that
	both parts represent a calculation that is relative to the PC at the
	individual relocation's location rather than both referring to the
	location of the R_MIPS_PCHI16 relocation, normally applied to an AUIPC
	instruction, the location of which is used for the run-time calculation
	executed by hardware.

	To take this semantics into account, the addend of the R_MIPS_PCLO16
	relocation matching a given R_MIPS_PCHI16 relocation is expected to be
	adjusted in the source assembly file for the distance between the two
	relocations in a single pair, so that once both relocations have been
	calculated by the linker, the expression calculated at run time is such
	as if the combined 32-bit immediate was added at the location of the
	AUIPC instruction.

	So for matching R_MIPS_PCHI16 and R_MIPS_PCLO16 relocations into pairs
	GAS needs to check for the distance between the two relocations to be
	equal to the difference between the addends supplied, and then the
	linker has to subtract the low part of the distance between the two
	relocations from the low part in calculating the high part, so as to
	factor in any borrow.

	A further complication is that `_bfd_mips_elf_lo16_reloc' handler is
	supplied with the addend differently depending on whether it has been
	called by GAS via `bfd_install_relocation', or by the generic linker via
	`bfd_perform_relocation'.  In the former case the addend is supplied
	with the relocation itself while in the latter one it comes from the
	field being relocated.

	We currently ignore the addend supplied with the relocation and it works
	for calculating absolute high-part relocations, because the same addend
	has been previously supplied with them when `_bfd_mips_elf_hi16_reloc'
	was called, however this approach does not work for the PC-relative case
	because as noted above the low-part addend is different and we need to
	consistently apply the distance adjustment both with GAS and LD.

	Since the supplied addend and one retrieved from field being relocated
	won't ever be both nonzero, just use the sum of the two values.

	The low-part addend in `mips_elf_add_lo16_rel_addend' always comes from
	the field being relocated, so there's no complication there, we just
	need to apply the same adjustment.

	New linker test cases verify that the same ultimate machine code is
	produced both for ELF and S-record output formats, ensuring that the
	both the MIPS/ELF linker and the generic linker behave in the correct
	way, consistent with each other.

2025-07-12  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/BFD: Use helper function for LO relocation sign-extension
	A calculation for LO relocations has been recently fixed with commit
	ce08b3bb19b3 ("MIPS/BFD: Fix RELA handling of borrow in the generic
	linker"), however it was missed that for the updated arithmetic we
	already have a helper function available, `_bfd_mips_elf_sign_extend'.

	Replace the open-coded statement then with an equivalent call to said
	function.  No functional change.

2025-07-12  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Remove duplicate HI/LO relocation test dump files
	There are only nonessential differences between corresponding o32 and
	n32 HI/LO relocation test dump files, so reduce the number of files by
	reusing the same dump between the two ABIs.  Adjust test naming, also
	for the n64 ABI, for consistency with other tests.

2025-07-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-11  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: testsuite: fix PR libsframe/33140
	Commit 0d4d5a2633f missed some necessary adjustments to the testcase
	after rebase.  SFrame FDE function start address data is now an offset
	in PCREL encoding; reflect with a new flag SFRAME_F_FDE_START_ADDR_PCREL
	in the header.

	Adjust the newly added testcase.

	PR libsframe/33140 SFrame test failures on x86-64

	libsframe/testsuite/
		* libsframe.find/plt-findfre-2.c: Adjust for the new FDE func
		start addr encoding.

2025-07-11  Simon Marchi  <simon.marchi@efficios.com>

	gdb: remove two unused includes of gdbcore.h
	clangd claims they are unused.

	Change-Id: I3c5e16279ff3b59679b8262a9d24a6e515a718f5

2025-07-11  Simon Marchi  <simon.marchi@efficios.com>

	gdb: fix formatting in solib.c
	There are many instances of `_ (...)` that should be `_(...)`, fix them.

	Change-Id: I9715019c9b62b72208b4849f3cfd531964480dd2

2025-07-11  Simon Marchi  <simon.marchi@efficios.com>

	gdb/solib-svr4: use program space from solib in find_debug_base_for_solib
	Instead of using the current global program space, I think it makes
	sense to fetch the program space from the solib.  The comment for
	solib::objfile indicates that it may be nullptr (which is true), but in
	this case, the callers (all in
	svr4_iterate_over_objfiles_in_search_order) find the solib from an
	objfile, so we know that solib::objfile (the link in the opposite
	direction) is set for these solibs at this point.

	Change-Id: I75037d0b2c39ab1b3a3792432be134e200438efe
	Approved-by: Kevin Buettner <kevinb@redhat.com>

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: Add support for more vmov-style instructions
	This commit adds support for a few more vmov instructions:
	* VMOV[LH|HL]PS
	* VMOVLPD
	* VMOVHP[S|D]
	* VMOVDDUP

	And associated tests. The testsuite had some minor re-working, adding a
	function to zero buffers, to make later tests less fragile.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support for AVX conversion instructions.
	WIP

	This commit adds support for instructions to convert from one type to
	another, which are in the form:
	* VCVTDQ2[PS|PD]
	* VCVTPS2[DQ|PD]
	* VCVTPD2[PS|DQ]
	* VCVTSD2[SI|SS]
	* VCVTSI2[SS|SD]
	* VCVTSS2[SD|SI]
	* VCVTTP[S|D]2DQ
	* VCVTTS[S|D]2SI

	It also adds support to vpsadbw, since it was trivial and only one
	instruction. Finally, I have slightly reorder the case statements to
	keep them in numerical order.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support for 'pack' AVX instructions
	This commit adds support for the following instructions VPACK[S|U]S[WB|DW] and associated tests.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support for comis instructions
	This commit adds support for the following instructions:
	* VCOMIS[S|D]
	* VUCOMIS[S|D]

	And associanted tests.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support for AVX blend instructions
	This commit supports for the following instructions:
	* VBLENDP[S|D]
	* VBLENDVP[S|D]
	* VPBLEND[D|W|VB]

	and test them.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support to vinsert and vextract instructions
	This patch adds support for the following instructions:
	* VEXTRACT[F128|I128|PS]
	* VINSERT[F128|I128|PS]
	* VPEXTR[B|W|D|Q]

	And associated test. For some reason, it seems that the extract
	instructions deal with the output register as though it was the first
	source register, so they use ModRM.r/m and VEX.B, instead of the usual
	ModRM.reg and VEX.R. This meant that the opcode collision with
	vbroadcastsd wasn't trivial. It can be easily solved by checking the
	VEX.map_select field, so soslving it was very easy.

	The VPEXTR instructions had several complicated collisions, and notably,
	vpextrw to a register works completely different to any other
	instruction in the family, so the code is messy, but it should be
	correct.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support for more AVX broadcast instructions
	This commit adds support for 3 instructions:
	* VBROADCASTSS
	* VBROADCASTSD
	* VBROADCASTF128

	and extends the function vpbroadcast_test to include these.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support for permutation instructions
	This commit adds recording support for the following instructions:
	* VPERM2[I|F]128
	* VPERM[D|Q|PD|PS]
	* VPERMILP[S|D]

	And associated tests.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: add support for AVX/AVX2 shuffle instructions
	This commit adds support for the following instructions:
	* VPSHUF[B|D|HW|LW]
	* VSHUFP[S|D]

	and the associated test.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: Add support for AVX/AVX2 shift instructions
	This commit adds record-full support to the following instructions:

	* VPSLL[W|D|Q|DQ]
	* VPSRL[W|D|Q|DQ]
	* VPSRA[W|D]

	With both dynamic and constant shifts, and the associated tests.
	Notably, vpsraq is not available for AVX or AVX2 instruction sets, only
	AVX512. vpsradq does not seem to be available with any instruction set.

2025-07-11  Guinevere Larsen  <guinevere@redhat.com>

	gdb/record: support more AVX arithmetic instructions
	This commit adds support to the following AVX/AVX2 instructions:
	* VPADD[B|W|D|Q]
	* VPMUL[LW|LD|HW|HUW|UDQ]
	* VXORP[S|D]
	* VPAND[|N]

	This required some reworking on the loop that processes instruction
	prefixes, because the opcode for VPMULLD overlapped with a valid
	instruction prefix. To fix that, rather than using "goto out_prefixes",
	this commit changes the infinite loop to only run while we don't find
	another VEX prefix. That should be OK, as the intel manual (page 526 on
	the March 2024 edition) says that the VEX prefix is always the last one.

2025-07-11  Ezra Sitorus  <ezra.sitorus@arm.com>

	aarch64: Support for FEAT_SVE_AES2
	FEAT_SVE_AES2 implements the SVE multi-vector Advanced Encryption
	Standard and 128-bit destination element polynomial multiply long
	instructions, when the PE is not in Streaming SVE mode.

	aarch64: Support for FEAT_LSUI
	FEAT_LSUI introduces unprivileged variants of load and store instructions so
	that clearing PSTATE.PAN is never required in privileged software.

2025-07-11  Ezra Sitorus  <ezra.sitorus@arm.com>

	aarch64: Support for FEAT_PCDPHINT
	FEAT_PCDPHINT - Producer-consumer data placement hints - is an optional
	ISA extension that provides hint instructions to indicate:
	- a store in the current execution thread is generating data at a specific
	location, which a thread of execution on one or more other observers is
	waiting on.
	- the thread of execution on the current PE will read a location that may not
	yet have been written with the value to be consumed.

	This extension introduces:
	- STSHH, a hint instruction, with operands (policies) keep and strm
	- PRFM *IR*, a new prefetch memory operand.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Announce s390 64-bit (s390x) SFrame V2 support in binutils
	The preceding commits add s390 64-bit (s390x) support in binutils to
	generate SFrame stack trace information (.sframe section) in the
	assembler from CFI directives (with option --gsframe), generate .sframe
	section for linker-generated .plt section in the linker, and dump SFrame
	information in objdump and readelf (with option --sframe).

	binutils/
		* NEWS: Announce s390 64-bit (s390x) SFrame V2 support in
		as, ld, objdump, and readelf.

	gas/
		* NEWS: Update s390 64-bit (s390x) SFrame V2 support in
		assembler.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: sframe: Test handling of .cfi_def_cfa_register
	Port x86-64 test for handling of .cfi_def_cfa_register from commit
	3602da6fa285 ("gas: sframe: fix handling of .cfi_def_cfa_register")
	to s390x.

	gas/testsuite/
		PR gas/32879
		* gas/cfi-sframe/cfi-sframe.exp: Add new test for handling of
		.cfi_def_cfa_register on s390x.
		* gas/cfi-sframe/cfi-sframe-s390x-3.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-3.s: Likewise.

	Bug: https://sourceware.org/PR32879

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Store SFrame CFA offset adjusted and scaled down
	In SFrame V2 the size of the offsets following an SFrame FRE can be
	either signed 8-bit, 16-bit, or 32-bit integer, with the largest offset
	determining their size:
	  1. CFA offset from CFA base register
	  2. RA (stack save slot) offset from CFA, usually -48 on s390x if saved
	  3. FP (stack save slot) offset from CFA, usually -72 on s390x if saved
	The FP and RA offsets from CFA, when FP/RA saved on the stack, usually
	have fixed values that fit into signed 8-bit SFrame offsets.  Likewise
	the DWARF register numbers on s390x of general registers (GR; 0-15) and
	floating-point registers (FPR; 16-31), when FP/RA saved in registers.
	With that the CFA offset from CFA base register has the greatest impact
	on the signed SFrame offset size.

	The s390x ELF ABI defines the stack pointer (SP) to be 8-byte aligned
	[1] and the CFA as SP at call site + 160 [2].  The CFA offset from CFA
	base register is therefore always a multiple of 8.

	On s390x store the SFrame CFA offset from CFA base register scaled down
	by the s390x-specific CFA alignment factor of 8, in addition to the
	adjustment by the s390x-specific CFA adjustment of -160, to further
	improve the use of signed 8-bit SFrame offsets.  This is similar to the
	DWARF data alignment factor getting factored out from certain offsets
	stored in DWARF CFI.

	[1]: s390x ELF ABI, sections "Register Roles" and "Stack Frame
	     Allocation", https://github.com/IBM/s390x-abi/releases
	[2]: s390x ELF ABI, commit 4e38ad9c8a88 ("Document the CFA"),
	     https://github.com/IBM/s390x-abi/commit/4e38ad9c8a88

	include/
		* sframe.h (SFRAME_S390X_CFA_OFFSET_ALIGNMENT_FACTOR): Define
		s390x-specific CFA offset alignment factor.
		(SFRAME_V2_S390X_CFA_OFFSET_ENCODE,
		SFRAME_V2_S390X_CFA_OFFSET_DECODE): Scale down/up by
		SFRAME_S390X_CFA_OFFSET_ALIGNMENT_FACTOR.

	libsframe/
		* doc/sframe-spec.texi (s390x,
		SFRAME_S390X_CFA_OFFSET_ALIGNMENT_FACTOR): Document s390x-
		specific CFA offset alignment factor.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Store SFrame CFA offset adjusted
	In SFrame V2 the size of the offsets following an SFrame FRE can be
	either signed 8-bit, 16-bit, or 32-bit integer, with the largest offset
	determining their size:
	  1. CFA offset from CFA base register
	  2. RA (stack save slot) offset from CFA, usually -48 on s390x if saved
	  3. FP (stack save slot) offset from CFA, usually -72 on s390x if saved
	The FP and RA offsets from CFA, when FP/RA saved on the stack, usually
	have fixed values that fit into signed 8-bit SFrame offsets.  Likewise
	the DWARF register numbers on s390x of general registers (GR; 0-15) and
	floating-point registers (FPR; 16-31), when FP/RA saved in registers.
	With that the CFA offset from CFA base register has the greatest impact
	on the signed SFrame offset size.

	The s390x ELF ABI [1] defines the CFA as stack pointer (SP) at call
	site +160. [2]  Therefore the minimum CFA offset from CFA base register
	on s390x is 160.  This does not fit into a signed 8-bit integer and
	therefore effectively prevents any use of signed 8-bit SFrame offsets
	on s390x.

	For s390x store the CFA offset from CFA base register adjusted by -160
	to enable the use of signed 8-bit SFrame offsets.

	[1]: s390x ELF ABI, https://github.com/IBM/s390x-abi/releases
	[2]: s390x ELF ABI, commit 4e38ad9c8a88 ("Document the CFA"),
	     https://github.com/IBM/s390x-abi/commit/4e38ad9c8a88

	include/
		* sframe.h (SFRAME_S390X_CFA_OFFSET_ADJUSTMENT): Define
		s390x-specific CFA offset adjustment.
		(SFRAME_V2_S390X_CFA_OFFSET_ENCODE,
		SFRAME_V2_S390X_CFA_OFFSET_DECODE): New s390x-specific
		macros.  Use SFRAME_S390X_CFA_OFFSET_ADJUSTMENT to en-/decode
		CFA offset.

	bfd/
		* elf64-s390.c (elf_s390x_sframe_plt_fre): Use
		SFRAME_V2_S390X_CFA_OFFSET_ENCODE on CFA offset to store it
		adjusted and switch to 8-bit offsets.

	gas/
		* gen-sframe.c (sframe_fre_set_cfa_offset): For s390x use
		SFRAME_V2_S390X_CFA_OFFSET_ENCODE on CFA offset to store it
		adjusted.
		(sframe_fre_get_cfa_offset): New helper.  For s390x use
		SFRAME_V2_S390X_CFA_OFFSET_DECODE on CFA offset to undo its
		adjustment.
		(sframe_xlate_do_def_cfa_register): Use new helper
		sframe_fre_get_cfa_offset.

	libsframe/
		* sframe.c (sframe_fre_get_cfa_offset): For s390x use
		SFRAME_V2_S390X_CFA_OFFSET_DECODE on CFA offset to undo its
		adjustment.
		* doc/sframe-spec.texi (s390x,
		SFRAME_S390X_CFA_OFFSET_ADJUSTMENT,
		SFRAME_V2_S390X_CFA_OFFSET_ENCODE,
		SFRAME_V2_S390X_CFA_OFFSET_DECODE): Document s390x-specific
		adjustment of CFA offset.

	libsframe/testsuite/
		* libsframe.find/plt-findfre-2.c (add_plt0_fde, add_pltn_fde):
		Use SFRAME_V2_S390X_CFA_OFFSET_ENCODE to enable use of 1-byte
		SFrame offsets.

	Suggested-by: Indu Bhagat <indu.bhagat@oracle.com>

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	libsframe: Add test for PLT0 and PLTN with only one FRE each
	On s390x the PLT0 and PLTN entries are described with one SFrame FRE
	each.  Add a test case for this particularity.

	libsframe/testsuite/
		* libsframe.find/find.exp (plt-findfre-2): Add new test.
		* libsframe.find/plt-findfre-2.c: New test for PLT0 and PLTN
		with only one FRE each.
		* libsframe.find/local.mk (plt-findfre-2): Add new test.

	libsframe/
		* Makefile.in: Regenerate.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Add SFrame stack trace information for .plt section
	Enable SFrame stack tracing through PLT entries.  Based on x86-64.

	On s390x both PLT0 and PLTn entries are 32-bytes in size.  Their code
	neither alters the stack pointer (SP), frame pointer (FP), nor return
	address (RA) registers.  Therefore the PLT0 can be represented using
	a SFrame FDE of type PCINC with a single SFrame FRE and the PLTn can
	be represented using a SFrame FDE of type PCMASK, with a repetition
	block size of 32 (PLTn size), and a single SFrame FRE.

	Note that as both the PLT0 entry and the PLTn entries have equal size
	and could both be represented using the identical SFrame FRE, the whole
	.plt section on s390x could be represented using a single SFrame FDE of
	type PCMASK, with a repetition block size of 32 (PLT0 and PLTn size),
	and a single SFrame FRE.  Keep the x86-64 logic with separate SFrame
	FDEs for PLT0 and PLTn, to ease potential generalization of the .sframe
	for .plt generation logic among architectures.

	bfd/
		* elf64-s390.c: Include sframe.h and sframe-api.h.
		(PLT_SFRAME_FDE_START_OFFSET, SFRAME_PLT0_MAX_NUM_FRES,
		SFRAME_PLTN_MAX_NUM_FRES, elf_s390x_sframe_plt_fre,
		elf_s390x_sframe_plt): New .sframe template for .plt section.
		(elf_s390_link_hash_table): Add plt_cfe_ctx, plt_sframe, and
		sframe_plt fields.
		(_bfd_s390_elf_create_sframe_plt): New function.  Fill in
		.sframe section for .plt section.
		(_bfd_s390_elf_write_sframe_plt): New function.  Write .sframe
		section.
		(elf_s390_create_dynamic_sections): Create .sframe section for
		.plt section.
		(elf_s390_late_size_sections): Call
		_bfd_s390_elf_create_sframe_plt and
		_bfd_s390_elf_write_sframe_plt.
		(elf_s390_finish_dynamic_sections): Write .plt section start
		into .sframe FDE covering .plt section.  Call
		_bfd_elf_merge_section_sframe on htab->plt_sframe.

	ld/
		* NEWS: Add news entry.

	ld/testsuite/
		* ld-s390/s390.exp: Add new test.
		* ld-s390/sframe-plt-1.d: New linker-generated .sframe for .plt
		test.
		* ld-s390/sframe-simple-1.d: Adjust expected test output due to
		linker-generated .sframe for .plt.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Represent FP without RA saved in SFrame
	If an architecture uses both SFrame RA and FP tracking SFrame assumes
	that the RA offset is the 2nd offset and the FP offset is the 3rd offset
	following a SFrame FRE.  An architecture does not necessarily need to
	save both on the stack (or in register) at the same time or even at all.
	SFrame cannot represent FP without RA saved on stack (or in a register),
	since it cannot distinguish whether the 2nd offset is the RA or FP
	offset.

	For s390x use an invalid SFrame RA offset from CFA value of zero as
	padding to represent the FP being saved when the RA is not saved.  This
	aligns with the existing invalid SFrame fixed RA offset from CFA value
	of zero.  In a stack tracer this then also naturally falls into place,
	as it can skip restoring the RA in the topmost frame, if both the fixed
	RA offset (from SFrame header) and the RA offset (from FDE) are zero,
	without any need to test architecture-specific flags.

	include/
		* sframe.h (SFRAME_FRE_RA_OFFSET_INVALID): New define.  Used as
		padding offset.
		* sframe-api.h (sframe_fre_get_ra_offset): Add comment that for
		s390x an offset value of SFRAME_FRE_RA_OFFSET_INVALID indicates
		that the RA is not saved.

	gas/
		* gen-sframe.c (get_fre_num_offsets): For s390x account padding
		RA offset, if FP without RA saved.
		(sframe_get_fre_offset_size): Likewise.
		(output_sframe_row_entry): For s390x write a padding RA offset,
		if FP without RA needs to be represented.
		(sframe_do_fde): Enable FP without RA saved to be represented
		on s390x.

	libsframe/
		* sframe.c (sframe_fre_get_ra_offset): Add comment that for
		s390x an offset value of SFRAME_FRE_RA_OFFSET_INVALID indicates
		that the RA is not saved.
		* sframe-dump.c (dump_sframe_func_with_fres): Treat invalid
		RA offsets as if they were undefined.  Display them as "U"
		to distinguish them.
		* doc/sframe-spec.texi (s390x): Document s390x-specific use of
		SFRAME_FRE_RA_OFFSET_INVALID to represent FP without RA saved.

	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe.exp: Rename s390x-specific tests.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-offset-err-1.s: Rename
		to ...
		* cfi-sframe/cfi-sframe-s390x-fpra-offset-err-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-offset-2.s: This.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-offset-2.d: Likewise.
		Update test verification pattern accordingly.
		* cfi-sframe/cfi-sframe-s390x-fpra-register-err-1.s: Rename
		to ...
		* cfi-sframe/cfi-sframe-s390x-fpra-register-err-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-2.s: This.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-2.d: Likewise.
		Update test verification pattern accordingly.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Represent FP/RA saved in register in SFrame
	GCC on s390x, when in a leaf function, can be observed to save the
	frame pointer (FP) and/or return address (RA) register in a floating-
	point registers (FPR) instead of on the stack.  This is declared using
	the following CFI directive:

	  .cfi_register <fp/ra-regnum>, <fpr-regnum>

	SFrame cannot represent the FP and/or RA being saved in another
	register.  It does only track the CFA base register (SP/FP), CFA offset
	from CFA base register, and FP and RA save area offsets from CFA.

	On s390x the FP and/or RA are only saved in another FPR when in a leaf
	function.  That is a function that does not call any other function.
	Therefore it can ever only be the topmost function in a call chain.
	An unwinder by default has access to all registers of the function that
	is the topmost on the call stack.  Therefore no further information
	is required to restore FP/RA from the FPR.

	Represent FP/RA saved in another register on s390x, by encoding the
	DWARF register number shifted by one to the left with the least-
	significant bit set in the offset as follows:

	  offset = (regnum << 1) | 1

	The use of the least-significant bit of the offset as indication is
	possible, as the stack pointer (SP), the CFA, and any register save
	area slots are 8-byte aligned according to the s390x ELF ABI:
	- The stack pointer (SP) "shall maintain an 8-byte alignment". [1]
	- The CFA is defined as SP at call site +160. [2]
	- Pointers and 8-byte integers, such as general register values, must
	  be 8-byte aligned. [3]
	SFrame FP and RA stack offsets must therefore always be a multiple of
	8 on s390x.  Note that for the same reason the DWARF data alignment
	factor is -8 on s390x (see DWARF2_CIE_DATA_ALIGNMENT).

	Add s390x-specific SFrame (error) tests for FP/RA saved in FPRs in leaf
	function.

	[1]: s390x ELF ABI, sections "Register Roles" and "Stack Frame
	     Allocation", https://github.com/IBM/s390x-abi/releases
	[2]: s390x ELF ABI, commit 4e38ad9c8a88 ("Document the CFA"),
	     https://github.com/IBM/s390x-abi/commit/4e38ad9c8a88
	[3]: s390x ELF ABI, section "Fundamental Types", table "Scalar types",
	     https://github.com/IBM/s390x-abi/releases

	include/
		* sframe.h (SFRAME_V2_S390X_OFFSET_IS_REGNUM): New s390x-
		specific macro to test whether an SFrame FP/RA offset is a DWARF
		register number.
		(SFRAME_V2_S390X_OFFSET_ENCODE_REGNUM): New s390x-specific macro
		to encode a DWARF register number into an SFrame FP/RA offset.
		(SFRAME_V2_S390X_OFFSET_DECODE_REGNUM): New s390x-specific macro
		to decode an SFrame FP/RA offset into a DWARF register number.
		* sframe-api.h (sframe_fre_get_fp_offset,
		sframe_fre_get_fp_offset): Add comment that for s390x the offset
		may be an encoded register number.

	gas/
		* gen-sframe.c (s390_sframe_xlate_do_register): New S390-
		specific function.  Uses SFRAME_V2_S390X_OFFSET_ENCODE_REGNUM to
		represent FP/RA saved in another register on s390x.
		(sframe_xlate_do_register): Invoke s390_sframe_xlate_do_register
		on s390x.

	libsframe/
		* sframe.c (sframe_fre_get_fp_offset, sframe_fre_get_fp_offset):
		Add comment that for s390x the offset may be an encoded register
		number.
		* sframe-dump.c (is_sframe_abi_arch_s390x): New helper to test
		whether ABI/arch is s390x.
		(dump_sframe_func_with_fres): Use
		SFRAME_V2_S390X_OFFSET_IS_REGNUM and
		SFRAME_V2_S390X_OFFSET_DECODE_REGNUM to dump FP/RA saved in
		another register on s390x.
		* doc/sframe-spec.texi (s390x): Document s390x-specific
		representation of FP/RA saved in another register.

	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe.exp: Update s390x-specific SFrame
		(error) tests.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-err-2.s: Rename
		to ...
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-err-2.d:
		Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-1.s: This.  Test
		no longer triggers a warning, as SFrame can represent FP and RA
		saved in registers.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-err-1.d: Test
		now triggers a different warning, as SFrame can represent FP and
		RA saved in registers, but not FP without RA saved in register.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Initial support to generate .sframe from CFI directives in assembler
	This introduces initial support to generate .sframe from CFI directives
	in assembler on s390 64-bit (s390x).  Due to SFrame V2 format
	limitations it has the following limitations, some of them getting
	addressed by subsequent patches, which cause generation of SFrame FDE
	to be skipped:

	- SFrame FP/RA tracking only supports register contents being saved on
	  the stack (i.e. .cfi_offset).  It does not support FP/RA register
	  contents being saved in other registers (i.e. .cfi_register).  GCC on
	  s390x can be observed to save the FP/RA register contents in floating-
	  point registers, but only in leaf functions.
	  This issue is detailed further and resolved in the subsequent commit
	  "s390: Represent FP/RA saved in register in SFrame".

	- SFrame FP/RA tracking cannot represent FP without RA saved.  This is
	  because the format assumes SFrame FDE offset2 to be the RA offset, if
	  there are two offsets, and offset3 to be the FP offset, if there are
	  three offsets.  There is no mean to distinguish whether offset2 is the
	  RA or FP offset, if there are only two offsets.
	  This issue is detailed further and resolved in the subsequent commit
	  "s390: Represent FP without RA saved in SFrame".

	- SFrame assumes a dedicated FP register number.  The s390x ELF ABI [1]
	  does only designate register 11 as preferred FP register number.  In
	  general GCC and Clang on s390x use register 11 as frame pointer.
	  GCC on s390x can be observed to use register 14 as frame pointer in
	  the stack clash protector in the function prologue.
	  glibc on s390x contains hand-written assembler code that uses
	  register 12 as frame pointer.

	This s390x support is largely based on the AArch64 support from commit
	b52c4ee46657 ("gas: generate .sframe from CFI directives").

	The SFrame ABI/arch identifier SFRAME_ABI_S390X_ENDIAN_BIG is introduced
	for s390x and added to the SFrame format specification.

	The s390x ELF ABI [1] specifies the following C calling conventions for
	s390x architecture:
	- Register 15 is the stack pointer (SP).
	- Register 14 contains the return address (RA) at function entry.
	- There is no dedicated frame pointer register.  Register 11 is the
	  preferred frame pointer (FP). [2]  GCC and Clang in general use
	  register 11 as frame pointer.
	- The CFA is defined as SP at call site +160. [3]  The SP at call site
	  can therefore be derived from the CFA using a SP value offset from CFA
	  of -160.

	The s390x ELF ABI [1] does not assign any standard save slot to each
	register in the register save area of a stack frame.  Neither the
	return address (RA, r14) nor preferred frame pointer (FP, r11)
	necessarily need to be saved.  Therefore SFrame RA and FP tracking is
	used.

	Support for SFrame on s390 is only enabled for the 64-bit s390x ELF ABI
	(z/Architecture with 64-bit addressing mode).  It is disabled for the
	32-bit s390 ELF ABI (ESA/390 or z/Architecture with 32-bit addressing
	mode).

	s390x-specific SFrame assembler and linker tests are added, including
	error tests for use of a non-preferred frame pointer (FP) register and
	specification of a non-default return address (RA) register.

	[1]: s390x ELF ABI, https://github.com/IBM/s390x-abi/releases
	[2]: s390x ELF ABI, commit f00421825979 ("Add information about the frame
	     pointer register"),
	     https://github.com/IBM/s390x-abi/commit/f00421825979
	[3]: s390x ELF ABI, commit 4e38ad9c8a88 ("Document the CFA"),
	     https://github.com/IBM/s390x-abi/commit/4e38ad9c8a88

	include/
		* sframe.h: Add reference to s390x architecture in comments.
		(SFRAME_ABI_S390X_ENDIAN_BIG): Define SFrame ABI/arch identifier
		for s390x.
		(SFRAME_S390X_SP_VAL_OFFSET): Define s390x-specific SP value
		offset from CFA.

	libsframe/
		* sframe.c (need_swapping): Add SFRAME_ABI_S390X_ENDIAN_BIG.
		* doc/sframe-spec.texi (SFRAME_ABI_S390X_ENDIAN_BIG, s390x,
		SFRAME_S390X_SP_VAL_OFFSET): Document SFrame ABI/arch identifier
		for s390x, add references to s390x architecture, and document
		s390x-specifics, such as the SP value offset from CFA of -160.

	gas/
		* config/tc-s390.h: s390x support to generate .sframe from CFI
		directives in assembler.
		(support_sframe_p): Define.
		(SFRAME_CFA_SP_REG, SFRAME_CFA_FP_REG, SFRAME_CFA_RA_REG):
		Define.
		(sframe_ra_tracking_p): Define.
		(sframe_cfa_ra_offset): Define.
		(sframe_get_abi_arch): Define.
		* config/tc-s390.c: s390x support to generate .sframe from CFI
		directives in assembler.
		(s390_sframe_cfa_sp_reg, s390_sframe_cfa_fp_reg,
		s390_sframe_cfa_ra_reg): New.  Initialize to DWARF register
		numbers of stack pointer (SP, r15), preferred frame pointer
		(FP, r11), and return address (RA, r14) registers.
		(s390_support_sframe_p): New function.  Return true if s390x.
		(s390_sframe_ra_tracking_p): New function.  Return true.
		(s390_sframe_cfa_ra_offset): New function.  Return
		SFRAME_CFA_FIXED_RA_INVALID.
		(s390_sframe_get_abi_arch): New function.  Return
		SFRAME_ABI_S390X_ENDIAN_BIG if s390x, otherwise zero.
		* gen-sframe.c: Add reference to s390x architecture in comments.
		(sframe_xlate_do_val_offset): Add support for s390x-specific
		SFRAME_S390X_SP_VAL_OFFSET.
		* NEWS: Add news entry.

	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe.exp: Enable common SFrame tests for
		s390x.  Add s390x-specific SFrame (error) tests.
		* gas/cfi-sframe/cfi-sframe-s390x-1.d: New s390x-specific SFrame
		test.
		* gas/cfi-sframe/cfi-sframe-s390x-1.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-2.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-err-1.d: New s390x-specific
		SFrame error test that uses a non-default frame-pointer register
		as CFA base register.
		* gas/cfi-sframe/cfi-sframe-s390x-err-1.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-err-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-err-2.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-err-3.d: New s390x-specific
		SFrame error test that uses a non-default return address
		register.
		* gas/cfi-sframe/cfi-sframe-s390x-err-3.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-offset-1.d: New s390x-
		specific SFrame test that saves RA and FP individually on the
		stack.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-offset-1.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-offset-err-1.d: New
		s390x-specific SFrame error test that saves FP and RA
		individually, to trigger FP without RA saved.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-offset-err-1.s: Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-err-1.d: New
		s390x-specific SFrame error test that saves FP and RA
		individually in registers.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-err-1.s:
		Likewise.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-err-2.d: New
		s390x-specific SFrame error test that saves RA and FP
		individually in registers.
		* gas/cfi-sframe/cfi-sframe-s390x-fpra-register-err-2.s:
		Likewise.

	ld/testsuite/
		* ld-s390/s390.exp: Add simple SFrame test.
		* ld-s390/sframe-simple-1.d: New simple SFrame test.
		* ld-s390/sframe-bar.s: Likewise.
		* ld-s390/sframe-foo.s: Likewise.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	s390: Explicitly list linker dump tests
	Generating the linker dump test list using file globbing makes it
	difficult to exclude specific tests under certain circumstances.  List
	them explicitly instead.  This enables to add tests in the future that
	can be excluded.  While at it reorganize how s390 linker tests get
	run for s390x.

	ld/testsuite/
		* ld-s390/s390.exp: Reorganize and explicitly list linker dump
		tests.

2025-07-11  Jens Remus  <jremus@linux.ibm.com>

	sframe: Ignore section padding when converting endianness
	The .sframe section may have a trailing padding due to the architecture-
	specific default section alignment.  Do not treat this padding as error
	when converting between target and host endianness.

	This can be observed when building Binutils with SFrame s390x support on
	x86-64 for s390x using configure option "--target=s390x-ibm-linux-gnu"
	and running the GAS test suite.

	While at it reuse the determined SFrame section header size.

	libsframe/
		* sframe.c (flip_sframe): Ignore .sframe section padding.  Reuse
		SFrame header size.

	Reported-by: Indu Bhagat <indu.bhagat@oracle.com>

2025-07-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-10  Alan Modra  <amodra@gmail.com>

	AM_PO_SUBDIRS
	Swap AM_PO_SUBDIRS and ZW_GNU_GETTEXT_SISTER_DIR lines in
	*/configure.ac.  ZW_GNU_GETTEXT_SISTER_DIR indirectly invokes
	AC_REQUIRE(AM_PO_SUBDIRS) so results in AM_PO_SUBDIRS being emitted
	before ZW_GNU_GETTEXT_SISTER_DIR if it hasn't already been invoked.

2025-07-10  Alan Modra  <amodra@gmail.com>

	gas v850 md_convert_frag
	The v850 md_convert_frag function oddly calls subseg_change twice
	(commit 1cd986c58543).  Neither call is needed, because that is done
	in size_seg.

	Convert the fr_opcode fixup field back (to an opindex, not fx_r_type)
	using a cast rather than a union, since we used casts when setting up
	those values.  I guess the union was added to silence compiler
	warnings about wrong-size casts, but unfortunately results in the
	wrong value being retrieved on big-endian hosts.

	Change "buffer" to a char* as there is no need to make it an
	unsigned char*, and that way requires fewer casts.  Finally, fix
	formatting and use uintptr_t when make the rs_machine_dependent frags.

	Remove subseg_change calls from cr16, crx, mn10200, mn10300, and sh
	md_convert_frag too.

2025-07-10  Alan Modra  <amodra@gmail.com>

	union alpha_macro_arg
	Rename the old enum alpha_macro_arg to alpha_macro_argset, and create
	a union alpha_macro_arg to use in all the alpha_macro.emit functions.
	This avoids intptr_t casts on retrieving index values and void* casts
	on storing them in the alpha_macros array.

2025-07-10  Nelson Chu  <nelson@rivosinc.com>

	sim: riscv: Fix build issue due to INSN_CLASS_C was changed to INSN_CLASS_ZCA

2025-07-10  Matthieu Longo  <matthieu.longo@arm.com>

	libiberty: sync with gcc
	Import the following commits from GCC as of r16-2170-g2f2e9bcfb0fd9c:
		0fd98b6f9f2 libiberty: add routines to handle type-sensitive doubly linked lists

2025-07-10  Nelson Chu  <nelson@rivosinc.com>

	RISC-V: Fixed wrong imply result for zce when -march=rv32id_zce
	The entry of "zce imply zcf" needs check_implicit_for_zcf, so it needs to be
	placed after the entries of "whatever imply f".  Otherwise the implicit zcf
	may be missed.  Also merge the march-implu-zce* testcases into imply testcases.

2025-07-10  Nelson Chu  <nelson@rivosinc.com>

	RISC-V: Clarify the imply rule of c
	This also fix the imply result for .option rvc.

	Imply zcf when c and f and rv32
	Imply zcd when c and d
	Imply zca when c

	Changed INSN_CLASS_C to INSN_CLASS_ZCA
	Changed INSN_CLASS_F_AND_C to INSN_CLASS_ZCF
	Changed INSN_CLASS_D_AND_C to INSN_CLASS_ZCD
	Changed INSN_CLASS_ZIHINTNTL_AND_C to INSN_CLASS_ZIHINTNTL_AND_ZCA

2025-07-10  Nelson Chu  <nelson@rivosinc.com>

	RISC-V: Deprecate ".option arch, -ext" for users due to its controversial use
	Before we figure out the whole remove situations for ".option arch, -ext", and
	have any RISC-V public spec defines it, we should just deprecate it.

2025-07-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-09  Indu Bhagat  <indu.bhagat@oracle.com>

	gas: ld: sframe: add new internal header
	for SFRAME_V2_GNU_AS_LD_ENCODING_FLAGS.

	The intention of creating an abstraction like
	SFRAME_V2_GNU_AS_LD_ENCODING_FLAGS is to address the concern that there
	should be a central place to enforce harmonious flags between GNU as and
	ld.  At the moment, the only flag that needs to be enforced is
	SFRAME_F_FDE_FUNC_START_PCREL.

	sframe.h and sframe-api.h are installed headers by libsframe for the
	specification and implementation respectively.  Adding a definition like
	SFRAME_V2_GNU_AS_LD_ENCODING_FLAGS does not fit in either.  Create a
	new internal header instead to keep the definition uncoupled from
	sframe.h and sframe-api.h.  Rename the previously added
	SFRAME_F_LD_MUSTHAVE_FLAGS to define the new
	SFRAME_V2_GNU_AS_LD_ENCODING_FLAGS.

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Use the new
		internal header and SFRAME_V2_GNU_AS_LD_ENCODING_FLAGS.
	gas/
		* gen-sframe.c (output_sframe_internal): Likewise.
	include/
		* sframe-api.h (SFRAME_F_LD_MUSTHAVE_FLAGS): Move from..
		* sframe-internal.h: ..to here.  New file.

2025-07-09  Alan Modra  <amodra@gmail.com>

	Merge init_private_section_data with copy_private_section_data
	init_private_section_data is used by the linker and is a special case
	of copy_private_section_data that copies a reduced set of section data
	from input to output.  Merge the two functions, adding a link_info
	param to copy_private_section_data and remove init_private_section_data.

	gas remove assorted unnecessary casts
	This continues the saga of removing unnecessary casts, and making
	small code tidies in gas.  Hopefully this sees the last of K&R
	anachronisms.

	gas standardise md_section_align
	The point here is that when valueT is 64 bits and int is 32 bits,
	1 << align doesn't work for shifts larger than the size of int.  (Not
	that anyone is likely to use such large alignments in real code.)

	gas function arg casts
	This patch removes more unnecessary arg casts in various function
	calls.

	gas fixups
	Remove unnecessary arg casts in fix_new and similar calls.

	gas char/unsigned char casts
	This patch removes many unneeded casts to char or unsigned char.  It's
	worth noting that safe-ctype.h macros ISDIGIT and the like cope with
	either signed or unsigned char.
	In some cases a cast to unsigned char is replaced by anding with 0xff,
	which accomplishes the same thing but doesn't rely on char being eight
	bits.  The patch also removes pointer casts, and a few unsigned char
	pointer variables.

	gas alpha sign extension macros
	Use standard sign extend and range checking using unsigned
	expressions that don't rely on implementation defined right shifts or
	size of short and int.

2025-07-09  Alan Modra  <amodra@gmail.com>

	gas md_number_to_chars
	Calls to md_number_to_chars don't need to cast their value arg (*).
	Remove those casts.  avr_output_property_recode made a call to
	md_number_to_chars with size of 1.  Simplify that.  tc-bpf.c
	md_convert_frag used write_insn_bytes that simply copied input to
	output.  Dispense with that nonsense, and similarly in a couple of
	other places where md_number_to_chars was called with size 1.

	*) unless the value arg is an expression that needs a cast, eg. tic54x
	   emit_insn where the shift left could trigger signed overflow UB
	   without a cast.

2025-07-09  Alan Modra  <amodra@gmail.com>

	z8k opcode_entry_type
	z8k opcode_entry_type.func is never used as a function pointer, only
	as a pointer to a pseudo_typeS.  Change it to a void*.

	gas various other void* casts
	This removes assorted unneeded casts of void* pointers, and casts when
	passing args to void* parameters or storing to void* pointers.  The
	patch also changes obj-coff.c stack_push to take a void* parameter,
	and replaces an odd memcpy in tc-metag.c find_insn_templates with a
	simple assignment.

	gas various other const pointer changes
	This removes a bunch of casts involving const pointers, in some cases
	by making variables const pointers so a cast is not needed.  In a
	couple of places the cast hid errors with "&array" written rather than
	"array", see iq2000_macro_defs and s_pru_align.  tc-xgate.c cmp_opcode
	is changed to be the standard qsort predicate to avoid a function
	cast.

	gas d30v_insn plus other non-const pointers
	d30v has a bunch of casts that are only needed due to various types
	missing a const.  Fix that.

	gas alloc casts
	All of the various memory allocation function return a "void *"
	pointer, which needs no cast to assign to other pointer types.

	gas bfd_put and bfd_get arg casts
	bfd_{h_,}put_* and bfd_{h_,}get_* have "void *" pointer params
	nowadays.  We don't need casts on their pointer args.  We also don't
	need to cast values passed to bfd_put.

	gas NULL casts
	This removes many unnecessary NULL casts.  I'm also adding a few arg
	casts in concat calls, to make the code consistent.  Advice from quite
	a few years ago was that it's better to use the exact type for args
	corresponding to function ellipses, in case NULL is defined as plain
	0.  (I think that happened with some early 64-bit systems.  Plain NULL
	ought to be OK nowadays.)

	gas s3_FAIL and s7_FAIL
	s3_FAIL is defined as 0x80000000 which is unsigned, but everywhere it
	is used it is cast to int.  Get rid of that silliness, and likewise
	for s7_FAIL.

	gas more enum casts
	Remove more unnecessary enum casts.

	gas bfd_reloc_code_real_type
	Enumeration constants are integer types, so there should be no need to
	cast such constants to int in expressions.  (Perhaps some older gccs
	warned, I checked back to gcc-4.5.)  Remove some of those unnecessary
	casts.  Also remove unnecessary casts to bfd_reloc_code_real_type.

	gas add_ecoff_symbol
		* ecoff.c: Remove unnecessary arg casts in add_ecoff_symbol
		calls throughout file.

2025-07-09  Alan Modra  <amodra@gmail.com>

	gas frag_var
	Many frag_var calls have unnecessary casts on arguments, no doubt from
	the days when binutils was written for K&R C.  (ie. functions were not
	prototyped so you needed to cast anything that didn't match the
	expected type after default promotions, as you still do for args
	matching a function ellipsis.)  Remove those casts.

		* config/tc-alpha.c (s_alpha_comm): Use offset_T for cur_size
		to avoid need for casts.  Remove casts from frag_var args.
		* config/tc-ia64.c (obj_elf_vms_common): Remove casts from
		frag_var args.
		* config/tc-m32r.c (m32r_scomm): Likewise.
		* config/tc-m68hc11.c (build_jump_insn): Likewise.
		(build_dbranch_insn): Likewise.
		* config/tc-m68k.c (md_assemble): Likewise.
		* config/tc-microblaze.c (microblaze_s_lcomm): Likewise.
		* config/tc-mmix.c (s_loc): Likewise.
		* config/tc-ppc.c (ppc_elf_lcomm, ppc_comm): Likewise.
		* config/tc-score.c (s3_s_score_lcomm): Likewise.
		* config/tc-score7.c (s7_s_score_lcomm): Likewise.
		* config/tc-sh.c (sh_cons_align): Likewise.
		* config/tc-sparc.c (s_reserve, s_common): Likewise.
		(sparc_cons_align): Likewise.
		* config/tc-tic4x.c (tic4x_seg_alloc, tic4x_bss): Likewise.
		* config/tc-tic54x.c (tic54x_bss, tic54x_space): Likewise.
		(tic54x_usect, tic54x_field): Likewise.
		* config/tc-tic6x.c (s_tic6x_scomm): Likewise.
		* config/tc-v850.c (v850_offset, v850_comm): Likewise.
		* frags.c (frag_align, frag_align_pattern, frag_align_code): Likewise.
		* gen-sframe.c (output_sframe_row_entry): Likewise.
		(output_sframe_funcdesc): Likewise.
		* read.c (s_fill, do_org, s_space, emit_leb128_expr): Likewise.
		* symbols.c (colon)): Likewise.

2025-07-09  Alan Modra  <amodra@gmail.com>

	gas pointer to int and vice versa
	Use "intptr_t" or "uintptr_t" for these conversions, not "long" which
	is wrong on LLP64 systems, or "size_t" which is better but still not
	the correct type.

		* config/tc-alpha.c (emit_ldXu, emit_ldX, emit_uldXu, emit_uldX),
		(emit_stX, emit_ustX, emit_sextX): Use correct type when
		converting vlgsize pointer to in.  Use "int" rather than
		"long" for result.
		* config/tc-ia64.c (generate_unwind_image): Use intptr_t cast
		when passing personality_routine to frag_var.
		* config/tc-ppc.c (ppc_frob_symbol <coff>): Use uintptr_t cast
		when converting symbol pointer to valueT.
		* config/tc-v850.c (md_assemble): Use intptr_t cast when
		loading integer opindex.

2025-07-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-08  Alice Carlotti  <alice.carlotti@arm.com>

	aarch64: Add support for FEAT_SVE2p2 and FEAT_SME2p2

	aarch64: Reorder virtual feature dependencies
	This will improve readability when more combinations of "SVE* or SME*"
	are added.

2025-07-08  First Last  <ghodawalaaman2@disroot.org>

	gdb/reverse: Add 2 AVX instructions VADDSUBPS and VADDSUBPD
	add support to recording 2 missing AVX instructions: vaddsubps and vaddsubpd, and add associated tests.

	Approved-By: Guinevere Larsen <guinevere@redhat.com>

2025-07-08  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: support external debug info
	Use bfd_follow_gnu_debuglink() and bfd_follow_gnu_debugaltlink() to find files
	with debug info.
	If necessary, gprofng-archive copies these files to EXP/archives.

	For each executable, gprofng creates the Elf class twice.
	One of them was a memory leak.
	Fixed this by adding a new argument to Stabs::Stabs().

	gprofng/ChangeLog
	2025-07-07  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		PR 32147
		PR 30194
		* src/Disasm.cc (get_funcname_in_plt): Use the executable file instead
		of the debug information file.
		* src/Dwarf.h: Define debug_alt_strSec.
		* src/DwarfLib.cc: Add support for DW_FORM_GNU_ref_alt,
		DW_FORM_GNU_strp_alt.
		* src/Elf.h (find_gnu_debug_files, get_dwr_section): New functions.
		* src/Elf.cc: Likewise.
		* src/Experiment.cc (copy_file): Add the const qualifier.
		* src/Experiment.h: Likewise.
		* src/LoadObject.cc (get_elf, openDebugInfo): Find files with debug info.
		* src/LoadObject.h: Remove unused variables.
		* src/Module.cc: Remove an argument in openDebugInfo().
		* src/Stabs.cc (Stabs::Stabs): Add the Elf* argument.
		* src/Stabs.h: Likewise.
		* src/gp-archive.cc: Archive files with debug info.
		* src/gp-archive.h (archive_file): New function.

2025-07-08  Tom Tromey  <tromey@adacore.com>

	Fix wchar.exp test case per review
	A recent patch of mine modified wchar.exp, but I failed to notice one
	part of the review.  This patch updates the code to conform to the
	review comments.

2025-07-08  Nick Clifton  <nickc@redhat.com>

	New Malay translation for bfd/ and new Spanish translation for gas/

2025-07-08  Mark Goncharov  <mark.goncharov@syntacore.com>

	RISC-V: Fix libpath_suffix selection for ldscript
	When building a cross-compiler ld for RISC-V Linux systems, you can specify
	target=riscv64*-linux* to create a linker that supports both 32-bit
	(-march=rv32*) and 64-bit (-march=rv64*) architectures.  The specified -march
	value populates the EMULATION_NAME variable, which determines the default
	linker script selection.  For proper riscv64 target support, the build process
	must prepare both elf32lriscv* and elf64lriscv* linker scripts.  These should
	align with the standard RISC-V Linux sysroot directory structure.

2025-07-08  Nelson Chu  <nelson@rivosinc.com>

	RISC-V: Fixed mapping symbol for .option norvc directive

	RISC-V: Fixed dis-assembler to set correct xlen from mapping symbol

	RISC-V: Fixed that .option push/pop won't recover the xlen

	RISC-V: Added testcase to show the current rvc and xlen problems

2025-07-08  Linsen Zhou  <i@lin.moe>

	RISC-V: Bind defined symbol locally in PIE
	Reference commit 1dcb9720d62cd053a72c31881b7724ce9f74332c

	bfd/
		* elfnn-riscv.c (RISCV_COPY_INPUT_RELOC): Bind defined symbol
		locally in PIE.

	ld/
		* testsuite/ld-riscv-elf/pie-bind-locally-a.s: New test source.
		* testsuite/ld-riscv-elf/pie-bind-locally-b.s: Likewise.
		* testsuite/ld-riscv-elf/pie-bind-locally-rv32.d: New testcase.
		* testsuite/ld-riscv-elf/pie-bind-locally-rv64.d: Likewise.

2025-07-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-07  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: remove ElfReloc class and unused functions and declarations
	class ElfReloc is not used after we started use libbfd.
	Removed ElfReloc and other unused declarations.

	gprofng/ChangeLog
	2025-07-03  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		* src/Disasm.cc: Remove unused functions and variables.
		* src/Disasm.h: Likewise.
		* src/Dwarf.cc: Likewise.
		* src/DwarfLib.cc: Likewise.
		* src/DwarfLib.h: Likewise.
		* src/Elf.cc: Likewise.
		* src/Elf.h: Likewise.
		* src/Stabs.cc: Likewise.
		* src/Stabs.h: Likewise.

2025-07-07  Tom Tromey  <tromey@adacore.com>

	Correctly handle L'\\'
	Hannes filed a bug that pointed out that:

	    print L'\\'

	... did not work correctly.  The bug is in convert_escape, which
	simply transcribes the backslash character, rather than convert it
	between encodings.

	This patch fixes the error.  I also turned a macro into a lambda to
	clean up this code a little.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33124
	Reviewed-By: Tom de Vries <tdevries@suse.de>
	Tested-By: Hannes Domani <ssbssa@yahoo.de>

2025-07-07  WANG Xuerui  <git@xen0n.name>

	LoongArch: Allow to relax instructions into NOPs after handling alignment
	Right now, LoongArch linker relaxation is 2-pass, since after alignment
	is done, byte deletion can no longer happen. However, as the alignment
	pass also shrinks text sections, new relaxation chances may well be
	created after alignment is done. Although at this point we can no longer
	delete unused instructions without disturbing alignment, we can still
	replace them with NOPs; popular LoongArch micro-architectures can
	eliminate NOPs during execution, so we can expect a (very) slight
	performance improvement from those late-created relaxation chances.

	To achieve this, the number of relax passes is raised to 3 for
	LoongArch, and every relaxation handler except loongarch_relax_align is
	migrated to a new helper loongarch_relax_delete_or_nop, that either
	deletes bytes or fills the bytes to be "deleted" with NOPs, depending on
	whether the containing section already has undergone alignment. Also,
	since no byte can be deleted during this relax pass, in the pass the
	pending_delete_ops structure is no longer allocated, and
	loongarch_calc_relaxed_addr(x) degrades to the trivial "return x" in
	this case.

	In addition, previously when calculating distances to symbols, an
	extra segment alignment must be considered, because alignment may
	increase distance between sites. However in the newly added 3rd pass
	code size can no longer increase for "closed" sections, so we can skip
	the adjustment for them to allow for a few more relaxation chances.

	A simple way to roughly measure this change's effectiveness is to check
	how many pcalau12i + addi.d pairs are relaxed into pcaddi's. Taking a
	Firefox 140.0.2 test build of mine as an example:

	Before: 47842 pcaddi's in libxul.so
	After: 48089

	This is a 0.5% increase, which is kind of acceptable for a peephole
	optimization like this; of which 9 are due to the "relax"ed symbol
	distance treatment.

2025-07-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-06  Jens Remus  <jremus@linux.ibm.com>

	ld: bfd: sframe: Update section size also for relocatable links
	For relocatable links the output .sframe section size may be wrong.
	This can be observed when dumping the SFrame information from the x86-64
	sframe-reloc-1 test:

	Name              Address          Off    Size
	.sframe           0000000000000000 000110 00007f

	Offset            Type               Symbol's Value  Symbol's Name + Addend
	000000000000001c  R_X86_64_PC32      0000000000000000 .text + 1c
	0000000000000030  R_X86_64_PC32      0000000000000000 .text + 65

	0x00000000 e2de0201 0300f800 02000000 08000000 ................
	0x00000010 1e000000 00000000 28000000 00000000 ........(.......
	0x00000020 35000000 00000000 04000000 00000000 5...............
	0x00000030 00000000 25000000 0f000000 04000000 ....%...........
	            offset 1st FRE---^^^^^^^^ ^^^^^^^^---number of FREs
	0x00000040 00000000 00030801 0510f004 0410f034 ...............4
	FDE info---^^      | begin of FDEs
	0x00000050 0508f000 03080105 10f00404 10f02405 ..............$.
	                 11111112222222223333333334444---FRE 1, 2, 3, 4
	0x00000060 08f00000 00000000 00000000 00000000 ................
	           4444^^^^...
	0x00000070 00000000 00000000 00000000 000000   ...............
	                                   ...^^^^^^---excessive section

	When running the x86-64 test cross build on a big-endian system, such
	as s390x, objdump and readelf fail to dump the SFrame information with
	the following error message:

	Error: SFrame decode failure: Buffer does not contain SFrame data.

	This is because the following check in flip_sframe() fails, which gets
	only invoked if the endianness of the SFrame data is different from the
	host system one:

	/* All FDEs and FREs must have been endian flipped by now.  */
	if ((j != ihp->sfh_num_fres) || (bytes_flipped != (buf_size - hdrsz)))
	                                 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	With:
	j=8, ihp->sfh_num_fres=8, bytes_flipped=70, buf_size=127, hdrsz=28

	While at it, remove the incorrect code comment.  There is no
	relationship between "do not update size" and the fact that the
	"contents have not been relocated".

	bfd/
		* elf-sframe.c (_bfd_elf_write_section_sframe): Update section
		size also for relocatable links.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	NEWS: sframe: mention new semantics for SFrame FDE function start addr
	The SFrame FDE's function start address is always emitted as follows by
	GAS and ld:  it is the offset of the start PC of the respective function
	from the FDE field itself.

	GAS and ld will emit a flag SFRAME_F_FDE_FUNC_START_PCREL set to 1
	when emitting the field in this encoding.

		* binutils/NEWS: Announce the change of encoding for SFrame FDE
		  func start addr field.
	        * gas/NEWS: Announce the emission of new flag
		  SFRAME_F_FDE_FUNC_START_PCREL.
	        * ld/NEWS: Likewise.  Relocatable links are now fixed.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	ld: bfd: sframe: fix incorrect r_offset in RELA entries
	PR/32666  Incorrect .rela.sframe when using ld -r

	Input SFrame sections are merged using _bfd_elf_merge_section_sframe (),
	which clubs all SFrame FDEs together in one blob and all SFrame FREs in
	another.  This, of course, means the offset of an SFrame FDE in the output
	section cannot be simply derived from the output_offset of the sections.

	Fix this by providing _bfd_elf_sframe_section_offset () which returns
	the new offset of the SFrame FDE in the merged SFrame section.

	Unlike EH_Frame sections, which also use the _bfd_elf_section_offset (),
	to update the r_offset, SFrame sections have distinct merging semantics.
	In case of SFrame, the SFrame FDE will not simply sit at location
	"sec->output_offset + offset of SFrame FDE in sec".  Recall that information
	layout in an SFrame section is as follows:
	   SFrame Header
	   SFrame FDE 1
	   SFrame FDE 2
	   ...
	   SFrame FDEn
	   SFrame FREs (Frame Row Entries)
	Note how the SFrame FDEs and SFrame FREs are clubber together in groups
	of their own.

	Next, also note how the elf_link_input_bfd () does a:
	            irela->r_offset += o->output_offset;
	This, however, needs to be avoided for SFrame sections because the
	placement of all FDEs is at the beginning of the section.  So, rather than
	conditionalizing this as follows:
	          if (o->sec_info_type != SEC_INFO_TYPE_SFRAME)
	            irela->r_offset += o->output_offset;
	the implementation in _bfd_elf_sframe_section_offset () does a reverse
	adjustment, so that the generic parts of the linking process in
	elf_link_input_bfd () are not made to do SFrame specific adjustments.

	Add a new enum to track the current state of the SFrame input section
	during the linking process (SFRAME_SEC_DECODED, SFRAME_SEC_MERGED) for
	each input SFrame section.  This is then used to assert an assumption
	that _bfd_elf_sframe_section_offset () is being used on an input SFrame
	sections which have not been merged (via
	_bfd_elf_merge_section_sframe ()) yet.

	bfd/
	        * elf-bfd.h: New declaration.
	        * elf-sframe.c (_bfd_elf_sframe_section_offset): New definition.
	        * elf.c (_bfd_elf_section_offset): Adjust offset if SFrame
		section.
	ld/testsuite/
	        * ld-x86-64/x86-64.exp: New test.
	        * ld-x86-64/sframe-reloc-1.d: New test.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	bfd: gas: ld: libsframe: adopt new encoding for FDE func start addr field
	This patch convenes a set of changes in bfd, gas, ld, libsframe towards
	moving to the new encoding for the 'sfde_func_start_address' field in
	SFrame FDE.

	First, gas must now mark all SFrame sections with the new flag
	SFRAME_F_FDE_FUNC_START_PCREL.  gas was already emitting the field
	in the said encoding.

		* gas/gen-sframe.c (output_sframe_internal): Emit the flag
		SFRAME_F_FDE_FUNC_START_PCREL.

	Similarly for ld, adopt the new semantics of sfde_func_start_address
	consistently.  This means:
	  - When merging SFrame sections, check that all input SFrame sections
	    have the SFRAME_F_FDE_FUNC_START_PCREL flag set.  If the check
	    fails, ld errors out.
	  - When merging SFrame sections, keep even the in-memory contents of
	    the FDE function start address (buffer passed to libsframe
	    sframe_encoder_write () for writing out) encoded in the new
	    semantics.  While it is, in theory, possible that instead of doing this
	    change here, we adjust the value of sfde_func_start_address at the final
	    write (sframe_encoder_write) time.  But latter is not favorable for
	    maintenanance and may be generally confusing for developers.
	  - When creating SFrame for PLT entries, emit flag
	    SFRAME_F_FDE_FUNC_START_PCREL.

	include/
	        * sframe-api.h (SFRAME_F_LD_MUSTHAVE_FLAGS): New definition.
	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Check for flag
		combinatation SFRAME_F_LD_MUSTHAVE_FLAGS set for all input and
		output SFrame sections.  If not, error out.  Also, adopt the new
	        semantics of function start address encoding.
		* bfd/elfxx-x86.c (_bfd_x86_elf_create_sframe_plt): Emit flag
		SFRAME_F_FDE_FUNC_START_PCREL.

	Next, for dumping SFrame sections, now that we are emitting the same
	encoding in GAS, non-relocatable and relocatable SFrame links, it is the
	time to set relocate to TRUE in debug_displays[].

	binutils/
		* dwarf.c (struct dwarf_section_display): Allow sframe sections
		  to now be relocated.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe-aarch64-pac-ab-key-1.d: Update the
		test.  Relocatable SFrame sections now display non-zero value
		(appropriate function start address).

	Now, as the SFrame sections on-disk and in-memory use the new semantics of
	sfde_func_start_address encoding (i.e., function start address is the
	offset from the sfde_func_start_address field to the start PC), the
	calculation to make it human readable (i.e., relatable to the addresses
	in .text sections) needs adjustment.

	libsframe/
		* sframe-dump.c (dump_sframe_func_with_fres): Adjust the
		function start address for dumping.

	Now that both the emission of the new encoding, and the relocation of
	sections before dumping them is in place, it is time to adjust the
	testcases.

	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe-aarch64-1.d: Update expected output
		to include SFRAME_F_FDE_FUNC_START_PCREL instead of NONE.
		* gas/cfi-sframe/cfi-sframe-aarch64-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-aarch64-3.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-aarch64-4.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-10.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-11.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-3.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-4.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-5.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-6.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-7.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-8.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-9.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-empty-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-empty-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-empty-3.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-empty-4.d: Likewise.
		* gas/cfi-sframe/common-empty-1.d: Likewise.
		* gas/cfi-sframe/common-empty-2.d: Likewise.
		* gas/cfi-sframe/common-empty-3.d: Likewise.
		* gas/scfi/x86_64/scfi-cfi-sections-1.d: Likewise.
		* gas/scfi/x86_64/scfi-dyn-stack-1.d: Likewise.
	ld/testsuite/
		* ld-aarch64/sframe-simple-1.d: Update expected output to
		include SFRAME_F_FDE_FUNC_START_PCREL.
		* ld-x86-64/sframe-ibt-plt-1.d: Likewise.
		* ld-x86-64/sframe-plt-1.d: Likewise.
		* ld-x86-64/sframe-pltgot-1.d: Likewise.
		* ld-x86-64/sframe-pltgot-2.d: Likewise.
		* ld-x86-64/sframe-simple-1.d: Likewise.

	Naturally, the change of semantics for 'SFrame FDE function start address'
	has consequences on the implementation in libsframe.  As per the new
	semantics:
	  - Function start address in the SFrame FDE (sfde_func_start_address)
	    is an offset from the FDE function start address field to the start
	    PC of the associated function.

	Note that, the libsframe library brings the SFrame section contents into
	its own memory to create a sframe_decoder_ctx object via sframe_decode
	().  Many internal and user-interfacing APIs then may use
	sframe_decoder_ctx object to interact and fulfill the work.

	In context of changing semantics for sfde_func_start_address, following
	relevant examples may help understand the impact:
	  - sframe_find_fre () finds a the SFrame stack trace data (SFrame FRE)
	    given a lookup offset (offset of lookup_pc from the start of SFrame
	    section).  Now that the sfde_func_start_address includes the
	    distance from the sfde_func_start_address field to the start of
	    SFrame section itself, the comparison checks of
	    sfde_func_start_address with the incoming lookup offset need
	    adjustment.
	  - Some internal functions (sframe_get_funcdesc_with_addr_internal ()
	    finds SFrame FDE by using binary seach comparing
	    sfde_func_start_address fields, etc.) need adjustments.
	  - sframe_encoder_write () sorts the SFrame FDEs before writing out
	    the SFrame data.  Sorting of SFrame FDE via the internal function
	    sframe_sort_funcdesc() needs adjustments: the new encoding of
	    sfde_func_start_address means the distances are not from the same
	    anchor, so cannot be sorted directly.

	This patch takes the approach of adding a new internal function:
	  - sframe_decoder_get_secrel_func_start_addr (): This function returns
	    the offset of the start PC of the function from the start of SFrame
	    section, i.e., it gives a section-relative offset.

	As the sframe_decoder_get_secrel_func_start_addr () API needs the value
	of the function index in the FDE list, another internal API needs
	sframe_fre_check_range_p () adjustments too.

	Sorting the FDEs (via sframe_sort_funcdesc ()) is done by first bringing
	all offsets in sfde_func_start_address relative to start of SFrame
	section, followed by sorting, and then readjusting the offsets accroding
	to the new position in the FDE list.

	libsframe/
		* sframe.c (sframe_decoder_get_secrel_func_start_addr): New
		static function.
	        (sframe_fre_check_range_p): Adjust the interface a bit.
		(sframe_get_funcdesc_with_addr_internal): Use
		sframe_decoder_get_secrel_func_start_addr () when comparing
		sfde_func_start_address with user input offset.
	        (sframe_find_fre): Adopt the new semantics.
	        (sframe_sort_funcdesc): Likewise.

	For the libsframe testsuite, use the new encoding for FDE func start
	addr: distance between the FDE sfde_func_start_address field and the
	start PC of the function itself.

	Use SFRAME_F_FDE_FUNC_START_PCREL flag, though the sframe_encode ()
	interface in libsframe applies no sanity checks for the encoding itself.

	libsframe/testsuite/
		* libsframe.find/findfre-1.c: Adjust to use the new
		SFRAME_F_FDE_FUNC_START_PCREL specific encoding.
		* libsframe.find/findfunc-1.c: Likewise.
		* libsframe.find/plt-findfre-1.c: Likewise.
		* libsframe/testsuite/libsframe.decode/DATA2: Update data file
		due to usage of new SFRAME_F_FDE_FUNC_START_PCREL flag.
		* libsframe/testsuite/libsframe.encode/encode-1.c: Use flag
		SFRAME_F_FDE_FUNC_START_PCREL.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	objdump, readelf: sframe: apply relocations before textual dump
	PR libsframe/32589 - function start address is zero in SFrame section dump

	Currently, readelf and objdump display the SFrame sections in ET_REL
	object files with function start addresses of each function as 0.  This
	makes it difficult to correlate SFrame stack trace information with the
	individual functions in the object file.

	For objdump, use the dump_dwarf () interface to dump SFrame section.
	Similarly, for readelf, use the display_debug_section () interface to
	dump SFrame section.  These existing interfaces (for DWARF debug
	sections) already support relocating the section contents before
	dumping, so lets use them for SFrame sections as well.

	When adding a new entry for SFrame in debug_option_table[], use char
	'nil' and the option name of "sframe-internal-only".  This is done so
	that there is no additional (unnecessary) user-exposed ways of dumping
	SFrame sections.  Additionally, we explicitly disallow the
	"sframe-internal-only" from external/user input in --dwarf (objdump).
	Similarly, "sframe-internal-only" is explicitly matched and disallowed
	from --debug-dump (readelf).

	For objdump and readelf, we continue to keep the same error messaging as
	earlier:

	  $ objdump --sframe=sframe bubble_sort.o
	  ...
	  No sframe section present

	  $ objdump --sframe=.sfram bubble_sort.o
	  ...
	  No .sfram section present

	  $ objdump --sframe=sframe-internal-only sort
	  ...
	  No sframe-internal-only section present

	Similarly for readelf:

	  $ readelf --sframe= bubble_sort.o
	  readelf: Error: Section name must be provided
	  $ readelf --sframe=.sfram bubble_sort.o
	  readelf: Warning: Section '.sfram' was not dumped because it does not exist
	  $ readelf --sframe=sframe bubble_sort.o
	  readelf: Warning: Section 'sframe' was not dumped because it does not exist

	PS: Note how this patch adds a new entry to debug_displays[] with a
	    relocate value set to FALSE.  This will be set to TRUE in a subsequent
	    patch ("bfd: gas: ld: libsframe: emit func start addr field as an offset
	    from FDE") when fixes are made to emit the value of the
	    'sfde_func_start_address' field in the new encoding
	    SFRAME_F_FDE_FUNC_START_PCREL across gas and ld.

	binutils/
		* dwarf.c (display_sframe): New definition.
		(dwarf_select_sections_all): Enable SFrame section too.
		(struct dwarf_section_display): Add entry for SFrame section.
		* dwarf.h (enum dwarf_section_display_enum): Add enumerator for
		SFrame.
		* objdump.c (dump_section_sframe): Remove.
		(dump_sframe_section): Add new definition.
		(dump_bfd): Use dump_sframe_section.
		* binutils/readelf.c (dump_section_as_sframe): Remove.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	include: sframe: doc: define new flag SFRAME_F_FDE_FUNC_START_PCREL
	Add a new flag SFRAME_F_FDE_FUNC_START_PCREL to SFrame stack trace
	format.  If set, this flag indicates that the function start address
	field (sfde_func_start_address) is the offset to the function start
	address from the SFrame FDE function start address field itself.

	Such an encoding is friendlier to the exisitng PC-REL relocations
	available in the ABIs supported in SFrame: AMD64 (R_X86_64_PC32) and
	AArch64 (R_AARCH64_PREL32).  In subsequent patches, we will make the
	implementation in gas and ld to both:
	  - emit the values in the same (above-mentioned) encoding uniformly.
	  - set the flag SFRAME_F_FDE_FUNC_START_PCREL in the SFrame header
	    for consumers to be able to distinguish.

	Define SFRAME_V2_F_ALL_FLAGS in sframe.h to help keep the implementation
	less error-prone by keeping a set of all defined flags at a central
	place.  Adjust the check in sframe_header_sanity_check_p () to use the
	SFRAME_V2_F_ALL_FLAGS instead.

	Add documentation for SFRAME_F_FDE_FUNC_START_PCREL.  Update the
	documentation about the encoding of the sfde_func_start_address field.

	Also, update the section "Changes from Version 1 to Version 2" to
	include the specification of the new flag SFRAME_F_FDE_FUNC_START_PCREL
	as an erratum to the SFrame Version 2 specification.

	include/
	        * sframe.h (SFRAME_F_FDE_FUNC_START_PCREL): New definition.
	        (SFRAME_V2_F_ALL_FLAGS): Likewise.
	libsframe/
		* sframe-dump.c (dump_sframe_header_flags): Update to include
		the new flag SFRAME_F_FDE_FUNC_START_PCREL.
		* sframe.c (sframe_header_sanity_check_p): Use
		SFRAME_V2_F_ALL_FLAGS.
	libsframe/doc/
		* sframe-spec.texi: Add details about the new flag.  Also update
		the defails about the sfde_func_start_address encoding.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	include: libsframe: add APIs for offsetof FDE func start addr field
	These APIs will be later used by the linker to arrange SFrame FDEs in
	the output SFrame section.

	include/
	        * sframe-api.h (sframe_decoder_get_offsetof_fde_start_addr): New
		declaration.
	        (sframe_encoder_get_offsetof_fde_start_addr): Likewise.

	libsframe/
	        * libsframe.ver: List the new APIs.
	        * sframe.c (sframe_decoder_get_offsetof_fde_start_addr): New
		definition.
	        (sframe_encoder_get_offsetof_fde_start_addr): Likewise.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: refactor code for dumping section flags
	To prepare code for accommodating new flag additions easily as the
	format evolves.

	libsframe/
	        * sframe-dump.c (SFRAME_HEADER_FLAGS_STR_MAX_LEN): Remove.
	        (dump_sframe_header_flags): .. to here. New definition.
	        (PRINT_FLAG): New definition.
	        (dump_sframe_header): Move some implementation from here ..

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	include: libsframe: add APIs for SFrame header flags
	Add new APIs, one each for getting flags from the SFrame decoder and
	SFrame encoder context objects respectively.

	These will later be used by the linker to uniformly access the flags,
	given the SFrame decoder and SFrame encoder objects.

	Use the new API, where applicable, within libsframe.

	include/
	        * sframe-api.h (sframe_decoder_get_flags): New declaration.
	        (sframe_encoder_get_flags): Likewise.
	libsframe/
		* libsframe.ver: List new APIs.
	        * sframe.c (sframe_decoder_get_flags): New definition.
		(sframe_encoder_get_flags): Likewise.
	        (sframe_get_funcdesc_with_addr_internal): Use the new API.
	        (sframe_encoder_get_flags): Likewise.
	        (sframe_encoder_write_sframe): Likewise.

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Remove empty pic-and-nonpic-1-r6.s file
	It was never used, pushed by mistake along with pic-and-nonpic-1a-r6.s.

2025-07-06  Alan Modra  <amodra@gmail.com>

	MIPS: Correct HI/LO rela reloc howto special_function entries
	The patch corrects the mips16 and micromips rela tables to *not*
	use _bfd_mips_elf_{hi,lo}16_reloc.  These special functions are
	inappropriate for RELA relocs where addends are in the reloc rather
	than in the section contents.  See corresponding rela R_MIPS howtos.

	bfd/
		* elf64-mips.c (mips16_elf64_howto_table_rela)
		<R_MIPS16_HI16, R_MIPS16_LO16>: Use _bfd_mips_elf_generic_reloc
		special_function.
		(micromips_elf64_howto_table_rela)
		<R_MICROMIPS_HI16, R_MICROMIPS_LO16>: Similarly.
		* elfn32-mips.c: As for elf64-mips.c.

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/BFD: Fix RELA handling of borrow in the generic linker
	Fix an issue with `_bfd_mips_elf_generic_reloc' not taking into account
	any borrow from the lower part in the handling of relocations of the
	HI/LO kind and resulting in incorrect calculations made for RELA targets
	in the generic used for non-ELF output such as S-records.  This doesn't
	trigger for REL targets because they call `_bfd_mips_elf_generic_reloc'
	indirectly from `_bfd_mips_elf_lo16_reloc' so as to obtain a complete
	32-bit addend from relocation pairs and in calculating the addend the
	latter function uses a hack to work around the lack of borrow handling
	in the former function.

	The MIPS/ELF linker is unaffected as it uses its own calculations.

	Correct the calculation of the relevant partial relocations made in
	`_bfd_mips_elf_generic_reloc' then to take the borrow into account and
	remove the hack from `_bfd_mips_elf_lo16_reloc' as no longer needed.

	Add generic linker test cases accordingly expecting the same disassembly
	from srec output produced as from ELF output produced by the MIPS/ELF
	linker.

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/testsuite: Expand GAS and LD HI/LO relocation coverage
	Expand test coverage for HI/LO relocation handling and add conventional
	MIPS and microMIPS GAS tests as well as conventional MIPS, microMIPS,
	and MIPS16e2 LD tests, covering R_MIPS_HI16, R_MIPS_LO16, R_MIPS16_HI16,
	R_MIPS16_LO16, R_MICROMIPS_HI16, and R_MICROMIPS_LO16 relocations, as
	well as 64-bit R_MIPS_HIGHEST, R_MIPS_HIGHER, R_MICROMIPS_HIGHEST, and
	R_MICROMIPS_HIGHER relocations.

	Modify the linker script so as to retain the `.MIPS.abiflags' section so
	as to disassemble MIPS16e2 code correctly, as MIPS16e2 ASE information
	is only carried in that section and not in ELF file header's `e_flags'.

	MIPS16e2 and microMIPS code requires at least the MIPS32r2 ISA (or the
	MIPS64r2 one for the n32 and n64 ABIs), which is incompatible with the
	`mips:5900' linker output architecture and causes link failures such as:

	./ld-new: tmpdir/mips-hilo1.o: linking mips:isa32r2 module with previous mips:5900 modules
	./ld-new: failed to merge target specific data of file tmpdir/mips-hilo1.o

	Therefore exclude `mips*el-ps2-elf*' targets from microMIPS and MIPS16e2
	LD testing.

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Switch mips16-hilo tests to new disassembly format
	Switch the o32 and n32 mips16-hilo MIPS LD tests to the new disassembly
	format, to reduce discrepancies in output in preparation to reuse for
	generic linker tests.

	Taking the first line of disassembly output as an example the difference
	is:

	00500000 <stuff> 6c00      	li	a0,0

	vs:

	0x0000000000500000 6c00      	li	a0,0

	for ELF and srec input respectively with the currently used older format
	requested with `--prefix-addresses', but with the new disassembly format
	it is exactly the same between the two input formats and no information
	that we need is lost in the transition:

	  500000:	6c00      	li	a0,0

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Remove symbol table output from mips16-hilo tests
	The o32 and n32 mips16-hilo MIPS LD tests request symbol table output
	only to discard it in matching.  The symbol table is not relevant to
	these tests, so remove it from output requested and adjust matching
	patterns accordingly.

	MIPS/testsuite: Fix %hi usage across MIPS16 GAS/LD tests
	Fix a couple of places in MIPS GAS and LD R_MIPS16_HI16/R_MIPS16_LO16
	relocation tests where the %hi operator has been incorrectly used, but
	the %lo operator is expected to complement the preceding %hi operation.

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Fix mips16-hilo IRIX 6 emulation failures
	IRIX 6 emulations place external small common symbols in the regular
	common section instead of the small common section.  With mips16-hilo
	test this leads to a different symbol assignment to memory locations
	between o32 and n32 ABIs, as follows:

	--- o32.map
	+++ n32.map
	@@ -46,23 +46,22 @@
	  *(.sdata)
	                 0x00765430                        . = 0x765430

	-.bss            0x00765430      0x7d8
	+.bss            0x00765430      0x7d9
	  *(.bss)
	  .bss           0x00765430      0x3f0 tmpdir/mips16-hilo.o
	  .bss           0x00765820        0x0 tmpdir/mips16-hilo1.o
	  *(COMMON)
	- COMMON         0x00765820      0x3e8 tmpdir/mips16-hilo.o
	+ COMMON         0x00765820      0x3e9 tmpdir/mips16-hilo.o
	                 0x00765820                big_external_common
	+                0x00765c08                small_external_common

	-.sbss           0x00765c08        0x2
	+.sbss           0x00765c09        0x1
	  *(.sbss)
	- .sbss          0x00765c08        0x1 tmpdir/mips16-hilo.o
	+ .sbss          0x00765c09        0x1 tmpdir/mips16-hilo.o
	  *(.scommon)
	- .scommon       0x00765c09        0x1 tmpdir/mips16-hilo.o
	-                0x00765c09                small_external_common

	 /DISCARD/
	  *(*)
	 LOAD tmpdir/mips16-hilo.o
	 LOAD tmpdir/mips16-hilo1.o
	-OUTPUT(tmpdir/dump elf32-bigmips)
	+OUTPUT(tmpdir/dump elf32-nbigmips)

	which in turn causes a testsuite regression.  Since the specific mapping
	of symbols does not matter for the scope of the test, reorder the small
	common section ahead of SBSS, so that the `small_external_common' symbol
	ends up in the same place regardless of whether via the regular common
	section or the small common section.  Adjust embedded addresses in the
	disassembly expected accordingly, removing the regression concerned:

	mips-sgi-irix6  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs n32
	mips64el-ps2-elf  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs n32

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Unify o32/n32 mips16-hilo test output
	The mips16-hilo MIPS LD test case is supposed to produce the same final
	linked output regardless of whether the o32 or n32 ABI has been chosen
	for assembly.  Reuse o32 output for the n32 test then.

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Set architecture for MIPS16 HI/LO tests
	Remove regressions across MIPSr6 targets with the MIPS16 HI/LO tests,
	which are incompatible with the default architecture of these targets:

	mips-img-elf  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mips-img-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mips64-img-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mips64-img-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs n32
	mips64el-img-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mips64el-img-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs n32
	mipsel-img-elf  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsel-img-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa32r6-elf  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa32r6-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa32r6el-elf  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa32r6el-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa64r6-elf  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa64r6-linux-gnuabi64  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa64r6-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa64r6el-elf  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa64r6el-linux-gnuabi64  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs
	mipsisa64r6el-linux  -FAIL: R_MIPS16_HI16 and R_MIPS16_LO16 relocs

2025-07-06  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/GAS/testsuite: Cover microMIPS HI/LO relocation pairing
	Add a GAS test case for R_MICROMIPS_HI16/R_MICROMIPS_LO16 REL relocation
	pairing, analogous to one for R_MIPS16_HI16/R_MIPS16_LO16 relocations.

	MIPS/GAS/testsuite: Remove useless whitespace from mips16-hilo-match test
	Remove trailing whitespace and extraneous new-line characters from
	mips16-hilo-match.d test case.

2025-07-06  Alan Modra  <amodra@gmail.com>

	gas pending_bundle_size assert
	oss-fuzz managed to trigger this assert, by assembling directives in
	the absolute section.  Avoid this using similar code to that in
	frags.c:frag_new (commit 2dc2dfa7d7a5).

	gas bundle support
	Use valueT when calculating sizes, since fr_fix is that type.
	unsigned int was fine for sane code, but can lose to fuzzed input.

	ubsan: gas resolve_symbol_value
	Avoid signed overflow when resolving constant +/- constant.

2025-07-06  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: fix error code in sframe_decode
	When sanity check of SFrame header fails, set error code to
	SFRAME_ERR_BUF_INVAL instead of the current SFRAME_ERR_NOMEM.

2025-07-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-05  Tom de Vries  <tdevries@suse.de>

	[gdb/tdep] Fix selftest scoped_mmap on freebsd
	On x86_64-freebsd, I run into:
	...
	$ gdb -q -batch -ex "maint selftest scoped_mmap"
	Running selftest scoped_mmap.
	Self test failed: self-test failed at scoped_mmap-selftests.c:50

	Failures:
	  scoped_mmap

	Ran 1 unit tests, 1 failed
	...

	The problem is that this call:
	...
	    ::scoped_mmap smmap (nullptr, sysconf (_SC_PAGESIZE), PROT_WRITE,
				 MAP_ANONYMOUS | MAP_PRIVATE, 0, 0);
	...
	returns MAP_FAILED and sets errno to EINVAL because the argument fd == 0.

	If MAP_ANONYMOUS is used, fd == -1 should be used on freebsd.  On linux, fd is
	ignored but -1 is recommended for portability.

	Fix this by using fd == -1 instead.

	Tested x86_64-freebsd and x86_64-linux.

2025-07-05  Tom de Vries  <tdevries@suse.de>

	[gdb/tdep] Fix doc string of kvm pcb/proc command
	On x86_64-freebsd, I ran into:
	...
	$ gdb -q -batch -ex "maint selftest help_doc_invariants"
	Running selftest help_doc_invariants.
	help doc broken invariant: command 'kvm pcb' help doc first line is not \
	  terminated with a '.' character
	Self test failed: self-test failed at command-def-selftests.c:120

	Failures:
	  help_doc_invariants

	Ran 1 unit tests, 1 failed
	...

	Fix this by adding the missing terminating dot.

	Likewise for the kvm proc command.

	Tested on x86_64-freebsd.

2025-07-05  Andrew Burgess  <aburgess@redhat.com>

	gdb: create gdb.sum/gdb.log summary after using check-all-boards
	Use the contrib/dg-extract-results.sh script to create a gdb.sum and
	gdb.log summary after running the check-all-boards make target.

	Having the results from all the boards merged into a single file
	isn't (maybe) the most useful, but it isn't a bad thing.  However, the
	great thing about merge the results is that the totals are also
	merged.

	The 'check-all-boards' recipe can then extract these totals, just as
	we do for the normal 'check' recipe, this makes is much easier to
	spot if there are any unexpected failures when using
	'check-all-boards'.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

2025-07-05  Andrew Burgess  <aburgess@redhat.com>

	contrib: sync dg-extract-results.{sh,py} with GCC
	Sync the dg-extract-results.{sh,py} scripts with GCC, up to commit
	4e9104ae5455a3c02c2a7e07f52e6bc574cc761d.

	This extends the dg-extract-results scripts to handle GDB's
	'unexpected core files' count.

	contrib/ChangeLog:

		* dg-extract-results.py: Handle GDB's unexpected core file count.
		* dg-extract-results.sh: Likewise.

	Reviewed-By: Keith Seitz <keiths@redhat.com>

2025-07-05  Pietro Monteiro  <pietro@sociotechnical.xyz>

	sim: ppc: use correct macros
	AC_STRUCT_ST_* are the names of the autoconf macros, the C
	preprocessor macros defined by autoconf/authoeader are
	HAVE_STRUCT_STAT_ST_*.

	Approved-By: Andrew Burgess <aburgess@redhat.com>

2025-07-05  Pietro Monteiro  <pietro@sociotechnical.xyz>

	sim: configury: fix obsolete macros
	Running `autoreconf -vf -Wall' in the sim directory shows errors about the use
	of obsolete macros.  This patch fix the issues with macros used or defined in
	the sim directory.  However, it doesn't fix all warnings.  There's 1 autoconf
	warning  from `config/pkg.m4', and many automake warnings about target
	shadowing.  It cuts a lot of the noise down and makes an upgrade to
	autoconf 2.71+ easier.

	- Replace AC_CANONICAL_SYSTEM by AC_CANONICAL_TARGET
	  https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/
	Obsolete-Macros.html#index-AC_005fCANONICAL_005fSYSTEM-1997

	- Replace AC_TRY_COMPILE by AC_COMPILE_IFELSE
	  https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/
	Obsolete-Macros.html#index-AC_005fTRY_005fCOMPILE-2203

	- Replace AC_ERROR by AC_MSG_ERROR
	  https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/
	Obsolete-Macros.html#index-AC_005fERROR-2034

	- Remove AC_TYPE_SIGNAL and replace `RETSIGTYPE' by `void' in the source
	  https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/
	Obsolete-Macros.html#index-AC_005fTYPE_005fSIGNAL-2213

	- Remove AC_STRUCT_ST_BLKSIZE, it's already covered by a AC_CHECK_MEMBERS call
	  https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/
	Obsolete-Macros.html#index-AC_005fSTRUCT_005fST_005fBLKSIZE-2176

	- Remove AC_STRUCT_ST_RDEV, it's already covered by a AC_CHECK_MEMBERS call
	  https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/
	Obsolete-Macros.html#index-AC_005fSTRUCT_005fST_005fRDEV-2180

	- Remove AC_STRUCT_ST_BLOCKS.  It is not obsolete, but it's already covered by a
	AC_CHECK_MEMBERS call.

	- Replace deprecated C macros HAVE_ST_${MEMBER} by HAVE_STRUCT_STAT_ST_${MEMBER}
	  https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/
	Particular-Structures.html#index-AC_005fSTRUCT_005fST_005fBLOCKS-693

	Approved-By: Tom Tromey <tom@tromey.com>

2025-07-05  Pietro Monteiro  <pietro@sociotechnical.xyz>

	gdb: add Pietro Monteiro to gdb/MAINTAINERS

2025-07-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-04  Jan Beulich  <jbeulich@suse.com>

	gas: introduce .errif and .warnif
	Rather than having people resort to indirect means to issue a certain
	kind of diagnostic conditionally upon an expression which can (or
	should) only be evaluated when all sections were sized and all symbols
	had their final values established, provide directives to directly
	achieve this.

2025-07-04  Jan Beulich  <jbeulich@suse.com>

	gas: add a means to programmatically determine the assembler version
	It has been more than once that I would have wanted to have a way to
	know the gas version in assembly sources, perhaps for use with .if. Add
	such a pre-defined symbol, introducing the common pattern GAS(<symbol>)
	for any such symbols. The use of parentheses is to keep the risk of
	collisions with users' symbols as low as possible. (Possible future
	arch-specific symbols may want to use GAS(<arch>:<symbol>).)

	Similarly permit determining whether the assembler is a released
	version. The exact value probably isn't of much use, it's more the
	defined-ness that one might care about. Yet the symbol needs to have
	some value anyway.

	While by default pre-defined symbols won't be emitted to the symbol
	table, introduce -emit-local-absolute to allow requesting this. Re-
	purpose flag_strip_local_absolute to become tristate, with a negative
	value indicating to also emit pre-defined symbols.

2025-07-04  Jan Beulich  <jbeulich@suse.com>

	cris/testsuite: don't use --em=
	Using such abbreviations is fine when written on an interactive command
	line by a human. In scripts and alike, doing so risks colliding with
	later option additions, as is about to occur for gas: Shortly there'll
	be --emit-local-absolute.

2025-07-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-03  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/linux-nat: initialize lwp_info::syscall_state
	When running gdb.base/foll-fork-syscall.exp with a GDB built with UBSan,
	I get:

	    /home/simark/src/binutils-gdb/gdb/linux-nat.c:1906:28: runtime error: load of value 3200171710, which is not a valid value for type 'target_waitkind'
	    ERROR: GDB process no longer exists
	    GDB process exited with wait status 3026417 exp9 0 1
	    UNRESOLVED: gdb.base/foll-fork-syscall.exp: follow-fork-mode=child: detach-on-fork=on: test_catch_syscall: continue to breakpoint after fork

	The error happens here:

	    #0  __sanitizer::Die () at /usr/src/debug/gcc/gcc/libsanitizer/sanitizer_common/sanitizer_termination.cpp:50
	    #1  0x00007ffff600d8dd in __ubsan::__ubsan_handle_load_invalid_value_abort (Data=<optimized out>, Val=<optimized out>) at /usr/src/debug/gcc/gcc/libsanitizer/ubsan/ubsan_handlers.cpp:551
	    #2  0x00005555636d37b6 in linux_handle_syscall_trap (lp=0x7cdff1eb1b00, stopping=0) at /home/simark/src/binutils-gdb/gdb/linux-nat.c:1906
	    #3  0x00005555636e0991 in linux_nat_filter_event (lwpid=3030627, status=1407) at /home/simark/src/binutils-gdb/gdb/linux-nat.c:3044
	    #4  0x00005555636e407f in linux_nat_wait_1 (ptid=..., ourstatus=0x7bfff0d6cf18, target_options=...) at /home/simark/src/binutils-gdb/gdb/linux-nat.c:3381
	    #5  0x00005555636e7795 in linux_nat_target::wait (this=0x5555704d35e0 <the_amd64_linux_nat_target>, ptid=..., ourstatus=0x7bfff0d6cf18, target_options=...) at /home/simark/src/binutils-gdb/gdb/linux-nat.c:3607
	    #6  0x000055556378fad2 in thread_db_target::wait (this=0x55556af42980 <the_thread_db_target>, ptid=..., ourstatus=0x7bfff0d6cf18, options=...) at /home/simark/src/binutils-gdb/gdb/linux-thread-db.c:1398
	    #7  0x0000555564811327 in target_wait (ptid=..., status=0x7bfff0d6cf18, options=...) at /home/simark/src/binutils-gdb/gdb/target.c:2593

	I believe the problem is that lwp_info::syscall_state is never
	initialized.  Fix that by initializing it with TARGET_WAITKIND_IGNORE.
	This is the value we use elsewhere when resetting this field to mean
	"not stopped at a syscall".

	Change-Id: I5b76c63d1466d6e63448fced03305fd5ca8294eb
	Approved-By: Tom Tromey <tom@tromey.com>

2025-07-03  Thiago Jung Bauermann  <thiago.bauermann@linaro.org>

	bfd/aarch64-linux: Support reading and writing the GCS core file note
	Reviewed-By: Luis Machado <luis.machado@arm.com>

2025-07-03  Simon Marchi  <simon.marchi@efficios.com>

	gdb/testsuite: remove spurious whitespace in gdb.python/py-symbol.exp
	Change-Id: I15e307e6910ecbea5a5852e07757f892ea799536

2025-07-03  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/alpha-tdep: add empty line
	This was suggested in review, to separate the comment from the following
	code.

	Change-Id: I077ad4545ee5ef1d362dcfacf585400e26dfdb29

2025-07-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-02  Yodel Eldar  <yodel.eldar@gmail.com>

	gdb/alpha: Redefine fpcr with fpcr_flags type
	This commit adds fpcr_flags and dyn_rm_enum types to define the fpcr.

	For details on the floating-point control register (fpcr), please see
	the Alpha Architecture Reference Manual, 4th Ed. [1]; in brief, it
	consists of a 64-bit bitfield with most bits reserved/unused. All but a
	pair of the used bits are boolean flags; the exception, DYN_RM, is a
	2-bit enum indicating the IEEE rounding mode and is defined as a
	dyn_rm_enum type in the target description annex.

	[1] https://archive.org/details/dec-alpha_arch_ref

	Approved-By: Simon Marchi <simon.marchi@efficios.com>
	Change-Id: Iea54c9e201faae6147a03de124b0368752bce060

2025-07-02  Yodel Eldar  <yodel.eldar@gmail.com>

	gdb/alpha: Add target description support
	This commit adds target description support for Alpha.

	The target description obviates the alpha_register_type and
	alpha_register_name functions in alpha-tdep.c. Removal of
	alpha_register_reggroup_p was considered but ultimately abandoned,
	because the "info regs" command would no longer omit the zero, fpcr, and
	unique registers from its output (they are neither vector nor float
	types).

	Register types in the target description annex match the types that the
	alpha_register_type function returned.

	The locally defined register_names array was moved out of
	alpha_register_name and renamed to alpha_register_names as a static
	global; calls to alpha_register_name have been replaced with direct
	access of the array.

	The patch follows the code pattern outlined in the following GDB
	Internals Wiki entry:

	https://sourceware.org/gdb/wiki/Internals%20Adding-Target-Described-Register-Support

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>
	Approved-By: Simon Marchi <simon.marchi@efficios.com>
	Change-Id: If4b25a891228388519074a31a682e33358c71063

2025-07-02  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Use support_displaced_stepping in gdb.arch/amd64-disp-step-avx.exp
	In commit 8e73fddeb0d ("[gdb/testsuite] Fix gdb.arch/amd64-disp-step-avx.exp
	on x86_64-freebsd") I added a "require {istarget *-*-linux*}", but since then
	I found support_displaced_stepping, which seems more appropriate and
	descriptive.

	Fix this by requiring support_displaced_stepping instead.

	Tested on x86_64-freebsd.

2025-07-02  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.arch/amd64-disp-step-avx.exp on x86_64-freebsd
	With test-case gdb.arch/amd64-disp-step-avx.exp on x86_64-freebsd I run into:
	...
	(gdb) continue
	Continuing.

	Breakpoint 3, test_rip_vex2_end () at amd64-disp-step-avx.S:35
	35		nop
	(gdb) FAIL: $exp: vex2: continue to test_rip_vex2_end
	...

	This happens while executing this bit of the test-case:
	...
	    # Turn "debug displaced" on to make sure a displaced step is actually
	    # executed, not an inline step.
	    gdb_test_no_output "set debug displaced on"

	    gdb_test "continue" \
		"Continuing.*prepared successfully .*Breakpoint.*, ${test_end_label} ().*" \
		"continue to ${test_end_label}"
	...

	The problem is that on x86_64, displaced stepping is only supported for linux.
	Consequently, the "prepared successfully" message is missing.

	Fix this by requiring linux.

	Approved-by: Kevin Buettner <kevinb@redhat.com>

	Tested on x86_64-freebsd.

2025-07-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-07-01  Tom Tromey  <tom@tromey.com>

	Fix handling of terminal escape sequences in TUI
	A user noticed that if the remote sends terminal escape sequences from
	the "monitor" command, then these will not be correctly displayed when
	in TUI mode.

	I tracked this down to remote.c emitting one character at a time --
	something the TUI output functions did not handle correctly.

	I decided in the end to fix in this in the ui-file layer, because the
	same bug seems to affect logging and, as is evidenced by the test case
	in this patch, Python output in TUI mode.

	The idea is simple: buffer escape sequences until they are either
	complete or cannot possibly be recognized by gdb.

	Regression tested on x86-64 Fedora 40.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=14126
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2025-07-01  Jens Remus  <jremus@linux.ibm.com>

	x86: ld: sframe: Remove SFrame NULL FRE template
	A SFrame NULL FRE template is used as NULL value in some but not all
	instances to initialize unused elements of SFrame FRE pointer arrays of
	fixed size.  Additionally it is erroneously used as SFrame FRE template
	for PLT GOT entries.

	Define a separate SFrame FRE template for PLT GOT entries with the same
	properties as the SFrame NULL FRE and use that for all PLT GOT entries.
	Remove the SFrame NULL FRE template, as initialization of unused array
	elements is not required, as demonstrated by the instances where it was
	not done.

	bfd/
		* elf64-x86-64.c (elf_x86_64_sframe_null_fre): Remove.
		(elf_x86_64_sframe_pltgot_fre1): New SFrame FRE template for
		PLT GOT entries.
		(elf_x86_64_sframe_non_lazy_plt,
		elf_x86_64_sframe_non_lazy_ibt_plt): Do not initialize unused
		FRE array elements with elf_x86_64_sframe_null_fre.  Use
		elf_x86_64_sframe_pltgot_fre1 for PLT GOT.
		(elf_x86_64_sframe_plt, elf_x86_64_sframe_ibt_plt): Use
		elf_x86_64_sframe_pltgot_fre1 for PLT GOT.

2025-07-01  Bruce McCulloch  <bruce.mcculloch@oracle.com>

	libctf: doc: add __float128 and SIMD vector classification to spec.
	This patch adds two additional distinct types (__float128 and the SIMD
	vector type generated from the vector_size attribute) to the umbrella of
	two existing types (long double and array, respectively). These types
	were previously invalid, producing CTF_K_UNKNOWN in the case of
	__float128 or a float in the case of the SIMD vector. This patch will
	cleanly allow these types to be represented more accurately without
	breaking back-compat.

	Reviewed-by: Nick Alcock <nick.alcock@oracle.com>

2025-07-01  Nick Alcock  <nick.alcock@oracle.com>

	libctf: add root-visibility-addition test
	libctf/
		* testsuite/libctf-writable/ctf-nonroot-addition.*: New test.

2025-07-01  Nick Alcock  <nick.alcock@oracle.com>

	libctf: create: check the right root-visible flag when adding enumerands
	The root-visible flag we're dealing with here is directly out of the dict,
	not a flag passed in to the API, so it does not have the values CTF_ADD_ROOT
	or CTF_ADD_NONROOT: instead it's simply zero for non-root-visible, nonzero
	otherwise.  Fix the test.

	libctf/
		* ctf-create.c (ctf_add_enumerator): Fix root-visibility test.

2025-07-01  Nick Alcock  <nick.alcock@oracle.com>

	libctf: create: addition of non-root types should not return root types
	If you add a non-root type to a dict, you should always get a new, unique
	type ID back, even if a root-visible type with the same name already exists.
	Unfortunately, if the root-visible type is a forward, and you're adding a
	non-root-visible struct, union, or enum, the machinery to detect forwards
	and promote them to the concrete type fires in this case and returns the
	root-visible type!  If this is an enum being inserted hidden because its
	enumerands conflict with some other enum, this will lead to failure later
	on: in any case, it's seriously counterintuitive to add a non-root- visible
	type and get a root-visible one instead.

	Fix this by checking the root-visible flag properly and only checking for
	forwards if this type is root-visible.  (This may lead to a certain degree
	of proliferation of non-root-visible forwards: we can add a cleanup pass for
	those later if needed.)

	libctf/
		* ctf-create.c (ctf_add_struct_sized): Check the root-visible flag when
		doing forward promotion.
		(ctf_add_union_sized): Likewise.
		(ctf_add_enum): Likewise.

	Reviewed-by: Bruce McCulloch <bruce.mcculloch@oracle.com>

2025-07-01  Alan Modra  <amodra@gmail.com>

	MIPS: Fix addend handling with rela R_MIPS16_GOT16 and R_MICROMIPS_GOT16
	In rela howtos these relocations should not be using
	_bfd_mips_elf_got16_reloc.  That special function is for extracting
	addends from section contents, and only for that (ie. it doesn't
	subtract gp).  Make these rela howtos like the corresponding
	R_MIPS_GOT16 rela howto.

		* elf64-mips.c (mips16_elf64_howto_table_rela <R_MIPS16_GOT16>):
		Use _bfd_mips_elf_generic_reloc.
		(micromips_elf64_howto_table_rela <R_MICROMIPS_GOT16>): Likewise.
		* elfn32-mips.c (elf_mips16_howto_table_rela <R_MIPS16_GOT16>):
		Likewise.
		(elf_micromips_howto_table_rela <R_MICROMIPS_GOT16>): Likewise.

2025-07-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-30  WANG Xuerui  <git@xen0n.name>

	RISC-V: [gprofng] Allow building gprofng without asm/hwprobe.h
	The code is actually able to gracefully fallback if the syscall number
	of riscv_hwprobe is not available at build time, but it still depended
	on the <asm/hwprobe.h> header unconditionally. In certain environments
	such as one of crosstool-NG's Canadian Cross build step (binutils for
	host), or one with very outdated kernel headers, the header will not be
	present, causing the build to fail.

	While the relevant projects/environments should be fixed nevertheless,
	a configure-time check for <asm/hwprobe.h> is helpful for fixing gprofng
	builds with released versions of ct-ng etc.

2025-06-30  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	Fix typos in binutils/dwarf.c
	binutils/ChangeLog
	2025-06-29  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		* dwarf.c: Change "/usrlib64/debug/usr" to "/usr/lib64/debug/usr/" and
		.gun_debugaltlink to .gnu_debugaltlink.

2025-06-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-29  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/solib-target: move make_target_solib_ops out of HAVE_LIBEXPAT
	When building without expat, we get a missing make_target_solib_ops
	error:

	    /usr/bin/ld: arch-utils.o: in function `gdbarch::gdbarch()':
	    /home/simark/src/binutils-gdb/gdb/gdbarch-gen.c:30:(.text+0x15be): undefined reference to `make_target_solib_ops()'

	Fix it by moving make_target_solib_ops out of HAVE_LIBEXPAT.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33118
	Change-Id: I76fe4698c6b71bd76096e6cdcbacf8de42a3eb43
	Tested-by: Thiago Jung Bauermann <thiago.bauermann@linaro.org>

2025-06-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-28  H.J. Lu  <hjl.tools@gmail.com>

	x86-64.exp: Correct pr26808.dump to pr27708.dump
	Change

	verbose "cmp tmpdir/pr27708.out $srcdir/$subdir/pr26808.dump" 1

	to

	verbose "cmp tmpdir/pr27708.out $srcdir/$subdir/pr27708.dump" 1

		* testsuite/binutils-all/x86-64/x86-64.exp: Correct pr26808.dump
		to pr27708.dump.

2025-06-28  Tom de Vries  <tdevries@suse.de>

	[gdb/tdep] Add "maint set console-translation-mode <binary|text>" command
	On MSYS2, say we record a brief gdb session using TERM=dumb script:
	...
	$ gdb -q
	(gdb) print 1
	$1 = 1
	(gdb) q
	...

	When looking at the resulting typescript, we notice something odd:
	...
	$ gdb -q^M
	(gdb) print 1^M
	$1 = 1^M^M
	(gdb) q^M
	...

	For some reason, we have "$1 = 1\r\r\n(gdb) ".

	Looking at the documentation of _setmode [1], it mentions translation mode
	_O_TEXT as a mode in which "\n" is translated into "\r\n" on output.

	So, it looks like this translation happens twice.

	Add a command "maint set console-translation-mode <binary|text>" command that
	allows us to set the translation mode of stdout/stderr to binary, such that we
	get instead:
	...
	$ gdb -q -ex "maint set console-translation-mode binary"^M
	(gdb) print 1^M
	$1 = 1^M
	(gdb) q^M
	...

	Since we run into this in the testsuite, add
	"maint set console-translation-mode binary" to INTERNAL_GDBFLAGS.

	Based on "maint set testsuite-mode on/off" from these patches [2][3] by Pierre
	Muller.

	Compared to that proposal, I dropped the name testsuite-mode, because the
	behaviour is not specific to the testsuite.

	Also I chose values binary/text instead of on/off because eventually there may
	be other translation mode values that we need [4].

	Co-Authored-By: Pierre Muller <muller@sourceware.org>
	Reviewed-By: Eli Zaretskii <eliz@gnu.org>

	[1] https://learn.microsoft.com/en-us/cpp/c-runtime-library/reference/setmode
	[2] https://sourceware.org/legacy-ml/gdb-patches/2013-09/msg00939.html
	[3] https://sourceware.org/legacy-ml/gdb-patches/2013-09/msg00940.html
	[4] https://learn.microsoft.com/en-us/cpp/c-runtime-library/translation-mode-constants

2025-06-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-27  Thiago Jung Bauermann  <thiago.bauermann@linaro.org>

	GDB: maint: Fix build on FreeBSD
	While trying to build current trunk of GDB on FreeBSD 14.3 on aarch64,
	I hit this warning converted to an error:

	In file included from /home/bauermann/src/binutils-gdb/gdb/maint.c:37:
	/home/bauermann/src/binutils-gdb/gdb/maint.h:64:8: error: private field 'm_start_space' is not used [-Werror,-Wunused-private-field]
	   64 |   long m_start_space;
	      |        ^
	1 error generated.
	gmake[2]: *** [Makefile:1973: maint.o] Error 1

	I used the default compiler on this system:

	$ c++ --version
	FreeBSD clang version 19.1.7 (https://github.com/llvm/llvm-project.git llvmorg-19.1.7-0-gcd708029e0b2)
	Target: aarch64-unknown-freebsd14.3
	Thread model: posix
	InstalledDir: /usr/bin

	The problem is that the only two places that use m_start_space are
	guarded by HAVE_USEFUL_SBRK, so also guard the member declaration with
	it.

	Build-tested on aarch64-unknown-freebsd14.3.

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2025-06-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-26  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/solib: C++ify solib_ops
	Convert solib_ops into an abstract base class (with abstract methods,
	some of them with default implementations) and convert all the existing
	solib_ops instances to solib_ops derived classes / implementations.

	Prior to this patch, solib_ops is a structure holding function pointers,
	of which there are only a handful of global instances (in the
	`solib-*.c` files).  When passing an `solib_ops *` around, it's a
	pointer to one of these instances.  After this patch, there are no more
	global solib_ops instances.  Instances are created as needed and stored
	in struct program_space.  These instances could eventually be made to
	contain the program space-specific data, which is currently kept in
	per-program space registries (I have some pending patches for that).

	Prior to this patch, `gdbarch_so_ops` is a gdbarch method that returns a
	pointer to the appropriate solib_ops implementation for the gdbarch.
	This is replaced with the `gdbarch_make_solib_ops` method, which returns
	a new instance of the appropriate solib_ops implementation for this
	gdbarch.  This requires introducing some factory functions for the
	various solib_ops implementation, to be used as `gdbarch_make_solib_ops`
	callbacks.  For instance:

	    solib_ops_up
	    make_linux_ilp32_svr4_solib_ops ()
	    {
	      return std::make_unique<linux_ilp32_svr4_solib_ops> ();
	    }

	The previous code is full of cases of tdep files copying some base
	solib_ops implementation, and overriding one or more function pointer
	(see ppc_linux_init_abi, for instance).  I tried to convert all of this
	is a class hierarchy.  I like that it's now possible to get a good
	static view of all the existing solib_ops variants.  The hierarchy looks
	like this:

	    solib_ops
	    ├── aix_solib_ops
	    ├── darwin_solib_ops
	    ├── dsbt_solib_ops
	    ├── frv_solib_ops
	    ├── rocm_solib_ops
	    ├── svr4_solib_ops
	    │   ├── ilp32_svr4_solib_ops
	    │   ├── lp64_svr4_solib_ops
	    │   ├── linux_ilp32_svr4_solib_ops
	    │   │   ├── mips_linux_ilp32_svr4_solib_ops
	    │   │   └── ppc_linux_ilp32_svr4_solib_ops
	    │   ├── linux_lp64_svr4_solib_ops
	    │   │   └── mips_linux_lp64_svr4_solib_ops
	    │   ├── mips_nbsd_ilp32_svr4_solib_ops
	    │   ├── mips_nbsd_lp64_svr4_solib_ops
	    │   ├── mips_fbsd_ilp32_svr4_solib_ops
	    │   └── mips_fbsd_lp64_svr4_solib_ops
	    └── target_solib_ops
	        └── windows_solib_ops

	The solib-svr4 code has per-arch specialization to provide a
	link_map_offsets, containing the offsets of the interesting fields in
	`struct link_map` on that particular architecture.  Prior to this patch,
	arches would set a callback returning the appropriate link_map_offsets
	by calling `set_solib_svr4_fetch_link_map_offsets`, which also happened
	to set the gdbarch's so_ops to `&svr_so_ops`.  I converted this to an
	abstract virtual method of `struct svr4_solib_ops`, meaning that all
	classes deriving from svr4_solib_ops must provide a method returning the
	appropriate link_map_offsets for the architecture.  I renamed
	`set_solib_svr4_fetch_link_map_offsets` to `set_solib_svr4_ops`.  This
	function is still necessary because it also calls
	set_gdbarch_iterate_over_objfiles_in_search_order, but if it was not for
	that, we could get rid of it.

	There is an instance of CRTP in mips-linux-tdep.c, because both
	mips_linux_ilp32_svr4_solib_ops and mips_linux_lp64_svr4_solib_ops need
	to derive from different SVR4 base classes (linux_ilp32_svr4_solib_ops
	and linux_lp64_svr4_solib_ops), but they both want to override the
	in_dynsym_resolve_code method with the same implementation.

	The solib_ops::supports_namespaces method is new: the support for
	namespaces was previously predicated by the presence or absence of a
	find_solib_ns method.  It now needs to be explicit.

	There is a new progspace::release_solib_ops method, which is only needed
	for rocm_solib_ops.  For the moment, rocm_solib_ops replaces and wraps
	the existing svr4_solib_ops instance, in order to combine the results of
	the two.  The plan is to have a subsequent patch to allow program spaces to have
	multiple solib_ops, removing the need for release_solib_ops.

	Speaking of rocm_solib_ops: it previously overrode only a few methods by
	copying svr4_solib_ops and overwriting some function pointers.  Now, it
	needs to implement all the methods that svr4_solib_ops implements, in
	order to forward the call.  Otherwise, the default solib_ops method
	would be called, hiding the svr4_solib_ops implementation.  Again, this
	can be removed once we have support for multiple solib_ops in a
	program_space.

	There is also a small change in how rocm_solib_ops is activated.  Prior
	to this patch, it's done at the end of rocm_update_solib_list.  Since it
	overrides the function pointer in the static svr4_solib_ops, and then
	overwrites the host gdbarch, so_ops field, it's something that happens
	only once.  After the patch though, we need to set rocm_solib_ops in all
	the program spaces that appear.  We do this in
	rocm_solib_target_inferior_created and in the new
	rocm_solib_target_inferior_execd.  After this, I will explore doing a
	change where rocm_solib_ops is only set when we detect the ROCm runtime
	is loaded.

	Change-Id: I5896b5bcbf8bdb024d67980380feba1ffefaa4c9
	Approved-By: Pedro Alves <pedro@palves.net>

2025-06-26  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/progspace: add solib_ops pointer in program_space
	The subsequent C++ification patch in this series will allocate one
	instance of solib_ops per program space.  That instance will be held in
	struct program_space.  As a small step towards this, add an `solib_ops
	*` field to `struct program_space`.  This field represents the solib_ops
	currently used to manage the solibs in that program space.  Initialize
	it with the result of `gdbarch_so_ops` in `post_create_inferior`, and
	use it whenever we need to do some solib stuff, rather than using
	`gdbarch_so_ops` directly.

	The difficulty here is knowing when exactly to set and unset the solib
	ops.  What I have here passes the testsuite on Linux, but with more
	testing we will probably discover more spots where it's needed.

	The C++ification patch will turn this field into a unique pointer.

	With this patch, the message we get when running "info
	linker-namespaces" becomes always the same, so update the test in
	gdb.base/dlmopen-ns-ids.exp.

	Change-Id: Ide8ddc57328895720fcd645d46dc34491f84c656
	Approved-By: Pedro Alves <pedro@palves.net>
	Reviewed-By: Guinevere Larsen <guinevere@redhat.com>

2025-06-26  Simon Marchi  <simon.marchi@efficios.com>

	gdb/solib: use solib::ops for operations that concern a single solib
	For operations that concern a single solib, use the solib_ops backlink
	added in the previous patch (solib::ops), instead of using the solib_ops
	from the gdbarch.  This is a small / easy step towards not using
	gdbarch_so_ops, which is necessary for the C++ification patch later in
	this series.

	There is no change in behavior expected.

	Change-Id: If80e9ea717a2788bada1cf0940cda3c73933bcff
	Approved-By: Pedro Alves <pedro@palves.net>

2025-06-26  Simon Marchi  <simon.marchi@efficios.com>

	gdb/solib: add solib -> solib_ops backlink
	The subsequent C++ification commit makes it so that one struct solib_ops
	is instantiated for each program space.  For some operations, it will
	then become necessary to be able to get the right solib_ops instance
	from a given solib.  Add an solib -> solib_ops backlink for that.

	Change-Id: Ib95407b3fa5fcfba55cf874e0e9dcd2d43a402e4
	Approved-By: Pedro Alves <pedro@palves.net>

2025-06-26  Simon Marchi  <simon.marchi@efficios.com>

	gdb/solib: fix formatting of "info linker-namespaces" error message
	Add spaces after the first period and add a period at the end, resulting
	in:

	    (gdb) info linker-namespaces
	    ❌️ Current inferior does not support linker namespaces.  Use "info sharedlibrary" instead.

	Change-Id: Ib3f1647cedcdb68852a3c63df26ea3e6f791b1b1
	Approved-By: Pedro Alves <pedro@palves.net>

2025-06-26  Simon Marchi  <simon.marchi@efficios.com>

	gdb/testsuite: check that "info shared" and "info linker-namespaces" before running don't crash
	While writing my solib_ops C++ification series, I broke this, and it
	didn't seem to be caught by the testsuite.  Add a test for those.

	The exact message for "info linker-namespaces" varies depending on the
	solib_ops of the target architecture (whether ops->num_active_namespaces
	is nullptr or not).  For now, just accept any message (a crash will
	still be caught).  A later patch in this series will make the message
	consistent and update this test.

	Change-Id: I6bce2ff317447bbf321fc9cbd2d42c3dcea0c683
	Approved-By: Pedro Alves <pedro@palves.net>

2025-06-26  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: need to know that experiment was created on big-endian machine
	gprofng/ChangeLog
	2025-06-25  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		* configure.ac: Add AC_C_BIGENDIAN.
		* common/config.h.in: Rebuild.
		* configure: Rebuild.
		* libcollector/collector.c (log_header_write): Save big-endian flag.
		* src/DbeSession.h (is_bigendian): New function.
		* src/DbeSession.cc: Likewise.
		* src/Experiment.cc: Set 'bigendian' and 'need_swap_endian'.
		* src/Experiment.h: New field 'bigendian'.
		* src/LoadObject.cc: Remove an unused variable.
		* src/LoadObject.h: Likewise.

2025-06-26  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb: remove some stray "void"
	Fix these little typos from commit 5fe70629ceaf ("Change file
	initialization to use INIT_GDB_FILE macro").

	Change-Id: Ib9ae29988dfda1165de47467087f154624916629

2025-06-26  Nick Clifton  <nickc@redhat.com>

	Updated Spanish translations for opcodes and gas

2025-06-26  Andrew Burgess  <aburgess@redhat.com>

	gdb/testsuite: handle failure to start process for later attach test
	Commit:

	  commit b23903836007d1acaf7f8c059ab000ee83fcebfa
	  Date:   Tue Mar 21 13:01:26 2023 +0100

	      gdb: linux-namespaces: enter user namespace when appropriate

	added a new test gdb.base/user-namespace-attach.exp.  It has been
	reported that this test will sometimes fail, like this:

	  (gdb) attach 184732
	  Attaching to process 184732
	  warning: process 184732 is a zombie - the process has already terminated
	  ptrace: Operation not permitted.
	  (gdb) FAIL: gdb.base/user-namespace-attach.exp: flags=--mount --map-root-user: attach to inferior

	the test tries to run the 'unshare' application.  Sometimes though,
	the application is present, but the set of flags used is not
	supported (maybe due to restrictions on the local machine), so we see
	behaviour like this:

	  $ unshare --mount --map-root-user /bin/true; echo $?
	  unshare: unshare failed: Operation not permitted
	  1

	Handle this case by first running 'unshare' with the same flags, but
	using '/bin/true', if this fails then assume the flags are not
	supported, and skip the test.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33108

2025-06-26  Tom Tromey  <tromey@adacore.com>

	Change file initialization to use INIT_GDB_FILE macro
	This patch introduces a new macro, INIT_GDB_FILE.  This is used to
	replace the current "_initialize_" idiom when introducing a per-file
	initialization function.  That is, rather than write:

	    void _initialize_something ();
	    void
	    _initialize_something ()
	    {
	       ...
	    }

	... now you would write:

	    INIT_GDB_FILE (something)
	    {
	       ...
	    }

	The macro handles both the declaration and definition of the function.

	The point of this approach is that it makes it harder to accidentally
	cause an initializer to be omitted; see commit 2711e475 ("Ensure
	cooked_index_entry self-tests are run").  Specifically, the regexp now
	used by make-init-c seems harder to trick.

	New in v2: un-did some erroneous changes made by the script.

	The bulk of this patch was written by script.
	Regression tested on x86-64 Fedora 41.

2025-06-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-25  Srinath Parvathaneni  <srinath.parvathaneni@arm.com>

	aarch64: Add supports for FEAT_PoPS feature and DC instructions.
	This patch add support for FEAT_PoPS feature which can be enabled
	through +pops command line flag.

	This patch also adds support for following DC instructions and the
	spec can be found here [1].
	1. "dc cigdvaps" enabled on passing +memtag+pops command line flags.
	2. "dc civaps" enabled on passing +pops command line flag.

	[1]: https://developer.arm.com/documentation/ddi0601/2025-03/AArch64-Instructions?lang=en

2025-06-25  Andrew Burgess  <aburgess@redhat.com>

	gdb: remove final m_stream->emit_style_escape calls from pager_file
	After the last commit there were still a couple of calls to
	m_stream->emit_style_escape in the pager_file class.  As discussed in
	the last commit, these are likely wrong, but I'd not been able to
	produce any bugs because of them.

	The reason why there are no bugs is that these calls are, I think,
	entirely redundant.  Consider this block:

	      if (m_wrap_column)
		{
		  /* We are about to insert a newline at an historic
		     location in the WRAP_BUFFER.  Before we do we want to
		     restore the default style.  To know if we actually
		     need to insert an escape sequence we must restore the
		     current applied style to how it was at the WRAP_COLUMN
		     location.  */
		  m_applied_style = m_wrap_style;
		  m_stream->emit_style_escape (ui_file_style ());
		  /* If we aren't actually wrapping, don't output
		     newline -- if chars_per_line is right, we
		     probably just overflowed anyway; if it's wrong,
		     let us keep going.  */
		  m_stream->puts ("\n");
		}

	What we know (see previous commit) is that the call:

	  m_stream->emit_style_escape (ui_file_style ());

	is dangerous as m_stream->m_applied_style is going to be out of sync
	with its current state.  Actually, m_stream->m_applied_style is likely
	to be the default style as it is not updated elsewhere.  So why does
	this not cause problems?

	Well, GDB's style output is always done in tightly scoped regions.
	That means if we want to print some styled output, and then apply a
	wrap point the code might look like this:

	  fprintf_styled (gdb_stdout, file_name_style, "some text");
	  gdb_stdout->wrap_here (4);

	But, after printing 'some text', the style of gdb_stdout will have
	returned to the default style.

	My claim is that, whenever we encounter a wrap_here call, the stream
	in question will _always_ have been returned to the default style.

	This means that, in the block above, the call:

	  m_stream->emit_style_escape (ui_file_style ());

	will never emit anything because it depends on a check against
	m_stream->m_applied_style, which will always mean that the above call
	does nothing.  But that's OK.  By chance, we'll have always placed the
	stream into a default style state anyway, so no harm done.

	Similarly, the other call:

	  /* Having finished inserting the wrapping we should
	     restore the style as it was at the WRAP_COLUMN.  */
	  m_stream->emit_style_escape (m_wrap_style);

	Tries to return m_stream to the state it was in at the point of the
	wrap_here call.  But, as described above, this will always be the
	default style, so the above call will do nothing, but that just
	happens to be exactly what we want!

	So what does this commit do?

	Well, I "fix" the above code by removing the
	m_stream->emit_style_escape calls and replacing them with calls to
	puts, passing in the escape sequence for the required style, but only
	if the m_stream style as tracked by pager_file::m_stream_style
	indicates this is needed.

	Got the reasons given above, this should mean there is no change after
	this patch.  We still shouldn't be emitting any extra escape
	sequences.  But, should we ever manage to get into a state where we
	call wrap_here with a stream in a style other than the default, then
	this should mean things work as expected.

	There should be no user visible changes after this commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-25  Andrew Burgess  <aburgess@redhat.com>

	gdb: styling fixes around and for the pagination prompt
	This commit fixes a couple of issues relating to the pagination
	prompt and styling.  The pagination prompt is this one:

	  --Type <RET> for more, q to quit, c to continue without paging--

	I did try to split this into multiple patches, based on the three
	issues I describe below, but in the end, the fixes were all too
	interconnected, so it ended up as one patch that makes two related,
	but slightly different changes:

	  1. Within the pager_file class, relying on the m_applied_style
	  attribute of the wrapped m_stream, as is done when calling
	  m_stream->emit_style_escape, is not correct, so stop doing that, and

	  2. Failing to update m_applied_style within the pager_file class can
	  leave that attribute out of date, which can then lead to styling
	  errors later on, so ensure m_applied_style is always updated.

	The problems I have seen are:

	  1. After quitting from a pagination prompt, the next command can
	  incorrectly style its output.  This was reported as bug PR
	  gdb/31033, and is fixed by this commit.

	  2. The pagination prompt itself could be styled.  The pagination
	  prompt should always be shown in the default style.

	  3. After continuing the output at a pagination prompt, GDB can fail
	  to restore the default style the next time the output (within the
	  same command) switches back to the default style.

	There are tests for all these issues as part of this patch.

	The pager_file class is a sub-class of wrapped_file, this means that a
	pager_file is itself a ui_file, while it also manages a pointer to a
	ui_file object (called m_stream).  An instance of pager_file can be
	installed as the gdb_stdout ui_file object.

	Output sent to a pager_file is stored within an internal
	buffer (called m_wrap_buffer) until we have a complete line, when the
	content is flushed to the wrapped m_stream.  If sufficient lines have
	been written out then the pager_file will present the pagination
	prompt and allow the user to continue viewing output, or quit the
	current command.

	As a pager_file is a ui_file, it has an m_applied_style member
	variable.

	The managed stream (m_stream) is also a ui_file, and so also has an
	m_applied_style member variable.

	In some places within the pager_file class we attempt to change the
	current style of the m_stream using calls like this:

	  m_stream->emit_style_escape (style);

	See pager_file::emit_style_escape, pager_file::prompt_for_continue,
	and pager_file::puts.  These calls will end up in
	ui_file::emit_style_escape, which tries to skip emitting unnecessary
	style escapes by checking if the requested style matches the current
	m_applied_style value.

	The m_applied_style value is updated by calls to the emit_style_escape
	function.

	The problem here is that most of the time pager_file doesn't change
	the style of m_stream by calling m_stream->emit_style_escape.  Most of
	the time, style changes are performed by pager_file writing the escape
	sequence into m_wrap_buffer, and then later flushing this buffer to
	m_stream by calling m_stream->puts.

	It has to be done this way.  Calling m_stream->emit_style_escape
	would, if it actually changed the style, immediately change the style
	by emitting an escape sequence.  But pager_file doesn't want that, it
	wants the style change to happen later, when m_wrap_buffer is
	flushed.

	To avoid excessive style escape sequences being written into
	m_wrap_buffer, the pager_file::m_applied_style performs a function
	similar to the m_applied_style within m_stream, it tracks the current
	style for the end of m_wrap_buffer, and only allows style escape
	sequences to be emitted if the style is actually changing.

	However, a consequence of this is the m_applied_style within m_stream,
	is not updated, which means it will be out of sync with the actual
	current style of m_stream.  If we then try to make a call to
	m_stream->emit_style_escape, if the style we are changing too happens
	to match the out of date style in m_stream->m_applied_style, then the
	style change will be ignored.

	And this is indeed what we see in pager_file::prompt_for_continue with
	the call:

	  m_stream->emit_style_escape (ui_file_style ());

	As m_stream->m_applied_style is not being updated, it will always be
	the default style, however m_stream itself might not actually be in
	the default style.  This call then will not emit an escape sequence as
	the desired style matches the out of date m_applied_style.

	The fix in this case is to call m_stream->puts directly, passing in
	the escape sequence for the desired style.  This will result in an
	immediate change of style for m_stream, which fixes some of the
	problems described above.

	In fact, given that m_stream's m_applied_style is always going to be
	out of sync, I think we should change all of the
	m_stream->emit_style_escape calls to instead call m_stream->puts.

	However, just changing to use puts doesn't fix all the problems.

	I found that, if I run 'apropos time', then quit at the first
	pagination prompt.  If for the next command I run 'maintenance time' I
	see the expected output:

	  "maintenance time" takes a numeric argument.

	However, everything after the first double quote is given the command
	name style rather than only styling the text between the double
	quotes.

	Here is GDB's stack while printing the above output:

	  #2  0x0000000001050d56 in ui_out::vmessage (this=0x7fff1238a150, in_style=..., format=0x1c05af0 "", args=0x7fff1238a288) at ../../src/gdb/ui-out.c:754
	  #3  0x000000000104db88 in ui_file::vprintf (this=0x3f9edb0, format=0x1c05ad0 "\"%ps\" takes a numeric argument.\n", args=0x7fff1238a288) at ../../src/gdb/ui-file.c:73
	  #4  0x00000000010bc754 in gdb_vprintf (stream=0x3f9edb0, format=0x1c05ad0 "\"%ps\" takes a numeric argument.\n", args=0x7fff1238a288) at ../../src/gdb/utils.c:1905
	  #5  0x00000000010bca20 in gdb_printf (format=0x1c05ad0 "\"%ps\" takes a numeric argument.\n") at ../../src/gdb/utils.c:1945
	  #6  0x0000000000b6b29e in maintenance_time_display (args=0x0, from_tty=1) at ../../src/gdb/maint.c:128

	The interesting frames here are #3, in here `this` is the pager_file
	for GDB's stdout, and this passes its m_applied_style to frame #2 as
	the `in_style` argument.

	If the m_applied_style is wrong, then frame #2 will believe that the
	wrong style is currently in use as the default style, and so, after
	printing 'maintenance time' GDB will switch back to the wrong style.

	So the question is, why is pager_file::m_applied_style wrong?

	In pager_file::prompt_for_continue, there is an attempt to switch back
	to the default style using:

	  m_stream->emit_style_escape (ui_file_style ());

	If this is changed to a puts call (see above) then this still leaves
	pager_file::m_applied_style out of date.

	The right fix in this case is, I think, to instead do this:

	  this->emit_style_escape (ui_file_style ());

	this will update pager_file::m_applied_style, and also send the
	default style to m_stream using a puts call.

	While writing the tests I noticed that I was getting unnecessary style
	reset sequences emitted.

	The problem is that, around pagination, we don't really know what
	style is currently applied to m_stream.  The
	pager_file::m_applied_style tracks the style at the end of
	m_wrap_buffer, but this can run ahead of the current m_stream style.
	For example, if the screen is currently full, such that the next
	character of output will trigger the pagination prompt, if the next
	call is actually to pager_file::emit_style_escape, then
	pager_file::m_applied_style will be updated, but the style of m_stream
	will remain unchanged.  When the next character is written to
	pager_file::puts then the pagination prompt will be presented, and GDB
	will try to switch m_stream back to the default style.  Whether an
	escape is emitted or not will depend on the m_applied_style value,
	which we know is different than the actual style of m_stream.

	It is, after all, only when m_wrap_buffer is flushed to m_stream that
	the style of m_stream actually change.

	And so, this commit also adds pager_file::m_stream_style.  This new
	variable tracks the current style of m_stream.  This really is a
	replacement for m_stream's ui_file::m_applied_style, which is not
	accessible from pager_file.

	When content is flushed from m_wrap_buffer to m_stream then the
	current value of pager_file::m_applied_style becomes the current style
	of m_stream.  But, when m_wrap_buffer is filling up, but before it is
	flushed, then pager_file::m_applied_style can change, but
	m_stream_style will remain unchanged.

	Now in pager_file::emit_style_escape we are able to skip some of the
	direct calls to m_stream->puts() used to emit style escapes.

	After all this there are still a few calls to
	m_stream->emit_style_escape().  These are all in the wrap_here support
	code.  I think that these calls are technically broken, but don't
	actually cause any issues due to the way styling works in GDB.  I
	certainly haven't been able to trigger any bugs from these calls yet.
	I plan to "fix" these in the next commit just for completeness.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=31033

	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-25  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.python/py-warning.exp with python 3.6
	On openSUSE Tumbleweed (with python 3.13), I get:
	...
	(gdb) PASS: gdb.python/py-warning.exp: python gdb.warning("")
	python gdb.warning()^M
	Python Exception <class 'TypeError'>: \
	  function missing required argument 'text' (pos 1)^M
	Error occurred in Python: function missing required argument 'text' (pos 1)^M
	(gdb) PASS: gdb.python/py-warning.exp: python gdb.warning()
	...

	But on openSUSE Leap 15.6 (with python 3.6), I get instead:
	...
	(gdb) PASS: gdb.python/py-warning.exp: python gdb.warning("")
	python gdb.warning()^M
	Python Exception <class 'TypeError'>: \
	  Required argument 'text' (pos 1) not found^M
	Error occurred in Python: Required argument 'text' (pos 1) not found^M
	(gdb) FAIL: gdb.python/py-warning.exp: python gdb.warning()
	...

	Fix this by updating the regexp.

	Tested on x86_64-linux.

	PR testsuite/33104
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33104

2025-06-25  Matthieu Longo  <matthieu.longo@arm.com>

	readelf: invalid error message triggered when last tag is an empty string
	Disclaimer: this issue cannot occur with Object Attributes v1 (OAv1) while
	using the GNU binutils because a value of '\0' (empty string) for a tag
	with a string value is considered as the default value for the attribute,
	and consequently is eliminated by gas from the output object file during
	the serialization.

	An empty string is a valid value for a NTBS tag in both OAv1 and OAv2 [1]
	cases. However, contrarily to OAv1, a OAv2 subsection can be required and
	so, tags in this subsection might have to be present even if the value is
	the default. To comply with this requirement, the OAv2 serializer won't
	drop the default values.

	In the case where a NTBS tag has the value '\0' and is last in the object
	attributes section, the current code in readelf used for dumping the object
	attributes incorrectly detects an overflow, and prints out an error message
	for a corrupted string tag.

	This patch fixes the detection of the overflow so that it now accept an
	empty string in the last tag of the object attributes section.

	It also fixes the previous tests for the empty NTBS case and the non-null
	terminated string one. The fix was also tested in the context of OAv2's
	patch series [1] where the issue was originally detected. No regression
	was found.

	[1]: https://inbox.sourceware.org/binutils/20250509151319.88725-1-matthieu
	     .longo@arm.com/

2025-06-25  Matthieu Longo  <matthieu.longo@arm.com>

	arm testsuite: add two corner cases for EABI string attributes
	The current testsuite for gas/readelf lacked two tests for EABI build
	attributes:
	- one when the final attribute is an empty string.
	- one when the final attribute is a string missing the NULL terminator.

	Those two issues cannot occur with Object Attributes v1 (OAv1) sections
	created by the GNU binutils. Indeed a value of '\0' (empty string) for a
	tag with a string value is considered as the default value for the
	attribute, and consequently is eliminated by Gas from the output object
	file during the serialization.
	However, readelf should be able to process correctly files of an unknown
	origin that could contain those two use cases.

	This patch adds the two tests mentioned above. The first one is marked
	as XFAIL because the empty string is not processed correctly by readelf
	when it is in the last position. The second one passes, but simply print
	out "[...]" without mentioning that the NTBS is corrupted.

	A following patch will fix the bug in readelf, and will amend the newly
	introduced tests.

2025-06-25  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.base/infcall-failure.exp on freebsd
	On x86_64-freebsd with test-case gdb.base/infcall-failure.exp I get:
	...
	(gdb) continue
	Continuing.

	Program received signal SIGSEGV, Segmentation fault.
	Address not mapped to object.
	0x0000000000400522 in func_segfault () at infcall-failure.c:24
	24	  return *p;	/* Segfault here.  */
	Error in testing condition for breakpoint 2:
	The program being debugged was signaled while in a function called from GDB.
	GDB remains in the frame where the signal was received.
	To change this behavior use "set unwind-on-signal on".
	Evaluation of the expression containing the function
	(func_segfault) will be abandoned.
	When the function is done executing, GDB will silently stop.
	(gdb) FAIL: $exp: target_async=on: target_non_stop=on: \
	  run_cond_hits_segfault_test: continue
	...

	The problem is that the regexp in the test-case doesn't expect the
	"Address not mapped to object." bit.

	Fix this by updating the regexp.

	Approved-by: Kevin Buettner <kevinb@redhat.com>

	Tested on x86_64-freebsd and x86_64-linux.

2025-06-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-24  Jiawei  <jiawei@iscas.ac.cn>

	RISC-V: Add Profiles RVA/B23S64 support.
	This patch adds support for the RISC-V Profiles RVA23S64 and RVB23S64.

	Version log:
	Fix wrong test for rvb23s.

	bfd/ChangeLog:

		* elfxx-riscv.c: New Profiles.

	gas/ChangeLog:

		* testsuite/gas/riscv/attribute-rva23s.d: New test.
		* testsuite/gas/riscv/attribute-rvb23s.d: New test.

2025-06-24  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Make gdb.dap/log-message.exp more robust
	PR testsuite/31831 reports the following failure in the
	gdb.dap/log-message.exp test-case (formatted for readability):
	...
	{ "type": "event",
	  "event": "output",
	  "body": {
	    "category": "stdout",
	    "output": "Breakpoint 1 at 0x681: file log-message.c, line 23.\n"
	  },
	  "seq": 13
	}
	FAIL: $exp: logging output (checking body category)
	...
	for a gdb 14.2 based package.

	The output event listed above is a result from the setBreakpoints request.

	The test-case issues the setBreakpoints request and waits for the
	corresponding response, but doesn't wait for the output event, and
	consequently the output event is read by:
	...
	dap_wait_for_event_and_check "logging output" output \
	    {body category} console \
	    {body output} "got 23 - 23 = 0"
	...
	which triggers the failure.

	I'm not able to reproduce this, but it looks worth fixing regardless.

	We're fixing this on trunk though, and the output event looks different, and
	there's one more output event:
	...
	{ "type": "event",
	  "event": "output",
	  "body": {
	    "category": "stdout",
	    "output": "No source file named log-message.c.\n"
	  },
	  "seq": 4
	}
	{ "type": "event",
	  "event": "output",
	  "body": {
	    "category": "stdout",
	    "output": "Breakpoint 1 (-source log-message.c -line 23) pending.\n"
	  },
	  "seq": 5
	}
	...

	Fix this by waiting for these two output events, making the test-case a bit
	more robust.

	It is possible that one or both of these output events will be read by
	dap_check_request_and_response "set breakpoint", and in that case restashing
	them (for which there's currently no infrastructure) would be an easy way of
	handling this.  But I haven't been able to trigger that, so I'm leaving that
	for if and when it does.

	Tested on x86_64-linux.

	Approved-By: Tom Tromey <tom@tromey.com>

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=31831

2025-06-24  Tom Tromey  <tromey@adacore.com>

	Allow DAP "threads" request when inferior is running
	A user pointed out that DAP allows the "threads" request to work when
	the inferior is running.  This is documented in the overview, not the
	specification.

	While looking into this, I found a few other issues:

	* The _thread_name function was not marked @in_gdb_thread.
	  This isn't very important but is still an oversight.

	* DAP requires all threads to have a name -- the field is not optional
	  in the "Thread" type.

	* There was no test examining events resulting from the inferior
	  printing to stdout.

	This patch fixes all these problems.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33080

2025-06-24  Tom Tromey  <tromey@adacore.com>

	Use "MS" for .debug_str
	I changed my system linker to 'mold', but then I saw some gdb test
	failures.  This patch fixes a subset of the failures.

	dw2-strp.exp was failing, and investigating showed that there were two
	.debug_str sections.  I tracked this down to the .S file not using the
	correct section flags.

	This patch fixes this problem, plus the other instances I could find.
	(Strangely, these did not all cause problems, however.)  I also
	changed the DWARF assembler to always use these flags for .debug_str.

2025-06-24  Jan Beulich  <jbeulich@suse.com>

	gas/doc: -v / -version / --version / --verbose
	Split -v from -version/--version. They aren't the same; -v long form is
	--verbose, which so far wasn't mentioned at all.

2025-06-24  Jiawei  <jiawei@iscas.ac.cn>

	RISC-V: Update Profiles string in RV23.
	Update the Profiles string in RV23 to include the extensions 'b' and 'supm'.

	bfd/ChangeLog:

		* elfxx-riscv.c: Update Profiles string in RV23.

	gas/ChangeLog:

		* testsuite/gas/riscv/attribute-19.d: Update test string.
		* testsuite/gas/riscv/attribute-20.d: Ditto.

2025-06-24  Nelson Chu  <nelson@rivosinc.com>

	gas/NEWS: Updated for RISC-V

	ld/NEWS,binutils/NEWS: Updated supports for RISC-V zicfiss and zicfilp

	RISC-V: Fxied failed testsuites when building rv32-linux

2025-06-24  Kito Cheng  <kito.cheng@sifive.com>

	RISC-V: Support for unlabeled landing pad PLT generation
	This patch adds support for generating unlabeled landing pad PLT entries
	for the RISC-V architecture. Unlabeled landing pad will place a LPAD
	instruction at the PLT entry and PLT header, also PLT header will have
	few changes due to the offset is different from the original one.

	Ref: https://github.com/riscv-non-isa/riscv-elf-psabi-doc/pull/417

2025-06-24  Kito Cheng  <kito.cheng@sifive.com>

	RISC-V: Implment the merge logic for GNU_PROPERTY_RISCV_FEATURE_1_AND
	GNU_PROPERTY_RISCV_FEATURE_1_AND will perform a bitwise AND operation
	on the properties of the input files.

2025-06-24  Kito Cheng  <kito.cheng@sifive.com>

	RISC-V: Add GNU_PROPERTY_RISCV_FEATURE_1_CFI_SS and GNU_PROPERTY_RISCV_FEATURE_1_CFI_LP_UNLABELED
	This patch adds two new GNU properties for RISC-V:
	GNU_PROPERTY_RISCV_FEATURE_1_CFI_SS and GNU_PROPERTY_RISCV_FEATURE_1_CFI_LP_UNLABELED.

	We only add readelf and define the properties in this patch.

	Ref: https://github.com/riscv-non-isa/riscv-elf-psabi-doc/pull/417

2025-06-24  Kito Cheng  <kito.cheng@sifive.com>

	RISC-V: Refactor PLT generation
	The goal of this refactor is to improve the possiblity of having
	different PLT generation code for different RISC-V ABIs. The changes
	include:
	- Extract PLT generation logic into individual functions.
	- Keep the PLT generation data in riscv_elf_link_hash_table.

	In the following patches, we will use this framework to implement
	different PLT.

2025-06-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-23  Pawel Kupczak  <pawel.kupczak@intel.com>

	gdb: return after stack alignment skip if current_pc is reached
	Make sure we bail out early from amd64_analyze_prologue if CURRENT_PC
	is reached to avoid unnecessary call to amd64_analyze_frame_setup.

	Approved-By: Andrew Burgess <aburgess@redhat.com>

2025-06-23  Pawel Kupczak  <pawel.kupczak@intel.com>

	gdb: correct endbr64 instruction handling in amd64_analyze_prologue
	Compilers can put a sequence aligning the stack at the entry of a
	function.  However with -fcf-protection enabled, "endbr64" is
	generated before.  Current implementation of amd64 prologue analyzer
	first checks for stack alignment and then for "endbr64", which is not
	correct.  This behavior was introduced with patch "gdb: handle endbr64
	instruction in amd64_analyze_prologue".  In case both are generated,
	prologue will not be skipped.  This patch swaps the order so that
	"endbr64" is checked first and adds a regression test.  i386-tdep
	implementation also already had those checked in the correct order,
	that is stack alignment is after endbr64.

	Given such source compiled with gcc 11.4.0 via:
	gcc -O0 main.c -o main

	```
		#include <alloca.h>

		void
		foo (int id)
		{
		  volatile __attribute__ ((__aligned__ (64))) int a;
		  volatile char *p = (char *) alloca (id * 12);
		  p[2] = 'b';
		}

		int
		main (int argc, char **argv)
		{
		  foo (argc + 1);
		  return 1;
		}
	```

	we get such function entry for foo (generated with objdump -d):
	```
	0000000000001149 <foo>:
	    1149:       f3 0f 1e fa             endbr64
	    114d:       4c 8d 54 24 08          lea    0x8(%rsp),%r10
	    1152:       48 83 e4 c0             and    $0xffffffffffffffc0,%rsp
	    1156:       41 ff 72 f8             push   -0x8(%r10)
	    115a:       55                      push   %rbp
	    115b:       48 89 e5                mov    %rsp,%rbp
	    115e:       41 52                   push   %r10
	    1160:       48 81 ec a8 00 00 00    sub    $0xa8,%rsp
	    1167:       89 7d 8c                mov    %edi,-0x74(%rbp)
	...
	```

	The 3 instructions following endbr64 align the stack.  If we were to set
	a breakpoint on foo, gdb would set it at function's entry:
	```
	(gdb) b foo
	Breakpoint 1 at 0x1149
	(gdb) r
	...
	Breakpoint 1, 0x0000555555555149 in foo ()
	(gdb) disassemble
	Dump of assembler code for function foo:
	=> 0x0000555555555149 <+0>:     endbr64
	   0x000055555555514d <+4>:     lea    0x8(%rsp),%r10
	   0x0000555555555152 <+9>:     and    $0xffffffffffffffc0,%rsp
	   0x0000555555555156 <+13>:    push   -0x8(%r10)
	   0x000055555555515a <+17>:    push   %rbp
	   0x000055555555515b <+18>:    mov    %rsp,%rbp
	   0x000055555555515e <+21>:    push   %r10
	   0x0000555555555160 <+23>:    sub    $0xa8,%rsp
	   0x0000555555555167 <+30>:    mov    %edi,-0x74(%rbp)
	...
	```

	With this patch fixing the order of checked instructions, gdb can
	properly analyze the prologue:
	```
	(gdb) b foo
	Breakpoint 1 at 0x115e
	(gdb) r
	...
	Breakpoint 1, 0x000055555555515e in foo ()
	(gdb) disassemble
	Dump of assembler code for function foo:
	   0x0000555555555149 <+0>:     endbr64
	   0x000055555555514d <+4>:     lea    0x8(%rsp),%r10
	   0x0000555555555152 <+9>:     and    $0xffffffffffffffc0,%rsp
	   0x0000555555555156 <+13>:    push   -0x8(%r10)
	   0x000055555555515a <+17>:    push   %rbp
	   0x000055555555515b <+18>:    mov    %rsp,%rbp
	=> 0x000055555555515e <+21>:    push   %r10
	   0x0000555555555160 <+23>:    sub    $0xa8,%rsp
	   0x0000555555555167 <+30>:    mov    %edi,-0x74(%rbp)
	...
	```

	Approved-By: Andrew Burgess <aburgess@redhat.com>

2025-06-23  Pawel Kupczak  <pawel.kupczak@intel.com>

	gdb: refactor amd64_analyze_prologue
	Refactor amd64_analyze_prologue so it clearly reflects what is the order
	of operations in the prologue that we expect to encounter, as is the
	case for i386's implementation.

	Approved-By: Andrew Burgess <aburgess@redhat.com>

2025-06-23  Andrew Burgess  <aburgess@redhat.com>

	gdb/testsuite: use TESTS from make-check-all.sh
	Update the make-check-all.sh script to use TESTS rather than passing
	the test names within RUNTESTFLAGS.  This addresses the following
	issue:

	I was running some tests like this:

	  make -C gdb check-all-boards TESTS="gdb.base/break*.exp"

	And I was finding that I would get lots of DUPLICATE test results,
	which is not what I expected.

	What's happening here is that the 'make check-all-boards' rule runs
	the 'make-check-all.sh' script, which then runs 'make check' with
	various board files.

	However, passing TESTS=... to the initial 'make check-all-boards'
	command invocation automatically causes the TESTS value to be added to
	the MAKEFLAGS environment variable, this is then picked up by the
	later calls to 'make check'.

	Now, in GDB's testfile/Makefile, we check for TESTS, and if this is
	set, we expand the value and set `expanded_tests_or_none`.  Otherwise,
	if TESTS is not set, expanded_tests_or_none is left empty.

	Finally, when handling 'make check', the value of
	`expanded_tests_or_none` is passed through to dejagnu, along with the
	RUNTESTFLAGS value.

	What this means is that, when make-check-all.sh passes the test names
	in the RUNTESTFLAGS, then dejagnu ends up seeing the list of tests
	twice, once from RUNTESTFLAGS, and once from expanded_tests_or_none,
	and this is why I was seeing duplicate testnames.

	The easiest fix for the above is to have make-check-all.sh pass the
	test names using TESTS="...", this will override the TESTS="..." value
	already present in MAKEFLAGS, and means dejagnu will see the test
	names just once.

	Additionally, this is a start towards allowing parallel test running
	from the make-check-all.sh script.  Parallel test running only works
	if the test names are passed in TESTS, and not in RUNTESTFLAGS.
	Currently, in testsuite/Makefile, if RUNTESTFLAGS is not empty, then
	we force single threaded test running.  But with this change, at least
	for the `local` board, we can now benefit from multi-threaded test
	running, as this board has an empty RUNTESTFLAGS now.  For the other
	boards we'd need to set FORCE_PARALLEL in order to benefit from
	parallel test running, but we'll need to double check that all the
	board files actually support parallel test running first, so I'm
	leaving that for another day.

2025-06-23  H.J. Lu  <hjl.tools@gmail.com>

	objcopy: Don't extend the output section size
	Since the output section contents are copied from the input, don't
	extend the output section size beyond the input section size.

		PR binutils/33049
		* objcopy.c (copy_section): Don't extend the output section
		size beyond the input section size.

2025-06-23  H.J. Lu  <hjl.tools@gmail.com>

	elf: Report corrupted group section
	Report corrupted group section instead of trying to recover.

		PR binutils/33050
		* elf.c (bfd_elf_set_group_contents): Report corrupted group
		section.

2025-06-23  Andrew Burgess  <aburgess@redhat.com>

	gdb: filename completion for pipe command -- the shell command bit
	This commit adds filename completion for the shell command part of
	the pipe command.  This is a follow on from this commit:

	  commit 036e5c0c9121d0ac691dbf408a3bdf2bf3501d0f
	  Date:   Mon May 19 20:54:54 2025 +0100

	      gdb: use quoted filename completion for the shell command

	which fixed the completion for the 'shell' command itself.

	Like with the 'shell' command, we don't offer completions of command
	names pulled from $PATH, we just offer filename completion, which is
	often useful for arguments being passed to commands.  Maybe in the
	future we could add completion for command names too (for both 'pipe'
	and the 'shell' command), but that is left for a future commit.

	There's some additional testing.

2025-06-23  Benjamin Berg  <benjamin@sipsolutions.net>

	gdb: linux-namespaces: enter user namespace when appropriate
	The use of user namespaces is required for normal users to use mount
	namespaces.  Consider trying this as an unprivileged user:

	  $ unshare --mount /bin/true
	  unshare: unshare failed: Operation not permitted

	The problem here is that an unprivileged user doesn't have the
	required permissions to create a new mount namespace.  If, instead, we
	do this:

	  $ unshare --mount --map-root-user /bin/true

	then this will succeed.  The new option causes unshare to create a
	user namespace in which the unprivileged user is mapped to UID/GID 0,
	and so gains all privileges (inside the namespace), the user is then
	able to create the mount namespace as required.

	So, how does this relate to GDB?

	When a user attaches to a process running in a separate mount
	namespace, GDB makes use of a separate helper process (see
	linux_mntns_get_helper in nat/linux-namespaces.c), which will then use
	the `setns` function to enter (or try to enter) the mount namespace of
	the process GDB is attaching too.  The helper process will then handle
	file I/O requests received from GDB, and return the results back to
	GDB, this allows GDB to access files within the mount namespace.

	The problem here is that, switching to a mount namespace requires that
	a process hold CAP_SYS_CHROOT and CAP_SYS_ADMIN capabilities within
	its user namespace (actually it's a little more complex, see 'man 2
	setns').  Assuming GDB is running as an unprivileged user, then GDB
	will not have the required permissions.

	However, if GDB enters the user namespace that the `unshare` process
	created, then the current user will be mapped to UID/GID 0, and will
	have the required permissions.

	And so, this patch extends linux_mntns_access_fs (in
	nat/linux-namespace.c) to first try and switch to the user namespace
	of the inferior before trying to switch to the mount namespace.  If
	the inferior does have a user namespace, and does have elevated
	privileges within that namespace, then this first switch by GDB will
	mean that the second step, into the mount namespace, will succeed.

	If there is no user namespace, or the inferior doesn't have elevated
	privileges within the user namespace, then the switch into the mount
	namespace will fail, just as it currently does, and the user will need
	to give elevated privileges to GDB via some other mechanism (e.g. run
	as root).

	This work was originally posted here:

	  https://inbox.sourceware.org/gdb-patches/20230321120126.1418012-1-benjamin@sipsolutions.net

	I (Andrew Burgess) have made some cleanups to the code to comply with
	GDB's coding standard, and the test is entirely mine.  This commit
	message is also entirely mine -- the original message was very terse
	and required the reader to understand how the various namespaces
	work and interact.  The above is my attempt to document what I now
	understand about the problem being fixed.

	I've left the original author in place as the core of the GDB change
	itself is largely as originally presented, but any inaccuracies in the
	commit message, or problems with the test, are all mine.

	Co-Authored-by: Andrew Burgess <aburgess@redhat.com>

2025-06-23  Andrew Burgess  <aburgess@redhat.com>

	gdb: only use /proc/PID/exe for local f/s with no sysroot
	This commit works around a problem introduced by commit:

	  commit e58beedf2c8a1e0c78e0f57aeab3934de9416bfc
	  Date:   Tue Jan 23 16:00:59 2024 +0000

	      gdb: attach to a process when the executable has been deleted

	The above commit extended GDB for Linux, so that, of the executable
	for a process had been deleted, GDB would instead try to use
	/proc/PID/exe as the executable.

	This worked by updating linux_proc_pid_to_exec_file to introduce the
	/proc/PID/exe fallback.  However, the result of
	linux_proc_pid_to_exec_file is then passed to exec_file_find to
	actually find the executable, and exec_file_find, will take into
	account the sysroot.  In addition, if GDB is attaching to a process in
	a different MNT and/or PID namespace then the executable lookup is
	done within that namespace.

	This all means two things:

	  1. Just because linux_proc_pid_to_exec_file cannot see the
	     executable doesn't mean that GDB is actually going to fail to
	     find the executable, and

	  2. returning /proc/PID/exe isn't useful if we know GDB is then going
	     to look for this within a sysroot, or within some other
	     namespace (where PIDs might be different).

	There was an initial attempt to fix this issue here:

	  https://inbox.sourceware.org/gdb-patches/20250511141517.2455092-4-kilger@sec.in.tum.de/

	This proposal addresses the issue in PR gdb/32955, which is all about
	the namespace side of the problem.  The fix in this original proposal
	is to check the MNT namespace inside linux_proc_pid_to_exec_file, and
	for the namespace problem this is fine.  But we should also consider
	the sysroot problem.

	And for the sysroot problem, the fix cannot fully live inside
	linux_proc_pid_to_exec_file, as linux_proc_pid_to_exec_file is shared
	between GDB and gdbserver, and gdbserver has no sysroot.

	And so, I propose a slightly bigger change.

	Now, linux_proc_pid_to_exec_file takes a flag which indicates if
	GDB (or gdbserver) will look for the inferior executable in the
	local file system, where local means the same file system as GDB (or
	gdbserver) is running in.

	This local file system check is true if:

	  1. The MNT namespace of the inferior is the same as for GDB, and

	  2. for GDB only, the sysroot must either be empty, or 'target:'.

	If the local file system check is false then GDB (or gdbserver) is
	going to look elsewhere for the inferior executable, and so, falling
	back to /proc/PID/exe should not be done, as GDB will end up looking
	for this file in the sysroot, or within the alternative MNT
	namespace (which in also likely to be a different PID namespace).

	Now this is all a bit of a shame really.  It would be nice if
	linux_proc_pid_to_exec_file could return /proc/PID/exe in such a way
	that exec_file_find would know that the file should NOT be looked for
	in the sysroot, or in the alternative namespace.  But fixing that
	problem would be a much bigger change, so for now lets just disable
	the /proc/PID/exe fallback for cases where it might not work.

	For testing, the sysroot case is now tested.

	I don't believe we have any alternative namespace testing.  It would
	certainly be interesting to add some, but I'm not proposing any with
	this patch, so the code for checking the MNT namespace has been tested
	manually by me, but isn't covered by a new test I'm adding here.

	Author of the original fix is listed as co-author here.  Credit for
	identifying the original problem, and proposing a solution belongs to
	them.

	Co-Authored-By: Fabian Kilger <kilger@sec.in.tum.de>
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=32955

2025-06-23  Andrew Burgess  <aburgess@redhat.com>

	gdb: better warning when attaching, and executable is unknown
	Currently, when attaching to a process, if the user hasn't told GDB
	which executable they are going to be debugging, GDB will try to
	figure out the executable from the running process.

	There are two (for this patch) interesting places where this can fail,
	both in exec_file_locate_attach.

	First GDB calls target_pid_to_exec_file, this does target specific
	"stuff" to find the name of the executable file.  If this returns NULL
	then GDB will give a warning and return.

	After this we need to "find" the executable.  This is where we apply
	things like the sysroot in order to transform the executable path.
	This is done by calling exec_file_find, and this too can return NULL
	to indicate that the executable couldn't be found.

	Currently, if exec_file_find returns NULL then GDB doesn't give a
	warning, instead we push on and call try_open_exec_file passing in the
	NULL pointer as the filename string.  This has the effect of removing
	the current executable from the current program space.

	However, exec_file_locate_attach already checks there is no executable
	attached to the current program space.  If there was, then there would
	be no need to try and lookup the executable from the running process.
	So calling try_open_exec_file with a NULL string is, I claim,
	pointless.

	But worse, calling try_open_exec_file with a NULL string means that
	GDB prints the message: "No executable file now.", which, while
	correct, isn't (I think) very helpful.  To me this message indicates
	that we've moved from a state of having an executable to a state of
	not having one, which isn't correct.

	I think we should introduce a new warning in exec_file_locate_attach,
	which is printed if the executable cannot be found.

	So, before this patch GDB's output looked like this:

	  (gdb) attach 12345
	  Attaching to process 12345
	  No executable file now.
	  warning: Could not load vsyscall page because no executable was specified
	  0x00007f0978b94557 in ?? ()
	  (gdb)

	After this patch the output now looks like this:

	  (gdb) attach 12345
	  Attaching to process 12345
	  No executable has been specified, and target executable /tmp/my-exec (deleted) could not be found.  Try using the "file" command.
	  warning: Could not load vsyscall page because no executable was specified
	  0x00007f0978b94557 in ?? ()
	  (gdb)

	This warning includes the name of the file that GDB was looking for,
	and gives a hint that the 'file' command should be used to tell GDB
	which executable is being debugged.  Much better.

	There's no test for this change in this commit.  The next commit fixes
	another (semi-related) bug, and includes a test that checks for this
	warning string.

2025-06-23  Andrew Burgess  <aburgess@redhat.com>

	gdbserver: include sys/stat.h for 'struct stat'
	Tom de Vries reported a build failure on x86_64-w64-mingw32 after
	commit:

	  commit bd389c9515d240f55b117075b43184efdea41287
	  Date:   Wed Jun 11 22:52:16 2025 +0200

	      gdb: implement linux namespace support for fileio_lstat and vFile::lstat

	The build failure looks like this:

	  ../../src/gdbserver/hostio.cc: In function 'void handle_lstat(char*, int*)':
	  ../../src/gdbserver/hostio.cc:544:63: error: cannot convert '_stat64*' to 'stat*'
	    544 |     ret = the_target->multifs_lstat (hostio_fs_pid, filename, &st);
	        |                                                               ^~~
	        |                                                               |
	        |                                                               _stat64*
	  In file included from ./../../src/gdbserver/server.h:58,
	                   from <command-line>:
	  ./../../src/gdbserver/target.h:448:74: note:   initializing argument 3 of 'virtual int process_stratum_target::multifs_lstat(int, const char*, stat*)'
	    448 |   virtual int multifs_lstat (int pid, const char *filename, struct stat *sb);
	        |                                                             ~~~~~~~~~~~~~^~

	The problem is that in sys/stat.h for mingw, 'stat' is #defined to
	_stat64, but target.h doesn't include sys/stat.h, and so doesn't see
	this #define.

	However, target.h does, by luck, manages to see the actual definition
	of 'struct stat', which isn't in sys/stat.h itself, but is in some
	other header that just happens to be pulled in by chance.

	As a result of all this, the declaration of
	process_stratum_target::multifs_lstat in target.h uses 'struct stat'
	for its argument type, while the call in hostio.cc, uses 'struct
	_stat64' as its argument type, which causes the build error seen
	above.

	The fix is to include sys/stat.h in target.h so that the declaration's
	argument type will change to 'struct _stat64' (via the #define).

2025-06-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-21  Stafford Horne  <shorne@gmail.com>

	or1k: Fix disassembly for little-endian binaries
	There are some OpenRISC CPUs that have their binaries stored in
	little-endian format.  Using objdump to disassemble these is
	problematic, as some instructions fail to disassemble, for example:

	    objdump -D -b binary -EB -m or1k test_be.bin

	       0:	18 60 07 27 	l.movhi r3,0x727
	       4:	a8 63 0e 00 	l.ori r3,r3,0xe00
	       8:	9c 63 ff ff 	l.addi r3,r3,-1
	       c:	bc 43 00 00 	l.sfgtui r3,0
	      10:	13 ff ff fe 	l.bf 0x8
	      14:	44 00 48 00 	l.jr r9

	    objdump -D -b binary -EL -m or1k test_le.bin

	       0:	27 07 60 18 	*unknown*
	       4:	00 0e 63 a8 	l.ori r3,r3,0xe00
	       8:	ff ff 63 9c 	*unknown*
	       c:	00 00 43 bc 	l.sfgtui r3,0
	      10:	fe ff ff 13 	*unknown*
	      14:	00 48 00 44 	l.jr r9

	It was found that the hash function was using the still little-endian
	buffer to extract the opcode used for the hash lookup.  This didn't work
	as it was pulling the wrong hashcode causing instruction lookup to fail.

	Fix the hash function by using the normalized/byte-swapped value instead
	of the buffer.

2025-06-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-20  Aleksandar Rikalo  <arikalo@gmail.com>

	gdbsupport: Use xsnprintf() instead of strcat() in print-utils
	Theoretically, in functions core_addr_to_string_nz() and
	core_addr_to_string(), strcat() can overflow, so use a safe
	approach using xsnprintf().

	Change-Id: Ib9437450b3634dc35077234f462a03a8640242d4

2025-06-20  Aleksandar Rikalo  <arikalo@gmail.com>

	gdb: Remove redundant null check
	This patch simplifies the code at two points by removing redundant
	null checks.  There is no functional impact.

	Reviewed-By: Keith Seitz <keiths@redhat.com>
	Approved-By: Pedro Alves <pedro@palves.net>
	Change-Id: I76e1c7fad00e8fcb24ced7bfd75d19cdd6266c32

2025-06-20  Srinath Parvathaneni  <srinath.parvathaneni@arm.com>

	aarch64: Support 2024 Debug Architecture system registers.
	This patch adds support for following system registers and the spec
	can be found here[1].
	1. PMBSR_EL12, PMBSR_EL2, PMBSR_EL3, PMBMAR_EL1 depends on FEAT_SPE
	   and Armv9.5-A architecture and these are enabled by passing
	   -march=armv9.5-a+profile.
	2. TRBSR_EL12, TRBSR_EL2, and TRBSR_EL3 depends Armv9.5-A architecture
	   and these are enabled by passing -march=armv9.5-a.
	3. HFGITR2_EL2 depends on Armv8.8-A architecture and enabled by passing
	   -march=armv8.8-a.

	[1]: https://developer.arm.com/documentation/ddi0601/2025-03/AArch64-Registers?lang=en

2025-06-20  Kirill Radkin  <kirill.radkin@syntacore.com>

	gdbserver: Update require_int function to parse offset for pread packet
	Currently gdbserver uses the require_int() function to parse the
	requested offset (in vFile::pread packet and the like).  This function
	allows integers up to 0x7fffffff (to fit in 32-bit int), however the
	offset (for the pread system call) has an off_t type which can be
	larger than 32-bit.

	This patch allows require_int() function to parse offset up to the
	maximum value implied by the off_t type.

	Approved-By: Pedro Alves <pedro@palves.net>
	Change-Id: I3691bcc1ab1838c0db7f8b82d297d276a5419c8c

2025-06-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-19  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/testsuite: run isort on gdb.server/fileio-packets.py
	`pre-commit run --all-files` found this.

	Change-Id: I8db09b12cf184d32351ff2c579bdaa8cf6f80ac3

2025-06-19  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: change CUs -> units in print_stats
	Change the messages to reflect that these numbers includes type units,
	not only compile units.

	Change-Id: Id2f511d4666e5cf92112be917d72ff76791b7e1d
	Approved-by: Kevin Buettner <kevinb@redhat.com>

2025-06-19  Ezra Sitorus  <ezra.sitorus@arm.com>

	aarch64: Support for FEAT_LSFE
	FEAT_LSFE - Large System Float Extension - implements A64 base atomic
	floating-point in-memory instructions.

2025-06-19  Ezra Sitorus  <ezra.sitorus@arm.com>

	aarch64: Support for FEAT_SVE_F16F32MM, FEAT_F8F16M, FEAT_F8F32MM
	FEAT_SVE_F16F32MM introduces the SVE half-precision floating-point
	matrix multiply-accumulate to single-precision instruction.

	FEAT_F8F32MM introduces the Advanced SIMD 8-bit floating-point matrix
	multiply-accumulate to single-precision instruction.

	FEAT_F8F16MM introduces the Advanced SIMD 8-bit floating-point matrix
	multiply-accumulate to half-precision instruction.

2025-06-19  Ezra Sitorus  <ezra.sitorus@arm.com>

	aarch64: Support for FEAT_CMPBR
	FEAT_CMPBR - Compare and branch instructions. This patch adds these
	instructions:
	- CB<CC> (register)
	- CB<CC> (immediate)
	- CBH<CC>
	- CBB<CC>

	where CC is one of the following:
	- EQ
	- NE
	- GT
	- GE
	- LT
	- LE
	- HI
	- HS
	- LO
	- LS

2025-06-19  Ezra Sitorus  <ezra.sitorus@arm.com>

	aarch64: Add occmo flag for FEAT_OCCMO
	FEAT_OCCMO support was introduced, but the feature flags were missing.
	This patch adds these flags, as well as splitting up the tests to test
	occmo vs occmo+memtag operands.

	aarch64: Support for FEAT_SVE_BFSCALE
	FEAT_SVE_BFSCALE introduces the SVE BFSCALE instruction, when the PE is not in
	Streaming SVE mode. If FEAT_SME2 is implemented, FEAT_SVE_BFSCALE also
	introduces SME multi-vector Z-targeting BFloat16 scaling instructions, BFSCALE
	and BFMUL.

2025-06-19  Andrew Burgess  <aburgess@redhat.com>

	gdb/python: introduce gdb.warning() function
	This commit adds a new gdb.warning() function.  This function takes a
	string and then calls GDB's internal warning() function.  This will
	display the string as a warning.

	Using gdb.warning() means that the message will get the new emoji
	prefix if the user has that feature turned on.  Also, the message will
	be sent to gdb.STDERR without the user having to remember to print to
	the correct stream.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-18  WANG Xuerui  <git@xen0n.name>

	LoongArch: Batch-delete bytes at the end of each relax trip
	Previously, memmove and reloc/symbol adjustments happened at each
	loongarch_relax_delete_bytes() call, which is O(n^2) time complexity and
	leads to unacceptable (multiple hours) linking times for certain inputs
	with huge number of relaxable sites -- see the linked issue for details.

	To get rid of the quadratic behavior, defer all delete ops to the end of
	each relax trip, with the buffer implemented with the splay tree from
	libiberty. The individual relaxation handlers are converted to handle
	symbol values and relocation offsets as if all preceding deletions
	actually happened, by querying a cumulative offset from the splay tree;
	the accesses should be efficient because they are mostly sequential
	during a relaxation trip. The exact relaxation behavior remains largely
	unchanged.

	Example running times before and after the change with the test case in
	the linked issue (mypy transpiled C), cross-linking on Threadripper
	3990X:
	Before: 4192.80s user 1.09s system 98% cpu 1:10:53.52 total
	After:  1.76s user 0.74s system 98% cpu 2.539 total - ~1/2382 the time!

	Also tested with binutils (bootstrapping self), CPython 3.14 and LLVM
	20.1.6; all passed the respective test suites.

	Link: https://github.com/loongson-community/discussions/issues/56

2025-06-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-17  Fabian Kilger  <kilger@sec.in.tum.de>

	gdb: query inferior's filesystem for build-id debug files
	This fixes a bug related to build-id files with linux namespaces.
	Specifically, we expect the debug files to be present inside the container,
	thus the container filesystem should be queried if the program is running
	inside one.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=32956
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2025-06-17  Fabian Kilger  <kilger@sec.in.tum.de>

	gdb: implement linux namespace support for fileio_lstat and vFile::lstat
	The new algorithm to look for a build-id-based debug file
	(introduced by commit 22836ca88591ac7efacf06d5b6db191763fd8aba)
	makes use of fileio_lstat. As lstat was not supported by
	linux-namespace.c, all lstat calls would be performed on the host
	and not inside the namespace.  Fixed by adding namespace lstat
	support.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=32956

	Approved-By: Andrew Burgess <aburgess@redhat.com>

2025-06-17  Andrew Burgess  <aburgess@redhat.com>

	gdbserver: fix vFile:stat to actually use 'stat'
	This commit continues the work of the previous two commits.

	In the following commits I added the target_fileio_stat function, and
	the target_ops::fileio_stat member function:

	  * 08a115cc1c4 gdb: add target_fileio_stat, but no implementations yet
	  * 3055e3d2f13 gdb: add GDB side target_ops::fileio_stat implementation
	  * 6d45af96ea5 gdbserver: add gdbserver support for vFile::stat packet
	  * 22836ca8859 gdb: check for multiple matching build-id files

	Unfortunately I messed up, despite being called 'stat' these function
	actually performed an 'lstat'.  The 'lstat' is the correct (required)
	implementation, it's the naming that is wrong.

	Additionally, to support remote targets, these commit added the
	vFile::stat packet, which again, performed an 'lstat'.

	In the previous two commits I changed the GDB code to replace 'stat'
	with 'lstat' in the fileio function names.  I then added a new
	vFile:lstat packet which GDB now uses instead of vFile:stat.

	And that just leaves the vFile:stat packet which is, right now,
	performing an 'lstat'.

	Now, clearly when I wrote this code I fully intended for this packet
	to perform an lstat, it's the lstat that I needed.  But now, I think,
	we should "fix" vFile:stat to actually perform a 'stat'.

	This is risky.  This is a change in remote protocol behaviour.

	Reasons why this might be OK:

	  - vFile:stat was only added in GDB 16, so it's not been "in the
	    wild" for too long yet.  If we're quick, we might be able to "fix"
	    this before anyone realises I messed up.

	  - The documentation for vFile:stat is pretty vague.  It certainly
	    doesn't explicitly say "this does an lstat".  Most implementers
	    would (I think), given the name, start by assuming this should be
	    a 'stat' (given the name).  Only if they ran the full GDB
	    testsuite, or examined GDB's implementation, would they know to
	    use lstat.

	Reasons why this might not be OK:

	  - Some other debug client could be connecting to gdbserver, sending
	    vFile:stat and expecting to get lstat behaviour.  This would break
	    after this patch.

	  - Some other remote server might have implemented vFile:stat
	    support, and either figured out, or copied, the lstat behaviour
	    from gdbserver.  This remote server would technically be wrong
	    after this commit, but as GDB no longer uses vFile:stat, then this
	    will only become a problem if/when GDB or some other client starts
	    to use vFile:stat in the future.

	Given the vague documentation for vFile:stat, and that it was only
	added in GDB 16, I think we should fix it now to perform a 'stat', and
	that is what this commit does.

	The change in behaviour is documented in the NEWS file.  I've improved
	the vFile:stat documentation in the manual to better explain what is
	expected from this packet, and I've extended the existing test to
	cover vFile:stat.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-17  Andrew Burgess  <aburgess@redhat.com>

	gdbserver: add vFile:lstat packet support
	In the following commits I added the target_fileio_stat function, and
	the target_ops::fileio_stat member function:

	  * 08a115cc1c4 gdb: add target_fileio_stat, but no implementations yet
	  * 3055e3d2f13 gdb: add GDB side target_ops::fileio_stat implementation
	  * 6d45af96ea5 gdbserver: add gdbserver support for vFile::stat packet
	  * 22836ca8859 gdb: check for multiple matching build-id files

	Unfortunately I messed up, despite being called 'stat' these function
	actually performed an 'lstat'.  The 'lstat' is the correct (required)
	implementation, it's the naming that is wrong.

	In the previous commit I fixed the naming within GDB, renaming 'stat'
	to 'lstat' throughout.

	However, in order to support target_fileio_stat (as was) on remote
	targets, the above patches added the vFile:stat packet, which actually
	performed an 'lstat' call.  This is really quite unfortunate, and I'd
	like to do as much as I can to try and clean up this mess.  But I'm
	mindful that changing packets is not really the done thing.

	So, this commit doesn't change anything.

	Instead, this commit adds vFile:lstat as a new packet.

	Currently, this packet is handled identically as vFile:stat, the
	packet performs an 'lstat' call.

	I then update GDB to send the new vFile:lstat instead of vFile:stat
	for the remote_target::fileio_lstat implementation.

	After this commit GDB will never send the vFile:stat packet.

	However, I have retained the 'set remote hostio-stat-packet' control
	flag, just in case someone was trying to set this somewhere.

	Then there's one test in the testsuite which used to disable the
	vFile:stat packet, that test is updated to now disable vFile:lstat.

	There's a new test that does a more direct test of vFile:lstat.  This
	new test can be extended to also test vFile:stat, but that is left for
	the next commit.

	And so, after this commit, GDB sends the new vFile:lstat packet in
	order to implement target_ops::fileio_lstat.  The new packet is more
	clearly documented than vFile:stat is.  But critically, this change
	doesn't risk breaking any other clients or servers that implement
	GDB's remote protocol.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-17  Andrew Burgess  <aburgess@redhat.com>

	gdb: rename target_fileio_stat to target_fileio_lstat
	In the following commits I added the target_fileio_stat function, and
	the target_ops::fileio_stat member function:

	  * 08a115cc1c4 gdb: add target_fileio_stat, but no implementations yet
	  * 3055e3d2f13 gdb: add GDB side target_ops::fileio_stat implementation
	  * 6d45af96ea5 gdbserver: add gdbserver support for vFile::stat packet
	  * 22836ca8859 gdb: check for multiple matching build-id files

	Unfortunately, I messed up when adding this API.  The actual
	underlying call is lstat, not stat.

	This commit tries to clear up some of the confusion by renaming things
	to target_fileio_lstat and target_ops::fileio_lstat.

	After this change the function names now match the underlying
	implementation.

	One problem remains though.  In order to support target_fileio_stat
	for remote target the above patches added the vFile:stat packet to GDB
	and gdbserver.  The implementation of this packet still does an lstat
	though, which is a bit of a shame.  I'm going to try and fix that in
	later commits.

	This commit is just a rename within GDB, there should be no user
	visible changes.

	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-17  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: rename get_cu -> get_unit
	This method returns type units too, so "get_unit" is a better name.

	Change-Id: I6ec9de3f783637a3e206bcaaec96a4e00b4b7d31
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-17  oltolm  <oleg.tolmatcev@gmail.com>

	gdb/dap: allow more requests when the process is running
	Makes it possible to set and remove other types of breakpoints while the
	process is running. Makes debugging more convenient.

	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-17  Timur  <timurgol007@gmail.com>

	gdb/record: Support csrrci instruction in risc-v
	During testing csr instructions in risc-v, it occurs that instruction csrrci
	is unsupported for recording process and there is such warning:
	'warning: Currently this instruction with len 4(100174f3) is unsupported', so
	recording failed. This patch fixes this error.

2025-06-17  timurgol007  <timurgol007@gmail.com>

	gdb: add Timur Golubovich to gdb/MAINTAINERS

2025-06-17  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Set interactive-mode to on
	With MSYS2 and test-case gdb.ada/assign_1.exp, we get:
	...
	(gdb) dir^M
	Reinitialize source path to empty? (y or n) \
	  [answered Y; input not from terminal]^M^M
	Source directories searched: $cdir;$cwd^M^M
	(gdb)
	...

	GDB automatically answers the query, because interactive-mode is off:
	...
	(gdb) show interactive-mode^M
	Debugger's interactive mode is auto (currently off).^M^M
	...

	The correct value is on, because GDB was started in a terminal.

	For some reason, the auto value of interactive-mode is off instead.  According
	to this patch [1], gdb doesn't recognize the pipes used by DejaGnu testsuite
	as an interactive setup.

	Fix this by adding "set interactive-mode on" to INTERNAL_GDBFLAGS, such that
	we get:
	...
	(gdb) dir^M
	Reinitialize source path to empty? (y or n) y^M
	Source directories searched: $cdir;$cwd^M^M
	(gdb)
	...
	and no longer need fixes like commit be740e7cc62 ("testsuite: skip
	confirmation in 'gdb_reinitialize_dir'")

	The fix is essentially the same as in aforementioned patch.

	For consistency, we apply the fix for all platforms.

	Co-Authored-By: Pierre Muller <muller@sourceware.org>
	Approved-By: Tom Tromey <tom@tromey.com>

	[1] https://sourceware.org/legacy-ml/gdb-patches/2013-09/msg00940.html

2025-06-17  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Set TERM to dumb by default
	With MSYS2 and default TERM=xterm-256color (as well as with xterm and ansi), I
	get:
	...
	builtin_spawn gdb -q ...
	^[[6n(gdb) ERROR: GDB never initialized.
	...

	This is not specific to gdb, other tools produce the same CSI sequence, and
	consequently we run into trouble in other places (like get_compiler_info).

	Fix this by default-setting TERM to dumb.

	We do this for all platforms, to avoid test-cases passing on one platform but
	failing on another.

	For test-cases that set TERM to something other than dumb, handle the CSI
	sequence in default_gdb_start.

	Approved-By: Tom Tromey <tom@tromey.com>

	PR testsuite/33072
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33072

2025-06-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-16  Indu Bhagat  <indu.bhagat@oracle.com>

	bfd: fix a minor typo

2025-06-16  Guinevere Larsen  <guinevere@redhat.com>

	gdb/doc: Explain linker namespaces
	Recent GDB commits added more features related to linker namespaces and
	documented them on the manual, but did not add a convenient way for a
	user to understand what they are. This commit adds a quick explanation
	of what they are.

	It also fixes the inconsistency of using "linker namespaces" and
	"linkage namespaces", by always using the first form to avoid user
	confusion.

	Approved-By: Eli Zaretskii <eliz@gnu.org>

2025-06-16  Andrew Burgess  <aburgess@redhat.com>

	gdb/doc: remove stray comma from gdb.flush description
	Remove comma from: gdb.flush([, stream]) .  I suspect this was a copy
	and paste from gdb.write(string [, stream]) where the comma is
	correct.

2025-06-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/amd-dbgapi: disable forward progress requirement in amd_dbgapi_target_breakpoint::check_status
	ROCgdb handles target events very slowly when running a test case like
	this, where a breakpoint is preset on HipTest::vectorADD:

	    for (int i=0; i < numDevices; ++i) {
	      HIPCHECK(hipSetDevice(i));
	      hipLaunchKernelGGL(HipTest::vectorADD, dim3(blocks), dim3(threadsPerBlock), 0, stream[i],
	                        static_cast<const int*>(A_d[i]), static_cast<const int*>(B_d[i]), C_d[i], N);
	    }

	What happens is:

	 - A kernel is launched
	 - The internal runtime breakpoint is hit during the second
	   hipLaunchKernelGGL call, which causes
	   amd_dbgapi_target_breakpoint::check_status to be called
	 - Meanwhile, all waves of the kernel hit the breakpoint on vectorADD
	 - amd_dbgapi_target_breakpoint::check_status calls process_event_queue,
	   which pulls the thousand of breakpoint hit events from the kernel
	 - As part of handling the breakpoint hit events, we write the PC of the
	   waves that stopped to decrement it.  Because the forward progress
	   requirement is not disabled, this causes a suspend/resume of the
	   queue each time, which is time-consuming.

	The stack trace where this all happens is:

	    #32 0x00007ffff6b9abda in amd_dbgapi_write_register (wave_id=..., register_id=..., offset=0, value_size=8, value=0x7fffea9fdcc0) at /home/smarchi/src/amd-dbgapi/src/register.cpp:587
	    #33 0x00005555588c0bed in amd_dbgapi_target::store_registers (this=0x55555c7b1d20 <the_amd_dbgapi_target>, regcache=0x507000002240, regno=470) at /home/smarchi/src/wt/amd/gdb/amd-dbgapi-target.c:2504
	    #34 0x000055555a5186a1 in target_store_registers (regcache=0x507000002240, regno=470) at /home/smarchi/src/wt/amd/gdb/target.c:3973
	    #35 0x0000555559fab831 in regcache::raw_write (this=0x507000002240, regnum=470, src=...) at /home/smarchi/src/wt/amd/gdb/regcache.c:890
	    #36 0x0000555559fabd2b in regcache::cooked_write (this=0x507000002240, regnum=470, src=...) at /home/smarchi/src/wt/amd/gdb/regcache.c:915
	    #37 0x0000555559fc3ca5 in regcache::cooked_write<unsigned long, void> (this=0x507000002240, regnum=470, val=140737323456768) at /home/smarchi/src/wt/amd/gdb/regcache.c:850
	    #38 0x0000555559fab09a in regcache_cooked_write_unsigned (regcache=0x507000002240, regnum=470, val=140737323456768) at /home/smarchi/src/wt/amd/gdb/regcache.c:858
	    #39 0x0000555559fb0678 in regcache_write_pc (regcache=0x507000002240, pc=0x7ffff62bd900) at /home/smarchi/src/wt/amd/gdb/regcache.c:1460
	    #40 0x00005555588bb37d in process_one_event (event_id=..., event_kind=AMD_DBGAPI_EVENT_KIND_WAVE_STOP) at /home/smarchi/src/wt/amd/gdb/amd-dbgapi-target.c:1873
	    #41 0x00005555588bbf7b in process_event_queue (process_id=..., until_event_kind=AMD_DBGAPI_EVENT_KIND_BREAKPOINT_RESUME) at /home/smarchi/src/wt/amd/gdb/amd-dbgapi-target.c:2006
	    #42 0x00005555588b1aca in amd_dbgapi_target_breakpoint::check_status (this=0x511000140900, bs=0x50600014ed00) at /home/smarchi/src/wt/amd/gdb/amd-dbgapi-target.c:890
	    #43 0x0000555558c50080 in bpstat_stop_status (aspace=0x5070000061b0, bp_addr=0x7fffed0b9ab0, thread=0x518000026c80, ws=..., stop_chain=0x50600014ed00) at /home/smarchi/src/wt/amd/gdb/breakpoint.c:6126
	    #44 0x000055555984f4ff in handle_signal_stop (ecs=0x7fffeaa40ef0) at /home/smarchi/src/wt/amd/gdb/infrun.c:7169
	    #45 0x000055555984b889 in handle_inferior_event (ecs=0x7fffeaa40ef0) at /home/smarchi/src/wt/amd/gdb/infrun.c:6621
	    #46 0x000055555983eab6 in fetch_inferior_event () at /home/smarchi/src/wt/amd/gdb/infrun.c:4750
	    #47 0x00005555597caa5f in inferior_event_handler (event_type=INF_REG_EVENT) at /home/smarchi/src/wt/amd/gdb/inf-loop.c:42
	    #48 0x00005555588b838e in handle_target_event (client_data=0x0) at /home/smarchi/src/wt/amd/gdb/amd-dbgapi-target.c:1513

	Fix that performance problem by disabling the forward progress
	requirement in amd_dbgapi_target_breakpoint::check_status, before
	calling process_event_queue, so that we can process all events
	efficiently.

	Since the same performance problem could theoritically happen any time
	process_event_queue is called with forward progress requirement enabled,
	add an assert to ensure that forward progress requirement is disabled
	when process_event_queue is invoked.  This makes it necessary to add a
	require_forward_progress call to amd_dbgapi_finalize_core_attach.  It
	looks a bit strange, since core files don't have execution, but it
	doesn't hurt.

	Add a test that replicates this scenario.  The test launches a kernel
	that hits a breakpoint (with an always false condition) repeatedly.
	Meanwhile, the host process loads an unloads a code object, causing
	check_status to be called.

	Bug: SWDEV-482511
	Change-Id: Ida86340d679e6bd8462712953458c07ba3fd49ec
	Approved-by: Lancelot Six <lancelot.six@amd.com>

2025-06-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/amd-dbgapi: factor out require_forward_progress overload to target one inferior
	A following patch will want to call require_forward_progress for a given
	inferior.  Extract a new require_forward_progress overload from the
	existing require_forward_progress function that targets a specific
	inferior.

	Change-Id: I54f42b83eb8443d4d91747ffbc86eaeb017f1e49
	Approved-by: Lancelot Six <lancelot.six@amd.com>

2025-06-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/amd-dbgapi: pass amd_dbgapi_inferior_info to process_one_event
	Pass the amd_dbgapi_inferior_info object from process_event_queue to
	process_one_event.  Since process_event_queue pulls events for one
	specific inferior, we know for which inferior the event is.  This
	removes the need for process_one_event to do two dbgapi calls to get the
	relevant pid.  If also removes one inferior lookup.

	Change-Id: I22927e4b6251513eb3be95785082058aa3d09954
	Approved-by: Lancelot Six <lancelot.six@amd.com>

2025-06-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/amd-dbgapi: pass amd_dbgapi_inferior_info to process_event_queue
	A following patch will make process_event_queue access a field of
	amd_dbgapi_inferior_info.  Prepare for this by making
	process_event_queue accept an amd_dbgapi_inferior_info object, instead
	of a process id.

	Change-Id: I9adc491dd1ff64ff74c40aa7662fffb11bd8332b
	Approved-by: Lancelot Six <lancelot.six@amd.com>

2025-06-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/amd-dbgapi: add assert in require_forward_progress
	I didn't have a problem in this area, but it seems to me that this
	pre-condition should always hold.  We should only disable forward
	progress requirement if the target says it's ok to do so.  Otherwise, we
	could get in a situation where we wait for events from amd-dbgapi, which
	will never arrive, because amd-dbgapi didn't actually resume things.

	Change-Id: Ifc49f55c7874924b7c47888b8391a07a01d960fc
	Approved-by: Lancelot Six <lancelot.six@amd.com>

2025-06-16  Simon Marchi  <simon.marchi@efficios.com>

	gdb/amd-dbgapi: remove unnecessary AMD_DBGAPI_EVENT_KIND_NONE argument
	Rely on the default value.

	Change-Id: I08c683de005806c5c5d29ed7f9b0c6de81b49a01
	Approved-By: Lancelot Six <lancelot.six@amd.com>

2025-06-16  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.python/py-source-styling-2.exp with TERM=dumb
	When running test-case gdb.python/py-source-styling-2.exp with TERM=dumb, I
	get:
	...
	(gdb) set style enabled on^M
	warning: The current terminal doesn't support styling. \
	  Styled output might not appear as expected.^M
	(gdb) FAIL: $exp: set style enabled on
	...

	Fix this by using with_ansi_styling_terminal on clean_restart.

	Tested on x86_64-linux.

2025-06-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-14  H.J. Lu  <hjl.tools@gmail.com>

	objcopy: Correctly check archive element for LTO IR
	commit 717a38e9a02109fcbcb18bb2ec3aa251e2ad0a0d
	Author: H.J. Lu <hjl.tools@gmail.com>
	Date:   Sun May 4 05:12:46 2025 +0800

	    strip: Add GCC LTO IR support

	added:

	@@ -3744,6 +3768,12 @@ copy_archive (bfd *ibfd, bfd *obfd, const char
	*output_target,
	     goto cleanup_and_exit;
	   }

	+#if BFD_SUPPORTS_PLUGINS
	+      /* Copy LTO IR file as unknown object.  */
	+      if (bfd_plugin_target_p (ibfd->xvec))
	                                ^^^^ A typo, should be this_element.
	+  ok_object = false;
	+      else
	+#endif
	       if (ok_object)
	   {
	     ok = copy_object (this_element, output_element, input_arch);

	to check if the archive element is a LTO IR file.  "ibfd" is the archive
	BFD.  "this_element" should be used to check for LTO IR in the archive
	element.  Fix it by replacing "ibfd" with "this_element".

		PR binutils/33078
		* objcopy.c (copy_archive): Correctly check archive element for
		LTO IR.
		* testsuite/binutils-all/objcopy.exp (strip_test_archive): New.
		Run strip_test_archive.

2025-06-14  Jeremy Bryant  <jb@jeremybryant.net>

	* gdb/doc/gdb.texinfo (Emacs): Refer to Emacs manual
	The manual section on using GDB under Emacs is out-of-date and
	duplicates existing and comprehensive documentation in the Emacs
	manual.

	Replace the section by a short introduction and reference.

	Approved-By: Eli Zaretskii <eliz@gnu.org>

2025-06-14  Stafford Horne  <shorne@gmail.com>

	or1k: Add support for numcores and coreid sprs
	These are needed when running GCC tests for newlib toolchains built with
	multicore support.  Without these SPRs we get the following warnings
	when running tests.

	    spawn or1k-elf-run ./20000112-1.exe^M
	    WARNING: l.mfspr with invalid SPR address 0x80^M
	    WARNING: l.mfspr with invalid SPR address 0x81^M
	    WARNING: l.mfspr with invalid SPR address 0x81^M
	    WARNING: l.mfspr with invalid SPR address 0x81^M

	Support is added by defining the SPRs in the cgen machine definition and
	regenerating the machine code.  In or1k/or1k.c we initialize NUMCORES to
	1 and COREID to 0 as the sim has only one CPU.  In or1k/traps.c we allow
	returning the NUMCORES and COREID spr values in the mfspr function.

2025-06-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-13  Simon Marchi  <simon.marchi@polymtl.ca>

	gdbsupport: make gdb::parallel_for_each's n parameter a template parameter
	This value will likely never change at runtime, so we might as well make
	it a template parameter.  This has the "advantage" of being able to
	remove the unnecessary param from gdb::sequential_for_each.

	Change-Id: Ia172ab8e08964e30d4e3378a95ccfa782abce674
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-13  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb: re-work parallel-for-selftests.c
	I find this file difficult to work with and modify, due to how it uses
	the preprocessor to include itself, to generate variations of the test
	functions.  Change it to something a bit more C++-y, with a test
	function that accepts a callback to invoke the foreach function under
	test.

	Change-Id: Ibf1e2907380a88a4f8e4b4b88df2b0dfd0e9b6c8

2025-06-13  Simon Marchi  <simon.marchi@efficios.com>

	gdb/dwarf: make cooked_index_flag's to_string handle IS_SYNTHESIZED
	Change-Id: Iaac252aa2abbe169153e79b84f956cda172c69d1

2025-06-13  Jan Beulich  <jbeulich@suse.com>

	x86: don't constrain %axl/%cxl
	They can be used like their %al/%cl counterparts everywhere else;
	there's no apparent reason why they shouldn't be usable as accumulator /
	shift count respectively. Enforcing such a restriction only makes
	writing heavily macro-ized code more cumbersome.

2025-06-13  Jan Beulich  <jbeulich@suse.com>

	x86: swap operands in OUT-with-immediate template
	In a number of places we assume that immediates come first in the set of
	operands. It is mere luck that so far OUT, having operands the other way
	around, wasn't negatively impacted by this.

	Leverage this to have a few loops start from the first non-immediate
	operand (or in one case to stop there). Note, however, that
	process_immext() inserts an immediate last, so especially all output_*()
	functions cannot be changed in the same way.

2025-06-13  H.J. Lu  <hjl.tools@gmail.com>

	elf: Return false if output_section is NULL
	Return false if output_section is NULL so that on input

	https://sourceware.org/bugzilla/attachment.cgi?id=16131

	objcopy generates

	objcopy: /tmp/objcopy-poc(OrcError.cpp.o): invalid entry (0x22000000) in group [3]
	objcopy: /tmp/objcopy-poc(OrcError.cpp.o): invalid entry (0x21000000) in group [3]
	objcopy: /tmp/objcopy-poc(OrcError.cpp.o)(.text._ZNK12_GLOBAL__N_116OrcErrorCategory7messageB5cxx11Ei): relocation 29 has invalid symbol index 1160982879
	objcopy: /tmp/stv73zYw/OrcError.cpp.o[.text._ZN4llvm3orc8orcErrorENS0_12OrcErrorCodeE]: bad value

	instead of

	objcopy: /tmp/objcopy-poc(OrcError.cpp.o): invalid entry (0x22000000) in group [3]
	objcopy: /tmp/objcopy-poc(OrcError.cpp.o): invalid entry (0x21000000) in group [3]
	objcopy: /tmp/objcopy-poc(OrcError.cpp.o)(.text._ZNK12_GLOBAL__N_116OrcErrorCategory7messageB5cxx11Ei): relocation 29 has invalid symbol index 1160982879
	Segmentation fault (core dumped)

		PR binutils/33075
		* elf.c (elf_map_symbols): Return false if output_section is
		NULL.

2025-06-13  Jan Beulich  <jbeulich@suse.com>

	x86: refine UD<n> kind-of-insns
	While documentation of these continues to be lacking sufficient detail,
	it is becoming increasingly clear that in 66f1eba0b7e8 ("x86: correct
	UDn") I went too far with requiring operands, to populate a ModR/M byte.
	AMD hardware appears to always behave as indicated as "may" in PM 3.36,
	which for all practical purposes means there's no ModR/M byte. The SDM
	(rev 087) indicates that such behavior can occur on older hardware for
	UD0. Re-add an operand-less UD1 form (as well as its UD2B alias), while
	newly adding such a form also for UD0. Because of the ambiguity, there's
	no good/easy way of handling both possibilities in the disassembler,
	which hence remains unaltered.

	Further, from all information I'm able to gather, the 0F opcode space
	was only introduced with the i286; bump the minimal hardware requirement
	for all UD<n> accordingly.

2025-06-13  Jan Beulich  <jbeulich@suse.com>

	gas: switch convert_to_bignum() to taking just an expression
	Both callers, despite spelling things differently, now pass the same
	input for its 2nd parameter. Therefore, as was supposed to be the case
	anyway, this 2nd parameter isn't needed anymore - the function can
	calculate "sign" all by itself from the incoming expression. Instead
	make the function return the resulting value, for emit_expr_with_reloc()
	to consume for setting its "extra_digit" local variable.

2025-06-13  Jan Beulich  <jbeulich@suse.com>

	gas: also maintain signed-ness for O_big expressions
	Interestingly emit_leb128_expr() already assumes X_unsigned is properly
	set for O_big. Adjust its conversion-to-bignum to respect the incoming
	flag, and have convert_to_bignum() correctly set it on output.

	It further can't be quite right that convert_to_bignum() depends on
	anything other than the incoming expression. Therefore adjust
	emit_expr_with_reloc() to be in line with the other invocation.

	This also requires an adjustment for SH, which really should have been
	part of 762acf217c40 ("gas: maintain O_constant signedness in more
	cases").

2025-06-13  Jeremy Drake  <sourceware-bugzilla@jdrake.com>

	bfd: populate delay import directory in PE header
	Previously, the delay import table was constructed but its rva and size
	were never put into the PE optional header.

	dlltool: respect use-nul-prefixed-import-tables option for delaylib
	Noticed the extra zeros while inspecting the output.

	ld,dlltool: move read-only delayimp data into .rdata
	This allows the delay IAT to be in its own section with nothing else, as
	required by IMAGE_GUARD_DELAYLOAD_IAT_IN_ITS_OWN_SECTION, documented at
	https://learn.microsoft.com/en-us/windows/win32/debug/pe-format#load-configuration-layout

2025-06-13  LIU Hao  <lh_mouse@126.com>
	    Jeremy Drake  <sourceware-bugzilla@jdrake.com>

	bfd,ld,dlltool: Emit delay-load import data into its own section
	A delay-import symbol (of a function) is resolved when a call to it is made.
	The delay loader may overwrite the `__imp_` pointer to the actual function
	after it has been resolved, which requires the pointer itself be in a
	writeable section.

	Previously it was placed in the ordinary Import Address Table (IAT), which
	is emitted into the `.idata` section, which had been changed to read-only
	in db00f6c3aceabbf03acdb69e74b59b2d2b043cd7, which caused segmentation
	faults when functions from delay-import library were called.  This is
	PR 32675.

	This commit makes DLLTOOL emit delay-import IAT into `.didat`, as specified
	by Microsoft. Most of the code is copied from `.idata`, except that this
	section is writeable.  As a side-effect of this, PR 14339 is also fixed.

	Using this DEF:

	   ```
	   ; ws2_32.def
	   LIBRARY "WS2_32.DLL"
	   EXPORTS
	     WSAGetLastError
	   ```

	and this C program:

	   ```
	   // delay.c
	   #define WIN32_LEAN_AND_MEAN 1
	   #include <windows.h>
	   #include <stdio.h>

	   /////////////////////////////////////////////////////////
	   // User code
	   /////////////////////////////////////////////////////////

	   DWORD WINAPI WSAGetLastError(void);
	   extern PVOID __imp_WSAGetLastError;

	   int
	   main(void)
	     {
	       fprintf(stderr, "before delay load, __imp_WSAGetLastError = %p\n", __imp_WSAGetLastError);
	       SetLastError(123);
	       fprintf(stderr, "WSAGetLastError() = %d\n", WSAGetLastError());
	       fprintf(stderr, "after delay load, __imp_WSAGetLastError = %p\n", __imp_WSAGetLastError);
	       __imp_WSAGetLastError = (PVOID) 1234567;
	       fprintf(stderr, "after plain write, __imp_WSAGetLastError = %p\n", __imp_WSAGetLastError);
	     }

	   /////////////////////////////////////////////////////////
	   // Overridden `__delayLoadHelper2` facility
	   /////////////////////////////////////////////////////////

	   extern char __ImageBase[];
	   PVOID WINAPI ResolveDelayLoadedAPI(PVOID ParentModuleBase, LPCVOID DelayloadDescriptor,
	                                      PVOID FailureDllHook, PVOID FailureSystemHook,
	                                      FARPROC* ThunkAddress, ULONG Flags);
	   FARPROC WINAPI DelayLoadFailureHook(LPCSTR name, LPCSTR function);

	   FARPROC WINAPI __delayLoadHelper2(LPCVOID pidd, FARPROC* ppfnIATEntry)
	   {
	     return ResolveDelayLoadedAPI(&__ImageBase, pidd, NULL, (PVOID) DelayLoadFailureHook,
	                                  ppfnIATEntry, 0);
	   }
	   ```

	This program used to crash:

	   ```
	   $ dlltool -nn -d ws2_32.def -y delay_ws2_32.a
	   $ gcc -g delay.c delay_ws2_32.a -o delay.exe
	   $ ./delay.exe
	   before delay load, __imp_WSAGetLastError = 00007FF6937215C6
	   Segmentation fault
	   ```

	After this commit, it loads and calls `WSAGetLastError()` properly, and
	`__imp_WSAGetLastError` is writeable:

	   ```
	   $ dlltool -nn -d ws2_32.def -y delay_ws2_32.a
	   $ gcc -g delay.c delay_ws2_32.a -o delay.exe
	   $ ./delay.exe
	   before delay load, __imp_WSAGetLastError = 00007FF76E2215C6
	   WSAGetLastError() = 123
	   after delay load, __imp_WSAGetLastError = 00007FFF191FA720
	   after plain write, __imp_WSAGetLastError = 000000000012D687
	   ```

	Reference: https://learn.microsoft.com/en-us/windows/win32/secbp/pe-metadata#import-handling

2025-06-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-12  Tom Tromey  <tromey@adacore.com>

	Minor grammar fix in DAP comment
	I noticed a minor grammer issue in a comment in DAP.

2025-06-12  Klaus Gerlicher  <klaus.gerlicher@intel.com>

	gdb, linespec: avoid multiple locations with same PC
	Setting a BP on a line like this would incorrectly yield two BP locations:

	01 void two () { {int var = 0;} }

	(gdb) break 1
	Breakpoint 1 at 0x1164: main.cpp:1. (2 locations)

	(gdb) info breakpoints
	Num     Type           Disp Enb Address            What
	1       breakpoint     keep y   <MULTIPLE>
	1.1                         y   0x0000000000001164 in two() at main.cpp:1
	1.2                         y   0x0000000000001164 in two() at main.cpp:1

	In this case decode_digits_ordinary () returns two SALs, exactly matching the
	requested line.  One for the entry PC and one for the prologue end PC.  This
	was
	tested with GCC, CLANG and ICPX.  Subsequent code tries to skip the prologue
	on these PCs, which in turn makes them the same.

	To fix this, ignore SALs with the same PC and program space when adding to the
	list of SALs.

	This will then properly set only one location:

	(gdb) break 1
	Breakpoint 1 at 0x1164: file main.cpp, line 1

	(gdb) info breakpoints
	Num     Type           Disp Enb Address            What
	1       breakpoint     keep y   0x0000000000001164 in two() at main.cpp:1

	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2025-06-12  Andrew Burgess  <aburgess@redhat.com>

	gdb: convert linux-namespaces debug to the new(er) debug scheme
	Convert 'set debug linux-namespaces' to the new(er) debug scheme.  As
	part of this change I converted the mnsh_debug_print_message function,
	which previously printed its output, to instead return a std::string,
	this string is then printed using linux_namespaces_debug_printf.  The
	mnsh_debug_print_message function is only used as part of the debug
	output.

	I also updated one place in the code where debug_linux_namespaces, the
	debug control variable, which is a boolean, was assigned an integer.

	When debug is turned on then clearly the output is now different, but
	in all other cases, there should be no user visible change in GDB
	after this commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-12  Richard Ball  <Richard.Ball@arm.com>

	aarch64: Add support for FEAT_FPRCVT
	FEAT_FPRCVT introduces new versions of previous instructions.
	The instructions are used to convert between floating points and
	Integers. These new versions take as operands SIMD&FP registers
	for both the source and destination register. FEAT_FPRCVT also
	enables the use of some existing AdvSIMD instructions in
	streaming mode. However, no changes are needed in gas to support this.

2025-06-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-11  Aaron Griffith  <aargri@gmail.com>

	gdb: fix size of z80 "add ii,rr" and "ld (ii+d),n" instructions
	The tables in z80-tdep.c previously either gave these instructions the
	wrong size, or failed to recognize them by using the wrong masks, or
	both. The fixed instructions alongside their representation in octal are:

	* add ii,rr:   [0335] 00r1 (where r & 1 == 1)
	               [0375] 00r1
	* ld (ii+d,n): [0335] 0066 <d> <n>
	               [0375] 0066 <d> <n>

	Prefix bytes inside [] do not count towards instruction length in
	these tables.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33066
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-11  Thiago Jung Bauermann  <thiago.bauermann@linaro.org>

	GDB: doc: Improve AArch64 subsubsection titles and index entries in gdb.texinfo
	Remove period from subsubsection titles in the AArch64 configuration-specific
	subsection, and expand acronyms.

	Regarding @cindex entries, remove periods and standardise their order
	and the position of "AArch64" to make it easier to find them by
	using the index-searching commands of Info readers that offer TAB
	completion.

	Approved-By: Eli Zaretskii <eliz@gnu.org>

2025-06-11  Matthieu Longo  <matthieu.longo@arm.com>

	Arm tests: reduce objdump's output and improve some matching patterns
	Linker scripts can change the sections order in the output. Some matching
	patterns in tests try to detect the end of a section by detecting the
	beginning of the next one. However, they mistakenly enforce the name of
	the next section without any need. This caused the tests to break due to
	minor changes to the linker scripts.

	This patch adds '-j <interesting-section>' to the arguments of objdump
	to dump only relevant information for the tests. This removed the issue
	related to the ordering of the sections. The matching patterns were also
	made stricter to match better the expected output.

2025-06-11  Pedro Alves  <pedro@palves.net>

	gdb testsuite: Introduce allow_multi_inferior_tests and use it throughout
	The Windows port does not support multi-process debugging.  Testcases
	that want to exercise multi-process currently FAIL and some hit
	cascading timeouts.  Add a new allow_multi_inferior_tests procedure,
	meant to be used with require, and sprinkle it throughout testcases as
	needed.

	Approved-by: Kevin Buettner <kevinb@redhat.com>
	Change-Id: I4a10d8f04f9fa10f4b751f140ad0a6d31fbd9dfb

2025-06-11  Pedro Alves  <pedro@palves.net>

	gdb testsuite: Introduce allow_fork_tests and use it throughout
	Cygwin debugging does not support follow fork.  There is currently no
	interface between the debugger and the Cygwin runtime to be able to
	intercept forks and execs.  Consequently, testcases that try to
	exercise fork/exec all FAIL, and several hit long cascading timeouts.

	Add a new allow_fork_tests procedure, meant to be used with require,
	and sprinkle it throughout testcases that exercise fork.

	Note that some tests currently are skipped on targets other than
	Linux, with something like:

	 # Until "set follow-fork-mode" and "catch vfork" are implemented on
	 # other targets...
	 #
	 if {![istarget "*-linux*"]} {
	     continue
	 }

	However, some BSD ports also support fork debugging nowadays, and the
	testcases were never adjusted...  That is why the new allow_fork_tests
	procedure doesn't look for linux.

	With this patch, on Cygwin, I get this:

	 $ make check TESTS="*/*fork*.exp"

	 ...
			 === gdb Summary ===

	 # of expected passes            6
	 # of untested testcases         1
	 # of unsupported tests          31

	Reviewed-By: Keith Seitz <keiths@redhat.com>
	Change-Id: I0c5e8c574d1f61b28d370c22a0b0b6bc3efaf978

2025-06-11  Pedro Alves  <pedro@palves.net>

	gdb.multi/attach-no-multi-process.exp: Detect no remote non-stop
	Running gdb.multi/attach-no-multi-process.exp on Cygwin, where
	GDBserver does not support non-stop mode, I see:

	 FAIL: gdb.multi/attach-no-multi-process.exp: target_non_stop=off: info threads
	 FAIL: gdb.multi/attach-no-multi-process.exp: target_non_stop=on: attach to the program via remote (timeout)
	 FAIL: gdb.multi/attach-no-multi-process.exp: target_non_stop=on: info threads (timeout)

	Let's ignore the first "info threads" fail.  The timeouts look like
	this:

	 builtin_spawn /home/alves/gdb-cache-cygwin/gdb/../gdbserver/gdbserver --once --multi localhost:2346
	 Listening on port 2346
	 target extended-remote localhost:2346
	 Remote debugging using localhost:2346
	 Non-stop mode requested, but remote does not support non-stop
	 (gdb) gdb_do_cache: can_spawn_for_attach (  )
	 builtin_spawn /home/alves/gdb/build-cygwin-testsuite/outputs/gdb.multi/attach-no-multi-process/attach-no-multi-process
	 attach 14540
	 FAIL: gdb.multi/attach-no-multi-process.exp: target_non_stop=on: attach to the program via remote (timeout)
	 info threads
	 FAIL: gdb.multi/attach-no-multi-process.exp: target_non_stop=on: info threads (timeout)

	Note the "Non-stop mode requested, but remote does not support
	non-stop" line.

	The intro to gdb_target_cmd_ext says:

	 # gdb_target_cmd_ext
	 # Send gdb the "target" command.  Returns 0 on success, 1 on failure, 2 on
	 # unsupported.

	That's perfect here, we can just use gdb_target_cmd_ext instead of
	gdb_target_cmd, and check for 2 (unsupported).  That's what this patch
	does.

	However gdb_target_cmd_ext incorrectly returns 1 instead of 2 for the
	case where the remote target says it does not support non-stop.  That
	is also fixed by this patch.

	With this, we no longer get those timeout fails.  We get instead:

	 target extended-remote localhost:2346
	 Remote debugging using localhost:2346
	 Non-stop mode requested, but remote does not support non-stop
	 (gdb) UNSUPPORTED: gdb.multi/attach-no-multi-process.exp: target_non_stop=on: non-stop RSP

	Approved-by: Kevin Buettner <kevinb@redhat.com>
	Change-Id: I1ab3162f74200c6c02a17a0600b102d2d12db236

2025-06-11  Pedro Alves  <pedro@palves.net>

	Convert gdb.base/watchpoint-hw-attach.exp to spawn_wait_for_attach
	On Cygwin, starting an inferior under GDB, and detaching it, quitting
	GDB, and then closing the shell, like so:

	  (gdb) start
	  (gdb) detach
	  (gdb) quit
	  # close shell

	... hangs the parent shell of GDB (not GDB!) until the inferior
	process that was detached (as it is still using the same terminal GDB
	was using) exits too.

	This leads to odd failures in gdb.base/watchpoint-hw-attach.exp like
	so:

	 detach
	 Detaching from program: .../outputs/gdb.base/watchpoint-hw-attach/watchpoint-hw-attach, process 16580
	 [Inferior 1 (process 16580) detached]
	 (gdb) FAIL: gdb.base/watchpoint-hw-attach.exp: detach

	Fix this by converting the testcase to spawn the inferior outside GDB,
	with spawn_wait_for_attach.

	With this patch, the testcase passes cleanly on Cygwin, for me.

	Approved-By: Tom Tromey <tom@tromey.com>
	Change-Id: I8e3884073a510d6fd2fff611e1d26fc808adc4fa

2025-06-11  dongjianqiang (A)  <dongjianqiang2@huawei.com>

	ld: arm32: fix segfault when linking foreign BFDs [PR32870]
	PR ld/32870

	The linker may occasionally need to process a BFD that is from a
	non-Arm architecture.  There will not be any Arm-specific tdata in
	that case, so skip such BFDs when looking for iplt information as the
	necessary tdata will not be present.

2025-06-11  Tom Tromey  <tromey@adacore.com>

	Fix Solaris build
	Commit 58984e4a ("Use gdb::function_view in iterate_over_threads")
	broke the Solaris build.  This patch attempts to fix it, changing
	find_signalled_thread to have the correct signature, and correcting a
	couple of problems in sol_thread_target::get_ada_task_ptid.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33073

2025-06-11  Jan Beulich  <jbeulich@suse.com>

	ld/PE: special-case relocation types only for COFF inputs
	In 72cd2c709779 ("ld/PE: no base relocs for section (relative) ones") I
	made a pre-existing problem quite a bit worse: When looking at a
	relocation's (numerical) howto->type, that value is meaningful only if
	the object was of corresponding COFF type. ELF objects in particular
	have their own enumeration. As it stands, specifically the not entirely
	unusual R_X86_64_32 and R_X86_64_32S did no longer have relocations
	emitted for them, due to matching R_AMD64_SECTION and R_AMD64_SECREL in
	value respectively.

	arm: ignore inapplicable .arch=no...
	Unlike for command line options, where a base architecture needs to be
	provided explicitly, the .arch directive doesn't have such a
	requirement. Therefore it is odd that disabling of an inapplicable
	extension isn't silently ignored; claiming "not allowed for the current
	base architecture" is at best misleading. Alter the error path to emit a
	more "soft" diagnostic in that case instead.

2025-06-11  Matthieu Longo  <matthieu.longo@arm.com>

	AArch64 variant PCS tests: remove RWX permissions on segments
	The symbols of variant PCS functions require special handling. The variant PCS
	tests check both the relocation information and the markings in the symbol table.
	Those tests dump a lot of addresses, so a custom linker script, variant_pcs.ld
	was used to control reliably the addresses of the sections.

	However, the linker script does not provide information enough to the linker to
	assess the right set of permisssions on segments (i.e. Read/Write/Execute).
	This insufficiency caused the linker to bundle all the sections in a same segment
	with the union of all the required permissions, i.e. RWX.
	A segment with such lax permissions constitutes a security hole, so the linker
	emits the following warning message:
	    <ELF file> has a LOAD segment with RWX permissions.
	This warning message is noisy in the tests, and has no reason to exist.

	This issue can be addressed in two ways:
	- either by providing the right set of permissions on a section so that the
	  linker assigns them to a segment with compatible permissions.
	- or by providing alignment constraints so that the linker can move the sections
	  automatically to a new segment and set the right permission for non-executable
	  data.

	The second option seems to be the preferred approach, even if not explicitly
	recommended. Examples of linker scripts for AArch64 are available at [1].
	This patch reorganizes the linker script to eliminate RWX segments by changing
	the order of the sections and their offset. The tests needed to be amended to
	match the new addresses.

	[1]: https://developer.arm.com/documentation/dui0474/m/gnu-ld-script-support-in
	     -armlink/default-gnu-ld-scripts-used-by-armlink/default-ld-script-when
	     -building-an-executable?lang=en

2025-06-11  Matthieu Longo  <matthieu.longo@arm.com>

	AArch64 BTI/PAC PLT tests: remove RWX permissions on segments
	The bti-far.ld and bti-plt.ld scripts don't provide information enough to the
	linker to assess the right set of permisssions on segments (i.e. Read/Write/Execute).
	This insufficiency caused the linker to bundle all the sections in a same segment
	with the union of all the required permissions, i.e. RWX.
	A segment with such lax permissions constitutes a security hole, so the linker
	emits the following warning message:
	    <ELF file> has a LOAD segment with RWX permissions.
	This warning message is noisy in the tests, and has no reason to exist.

	This issue can be addressed in two ways:
	- either by providing the right set of permissions on a section so that the
	  linker assigns them to a segment with compatible permissions.
	- or by providing alignment constraints so that the linker can move the sections
	  automatically to a new segment and set the right permission for non-executable
	  data.

	The second option seems to be the preferred approach, even if not explicitly
	recommended. Examples of linker scripts for AArch64 are available at [1].
	The fixes in bti-far.ld and bti-plt.ld are the same, except that bti-far.ld also
	contains a ".far" section, to make sure that it generates the trampolines correctly.

	[1]: https://developer.arm.com/documentation/dui0474/m/gnu-ld-script-support-in
	     -armlink/default-gnu-ld-scripts-used-by-armlink/default-ld-script-when
	     -building-an-executable?lang=en

2025-06-11  Matthieu Longo  <matthieu.longo@arm.com>

	AArch64 tests: remove RWX permissions on segments
	aarch64.ld is the linker script used by most of the relocation tests in AArch64
	testsuite. The script does not provide information enough to the linker to assess
	the right set of permisssions on segments (i.e. Read/Write/Execute).
	This insufficiency caused the linker to bundle all the sections in a same segment
	with the union of all the required permissions, i.e. RWX.
	A segment with such lax permissions constitutes a security hole, so the linker
	emits the following warning message:
	    <ELF file> has a LOAD segment with RWX permissions.
	This warning message is noisy in the tests, and has no reason to exist.

	This issue can be addressed in two ways:
	- either by providing the right set of permissions on a section so that the
	  linker assigns them to a segment with compatible permissions.
	- or by providing alignment constraints so that the linker can move the sections
	  automatically to a new segment and set the right permission for non-executable
	  data.

	The second option seems to be the preferred approach, even if not explicitly
	recommended. Examples of linker scripts for AArch64 are available at [1].

	[1]: https://developer.arm.com/documentation/dui0474/m/gnu-ld-script-support-in
	     -armlink/default-gnu-ld-scripts-used-by-armlink/default-ld-script-when
	     -building-an-executable?lang=en

2025-06-11  Yury Khrustalev  <yury.khrustalev@arm.com>

	aarch64: Add system registers for 2024 MPAM extension
	This patch adds support for new system registers introduced in the
	2024 MPAM extension (Memory Partitioning and Monitoring):

	Available in Armv9.3-A:
	  MPAMBW0_EL1,
	  MPAMBW1_EL1,
	  MPAMBW1_EL12,
	  MPAMBW2_EL2,
	  MPAMBW3_EL3,
	  MPAMBWCAP_EL2,
	  MPAMBWIDR_EL1

	Available in Armv9.3-A with SME:
	  MPAMBWSM_EL1

	The details can be found in [1].

	[1]: https://developer.arm.com/documentation/ddi0601/latest

2025-06-11  Yury Khrustalev  <yury.khrustalev@arm.com>

	aarch64: Add definitions for missing architecture bits
	Complete macros for feature bits for v9.1-A, v9.2-A, v9.3-A,
	and v9.4-A.

2025-06-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-10  Alan Modra  <amodra@gmail.com>

	gas md_apply_fix value casts
	These are all innocuous but unneeded.  pdp11 and ppc are only formatting.

	gas md_apply_fix bad casts
	ns32k and z8k cast a valueT pointer to a long pointer when loading
	md_apply_fix's value.  That's quite wrong if the types have different
	sizes, as they may eg. on a 32-bit host with 64-bit bfd support.
	sparc also loads the value via a cast pointer, but at least in that
	case the cast is to the same size pointer.  None of these casts are
	needed.  Get rid of them.

2025-06-10  Alan Modra  <amodra@gmail.com>

	loongarch gcc-4.5 build fixes
	Yet another case of missing fields in struct initialisation, which
	I've replaced with a memset, and some complaints about identifiers
	shadowing global declarations.  Fixing the shadowing in
	loongarch-parse.y is easy.  This one isn't so easy:
	gas/expr.c: In function 'expr':
	gas/expr.c:1891:12: error: declaration of 'is_unsigned' shadows a global declaration
	include/opcode/loongarch.h:224:14: error: shadowed declaration is here

	opcode/loongarch.h declares lots of stuff that shouldn't be made
	available to generic gas code, so I've removed that header from
	tc-loongarch.h and moved the parts of TC_FORCE_RELOCATION_SUB_LOCAL
	and TC_FORCE_RELOCATION_SUB_LOCAL that need LARCH_opts to functions
	in tc-loongarch.c

		* config/loongarch-parse.y (loongarch_parse_expr): Rename
	        param to avoid shadowing.
		* config/tc-loongarch.c (loongarch_assemble_INSNs): Use memset
		rather than struct initialisation.
		(loongarch_force_relocation_sub_local): New function.
		(loongarch_force_relocation_sub_same): Likewise.
		* config/tc-loongarch.h: Don't include opcode/loongarch.h.
		(loongarch_force_relocation_sub_local): Declare, and..
		(TC_FORCE_RELOCATION_SUB_LOCAL): ..use here.
		(loongarch_force_relocation_sub_same): Declare, and..
		(TC_FORCE_RELOCATION_SUB_SAME): ..use here.

2025-06-10  Alan Modra  <amodra@gmail.com>

	kvx gcc-4.5 build fixes
	More missing struct initialisers, for expressionS vars that in this
	case don't need to be initialised.  Also an error: redefinition of
	typedef 'symbolS'.  OK, so don't use a typedef.

	csky gcc-4.5 build fix
	gcc-4.5 warns about missing csky_cpus struct initialisers.  Fix that
	by providing everything in the init macros and the zero sentinel,
	rather than just a single {0} as allowed by C99.

	gas m68hc11 use standard qsort predicate signature
	Avoid a function cast when using cmp_opcode with qsort.

	Re: Further rs_code_align support refinement
	Don't write the repeating nop pattern if it won't be used for alpha
	handle_align too.

2025-06-10  Alan Modra  <amodra@gmail.com>

	gas: xtensa build failure with --enable-64-bit-bfd
	A 32-bit host with --enable-64-bit-bfd --target=xtensa-lx106-elf give:
	gas/config/tc-xtensa.c: In function ‘xg_get_best_chain_entry’:
	gas/config/tc-xtensa.c:7689:11: error: absolute value function ‘labs’ given an argument of type ‘offsetT’ {aka ‘long long int’} but has parameter of type ‘long int’ which may cause truncation of value [-Werror=absolute-value]
	 7689 |       if (labs (off) >= J_RANGE - J_MARGIN)
	      |           ^~~~

	Let's not use labs.  Unlike labs vma_abs deliberately returns an
	unsigned value, and does the negation in an unsigned type so that
	signed overflow can't happen.

		* config/tc-xtensa.c (vma_abs): New function.
		(xg_get_best_chain_entry, xg_get_fulcrum, xg_find_best_trampoline),
		(xg_is_relaxable_fixup): Use in place of labs.

2025-06-10  Alan Modra  <amodra@gmail.com>

	dlltool invalid free
	This is a followup to commt 619f863c55ca "dlltool memory leaks".
	The name passed to def_name is freed, so if missing we can't just
	use "".  strdup it.

		* defparse.y (opt_name): xstrdup empty string.

2025-06-10  Matthieu Longo  <matthieu.longo@arm.com>

	AArch64, Arm and TIC6x tests: fix typo in linker scripts
	The linker scripts for AArch64 and TIC6x were probably originally copied from
	Arm testsuite, and contain the same typo in the name of the attributes section.

	This patch fixes the typo across all the testsuites.

2025-06-10  Simon Marchi  <simon.marchi@polymtl.ca>

	gdb/dwarf2: remove erroneous comment in open_and_init_dwo_file
	When writing commit 28f15782adab ("gdb/dwarf: read multiple .debug_info.dwo
	sections"), I initially thought that the gcc behavior of producing multiple
	.debug_info.dwo sections was a bug (it is not).  I updated the commit
	message, but it looks like this comment stayed.  Remove it, since it can
	be misleading.

	Change-Id: I027712d44b778e836f41afbfafab993da02726ef
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-10  Jiawei  <jiawei@iscas.ac.cn>

	RISC-V: Add Smrnmi extension imply relation.
	This patch adds the dependency of Smrnmi extension on Zicsr extension.

	bfd/ChangeLog:

		* elfxx-riscv.c: New imply.

	gas/ChangeLog:

		* testsuite/gas/riscv/imply.d: New test check.
		* testsuite/gas/riscv/imply.s: New imply test.

2025-06-10  Dongyan Chen  <chendongyan@isrc.iscas.ac.cn>

	RISC-V: Add support for svvptc extension.
	This implements the svvptc extensons, version 1.0[1].

	[1] https://github.com/riscv/riscv-svvptc

	bfd/ChangeLog:

		* elfxx-riscv.c: New extension.

	gas/ChangeLog:

		* NEWS: Updated.
		* testsuite/gas/riscv/march-help.l: Ditto.

2025-06-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-09  Simon Marchi  <simon.marchi@efficios.com>

	gdb/solib-svr4: remove svr4_have_link_map_offsets
	While C++ifying the solib code, I concluded that all arches that use
	SVR4 libraries do provide link map offsets, so I think this function is
	unnecessary now.

	Change-Id: Ifaae2560d92f658df3724def6219e2f89054e4b7
	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-09  Pedro Alves  <pedro@palves.net>

	Adjust gdb.cp/cpexprs.exp for Cygwin
	Running gdb.cp/cpexprs.exp on x86-64 GNU/Linux, I see:

	 break base::~base
	 Breakpoint 117 at 0x555555555d90: file .../src/gdb/testsuite/gdb.cp/cpexprs.cc, line 135.
	 (gdb) continue
	 Continuing.

	 Breakpoint 117, base::~base (this=0x7fffffffd0f8, __in_chrg=<optimized out>) at .../src/gdb/testsuite/gdb.cp/cpexprs.cc:135
	 135	  ~base (void) { } // base::~base
	 (gdb) PASS: gdb.cp/cpexprs.exp: continue to base::~base

	Here, the breakpoint only got one location because both the in-charge
	and the not-in-charge dtors are identical and got the same address:

	 $ nm -A ./testsuite/outputs/gdb.cp/cpexprs/cpexprs| c++filt |grep "~base"
	 ./testsuite/outputs/gdb.cp/cpexprs/cpexprs:0000000000001d84 W base::~base()
	 ./testsuite/outputs/gdb.cp/cpexprs/cpexprs:0000000000001d84 W base::~base()

	While on Cygwin, we get two locations for the same breakpoint, which
	the testcase isn't expecting:

	 break base::~base
	 Breakpoint 117 at 0x100402678: base::~base. (2 locations)
	 (gdb) continue
	 Continuing.

	 Thread 1 "cpexprs" hit Breakpoint 117.1, base::~base (this=0x7ffffcaf8, __in_chrg=<optimized out>) at .../src/gdb/testsuite/gdb.cp/cpexprs.cc:135
	 135	  ~base (void) { } // base::~base
	 (gdb) FAIL: gdb.cp/cpexprs.exp: continue to base::~base

	We got two locations because the in-charge and the not-in-charge dtors
	have different addresses:

	 $ nm -A outputs/gdb.cp/cpexprs/cpexprs.exe | c++filt | grep "~base"
	 outputs/gdb.cp/cpexprs/cpexprs.exe:0000000100402680 T base::~base()
	 outputs/gdb.cp/cpexprs/cpexprs.exe:0000000100402690 T base::~base()

	On Cygwin, we also see the typical failure due to not expecting the
	inferior to be multi-threaded:

	  (gdb) continue
	  Continuing.
	  [New Thread 628.0xe08]

	  Thread 1 "cpexprs" hit Breakpoint 200, test_function (argc=1, argv=0x7ffffcc20) at .../src/gdb/testsuite/gdb.cp/cpexprs.cc:336
	  336	  derived d;
	  (gdb) FAIL: gdb.cp/cpexprs.exp: continue to test_function for policyd3::~policyd

	Both issues are fixed by this patch, and now the testcase passes
	cleanly on Cygwin, for me.

	Reviewed-By: Keith Seitz <keiths@redhat.com>
	Change-Id: If7eb95d595f083f36dfebf9045c0fc40ef5c5df1

2025-06-09  Pedro Alves  <pedro@palves.net>

	gdb.threads/thread-execl, don't re-exec forever
	I noticed on Cygwin, gdb.thread/thread-execl.exp would hang, (not that
	surprising since we can't follow-exec on Cygwin).  Looking at the
	process list running on the machine, we end up with a thread-execl.exe
	process constantly respawning another process [1].

	We see the same constant-reexec if we launch gdb.thread/thread-execl
	manually on the shell:

	 $ ./testsuite/outputs/gdb.threads/thread-execl/thread-execl
	 # * doesn't exit, constantly re-execing *
	 ^C

	Prevent this leftover constantly-re-execing scenario by making the
	testcase program only exec once.  We now get:

	  $ ./testsuite/outputs/gdb.threads/thread-execl/thread-execl
	  $   # exits immediately after one exec.

	On Cygwin, the testcase now fails reasonably quickly, and doesn't
	leave stale processes behind.

	Still passes cleanly on x86-64 GNU/Linux.

	[1] Cygwin's exec emulation spawns a new Windows process for the new
	image.

	Approved-By: Andrew Burgess <aburgess@redhat.com>
	Change-Id: I0de1136cf2ef7e89465189bc43489a2139a80efb

2025-06-09  Pedro Alves  <pedro@palves.net>

	Support core dumping testcases with Cygwin's dumper
	Cygwin supports dumping ELF cores via a dumper.exe utility, see
	https://www.cygwin.com/cygwin-ug-net/dumper.html.

	When I run a testcase that has the "kernel" generate a corefile, like
	gdb.base/corefile.exp, Cygwin invokes dumper.exe correctly and
	generates an ELF core file, however, the testsuite doesn't find the
	generated core:

	 Running /home/alves/gdb/src/gdb/testsuite/gdb.base/corefile.exp ...
	 WARNING: can't generate a core file - core tests suppressed - check ulimit -c

	The file is correctly put under $coredir, e.g., like so:

	  outputs/gdb.base/corefile/coredir.8926/corefile.exe.core

	The problem is in this line in core_find:

	  foreach i "${coredir}/core ${coredir}/core.coremaker.c ${binfile}.core" {

	Note that that isn't looking for "${binfile}.core" inside
	${coredir}...  That is fixed in this patch.

	However, that still isn't sufficient for Cygwin + dumper, as in that
	case the core is going to be called foo.exe.core, not foo.core.  Fix
	that by looking for foo.exe.core in the core dir as well.

	With this, gdb.base/corefile.exp and other tests that use core_find
	now run.  They don't pass cleanly, but at least now they're exercised.

	Approved-By: Tom Tromey <tom@tromey.com>
	Change-Id: Ic807dd2d7f22c5df291360a18c1d4fbbbb9b993e

2025-06-09  Pedro Alves  <pedro@palves.net>

	Adjust gdb.base/sigall.exp for Cygwin
	The gdb.base/sigall.exp testcase has many FAILs on Cygwin currently.

	From:

	 Thread 1 "sigall" received signal SIGPWR, Power fail/restart.
	 0x00007ffeac9ed134 in ntdll!ZwWaitForSingleObject () from /cygdrive/c/Windows/SYSTEM32/ntdll.dll
	 (gdb) FAIL: gdb.base/sigall.exp: get signal LOST

	we see two issues.  The test is expecting "Program received ..." which
	only appears if the inferior is single-threaded.  All Cygwin inferiors
	are multi-threaded, because both Windows and the Cygwin runtime spawn
	a few helper threads.

	And then, SIGLOST is the same as SIGPWR on Cygwin.  The testcase
	already knows to treat them the same on SPARC64 GNU/Linux.  We just
	need to extend the relevant code to treat Cygwin the same.

	With this, the test passes cleanly on Cygwin.

	Approved-By: Tom Tromey <tom@tromey.com>
	Change-Id: Ie3553d043f4aeafafc011347b6cb61ed58501667

2025-06-09  Pedro Alves  <pedro@palves.net>

	Adjust gdb.arch/amd64-watchpoint-downgrade.exp for Cygwin
	The gdb.arch/amd64-watchpoint-downgrade.exp testcase is assuming the
	output of debugging a single-thread program, like so, on e.g.,
	GNU/Linux:

	 starti
	 Starting program: .../gdb.arch/amd64-watchpoint-downgrade/amd64-watchpoint-downgrade
	 warning: watchpoint 1 downgraded to software watchpoint

	 Program stopped.
	 0x00007ffff7fe32b0 in _start () from /lib64/ld-linux-x86-64.so.2

	However, on Cygwin, where all inferiors are multi-threaded (because
	both Windows and the Cygwin runtime spawn a few helper threads), we
	get:

	 starti
	 Starting program: .../gdb.arch/amd64-watchpoint-downgrade/amd64-watchpoint-downgrade
	 [New Thread 4652.0x17e4]
	 warning: watchpoint 1 downgraded to software watchpoint

	 Thread 1 stopped.
	 0x00007ffbfc1c0911 in ntdll!LdrInitShimEngineDynamic () from C:/Windows/SYSTEM32/ntdll.dll

	This commit adjusts the testcase to work with either output.

	(Note GDB may print a thread name after the thread number.)

	Approved-by: Kevin Buettner <kevinb@redhat.com>
	Change-Id: I3aedfec04924ea3fb3bb87ba3251e2b720f8d59c

2025-06-09  Pedro Alves  <pedro@palves.net>

	Adjust gdb.base/bp-permanent.exp for Cygwin
	On Cygwin, all inferiors are multi-threaded, because both Windows and
	the Cygwin runtime spawn a few helper threads.  Adjust the
	gdb.base/bp-permanent.exp testcase to work with either single- or
	multi-threaded inferiors.

	Approved-by: Kevin Buettner <kevinb@redhat.com>
	Change-Id: I28935b34fc9f739c2a5490e83aa4995d29927be2

2025-06-09  Pedro Alves  <pedro@palves.net>

	Adjust gdb.base/bp-cond-failure.exp for Cygwin
	Currently on Cygwin, I get:

	 Running /home/alves/gdb/src/gdb/testsuite/gdb.base/bp-cond-failure.exp ...
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=char: cond_eval=auto: multi-loc: continue
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=char: cond_eval=auto: single-loc: continue
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=short: cond_eval=auto: multi-loc: continue
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=short: cond_eval=auto: single-loc: continue
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=int: cond_eval=auto: multi-loc: continue
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=int: cond_eval=auto: single-loc: continue
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=long long: cond_eval=auto: multi-loc: continue
	 FAIL: gdb.base/bp-cond-failure.exp: access_type=long long: cond_eval=auto: single-loc: continue

	On GNU/Linux, we see:

	 Breakpoint 2.1, foo () at .../src/gdb/testsuite/gdb.base/bp-cond-failure.c:21
	 21        return 0;     /* Multi-location breakpoint here.  */
	 (gdb) PASS: gdb.base/bp-cond-failure.exp: access_type=char: cond_eval=auto: multi-loc: continue

	While on Cygwin, we see:

	 Thread 1 "bp-cond-failure" hit Breakpoint 2.1, foo () at .../src/gdb/testsuite/gdb.base/bp-cond-failure.c:21
	 21        return 0;     /* Multi-location breakpoint here.  */
	 (gdb) FAIL: gdb.base/bp-cond-failure.exp: access_type=char: cond_eval=auto: multi-loc: continue

	The difference is the "Thread 1" part in the beginning of the quoted
	output.  It appears on Cygwin, but not on Linux.  That's because on
	Cygwin, all inferiors are multi-threaded, because both Windows and the
	Cygwin runtime spawn a few helper threads.

	Fix this by adjusting the gdb.base/bp-cond-failure.exp testcase to
	work with either single- or multi-threaded inferiors.

	The testcase passes cleanly for me after this.

	Approved-by: Kevin Buettner <kevinb@redhat.com>
	Change-Id: I5ff11d06ac1748d044cef025f1e78b8f84ad3349

2025-06-09  Alice Carlotti  <alice.carlotti@arm.com>

	MAINTAINERS: Add myself as an AArch64 maintainer

2025-06-09  Richard Earnshaw  <rearnsha@arm.com>

	aarch64: Increase the number of feature words to 3
	Now that most of the effort of updating the number of feature words is
	handled by macros, add an additional one, taking the number of
	supported features to 192.

2025-06-09  Richard Earnshaw  <rearnsha@arm.com>

	aarch64: use macro trickery to automate feature array size replication
	There are quite a few macros that need to be changed when we need to
	increase the number of words in the features data structure.  With
	some macro trickery we can automate most of this so that a single
	macro needs to be updated.

	With C2X we could probably do even better by using recursion, but this
	is still a much better situation than we had previously.

	A static assertion is used to ensure that there is always enough space
	in the flags macro for the number of feature bits we need to support.

2025-06-09  Yury Khrustalev  <yury.khrustalev@arm.com>

	aarch64: Fix typos in opcode headers

2025-06-09  Alan Modra  <amodra@gmail.com>

	change some listing.c variables to unsigned.
	The values are unsigned, and changing the types allows some casts to
	be removed.

2025-06-09  Alan Modra  <amodra@gmail.com>

	dwarf2dbg.c line_entry.next assert
	I was puzzling over how it was correct to cast what is clearly a
	struct line_entry** pointer to a struct line_entry* pointer for a
	few moments, and was going to write a comment but then decided we
	really don't require the "next" pointer to be where it is.  Replace
	the assert with an inline function that does any necessary pointer
	adjustments.

		* dwarf2dbg.c (line_entry.next): Delete static assertion.
		(line_entry_at_tail): New inline function.
		(dwarf2_gen_line_info_1, dwarf2_finish): Replace casts in
		set_or_check_view arguments with line_entry_at_tail.

2025-06-09  Alan Modra  <amodra@gmail.com>

	str_hash_find casts
	Putting an explicit cast on the void* return from str_hash_find isn't
	necessary and doesn't add much to code clarity.  In other cases, poor
	choice of function parameter types, eg. "void *value" in
	tc-aarch64.c checked_hash_insert rather than "const void *value" leads
	to needing (void *) casts all over the place just to cast away const.
	Fix that by correcting the parameter type.  (And it really is a const,
	the function and str_hash_insert don't modify the strings.)
	This patch also removes some unnecessary casts in hash.c

2025-06-09  Alan Modra  <amodra@gmail.com>

	str_hash_find_int
	This changes the internal representation of string_tuple.value from
	a void* to an intptr_t, removing any concerns that code wanting to
	store an integer value will use values that are trap encodings or
	suchlike for a pointer.  The ISO C standard says any void* can be
	converted to intptr_t and back again and will compare equal to the
	original pointer.  It does *not* say any intptr_t can be converted to
	void* and back again to get the original integer..

	Two new functions, str_hash_find_int and str_hash_insert_int are
	provided for handling integer values.  str_hash_find_int returns
	(intptr_t) -1 on failing to find the key string.

	Most target code need minimal changes to use the new interface, but
	some simplification is possible since now a zero can be stored and
	differentiated from the NULL "can't find" return.  (Yes, that means
	(intptr_t) -1 can't be stored.)

	I've changed the avr_no_sreg_hash dummy value to zero, and the
	loongarch register numbers don't need to be incremented.  loongarch
	also doesn't need to store an empty key string (if it ever did).

2025-06-09  Alan Modra  <amodra@gmail.com>

	metag build error
	gas/config/tc-metag.c: In function ‘parse_dsp_addr’:
	gas/config/tc-metag.c:4386:29: error: ‘regs[0]’ may be used uninitialized [-Werror=maybe-uninitialized]
	 4386 |   if (!is_addr_unit (regs[0]->unit) &&
	      |                      ~~~~~~~^~~~~~

	It looks like regs_read can be zero with "l" non-NULL, so this gcc
	complaint is accurate.

		* config/tc-metag.c (parse_dsp_addr, parse_dget_set): Check
		regs_read.

2025-06-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-07  Tom de Vries  <tdevries@suse.de>

	[gdb/build] Fix buildbreaker in hardwire_setbaudrate
	When building on x86_64-cygwin, I run into:
	...
	In file included from gdbsupport/common-defs.h:203,
	                 from gdb/defs.h:26,
	                 from <command-line>:
	gdb/ser-unix.c: In function ‘void hardwire_setbaudrate(serial*, int)’:
	gdbsupport/gdb_locale.h:28:20: error: expected ‘)’ before ‘gettext’
	   28 | # define _(String) gettext (String)
	      |                    ^~~~~~~
	gdbsupport/gdb_assert.h:43:43: note: in expansion of macro ‘_’
	   43 |   internal_error_loc (__FILE__, __LINE__, _("%s: " message), __func__, \
	      |                                           ^
	gdb/ser-unix.c:590:7: note: in expansion of macro ‘gdb_assert_not_reached’
	  590 |       gdb_assert_not_reached (_("Serial baud rate was not found in B_codes"));
	      |       ^~~~~~~~~~~~~~~~~~~~~~
	gdb/ser-unix.c:590:31: note: in expansion of macro ‘_’
	  590 |       gdb_assert_not_reached (_("Serial baud rate was not found in B_codes"));
	      |                               ^
	gdbsupport/gdb_locale.h:28:28: note: to match this ‘(’
	   28 | # define _(String) gettext (String)
	      |                            ^
	gdbsupport/gdb_assert.h:43:43: note: in expansion of macro ‘_’
	   43 |   internal_error_loc (__FILE__, __LINE__, _("%s: " message), __func__, \
	      |                                           ^
	gdb/ser-unix.c:590:7: note: in expansion of macro ‘gdb_assert_not_reached’
	  590 |       gdb_assert_not_reached (_("Serial baud rate was not found in B_codes"));
	      |       ^~~~~~~~~~~~~~~~~~~~~~
	...

	Fix this by dropping the unneeded _() on the gdb_assert_not_reached argument.

	PR build/33064
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=33064

2025-06-07  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.ada/dyn-bit-offset.exp on s390x
	On s390x-linux, with test-case gdb.ada/dyn-bit-offset.exp and gcc 7.5.0 I get:
	...
	(gdb) print spr^M
	$1 = (discr => 3, array_field => (-5, -6, -7), field => -6, another_field => -6)^M
	(gdb) FAIL: $exp: print spr
	print spr.field^M
	$2 = -6^M
	(gdb) FAIL: $exp: print spr.field
	...

	On x86_64-linux, with the same compiler version I get:
	...
	(gdb) print spr^M
	$1 = (discr => 3, array_field => (-5, -6, -7), field => -4, another_field => -4)^M
	(gdb) XFAIL: $exp: print spr
	print spr.field^M
	$2 = -4^M
	(gdb) PASS: $exp: print spr.field
	...

	In both cases, we're hitting the same compiler problem, but it manifests
	differently on little and big endian.

	Make sure the values seen for both little and big endian trigger xfails
	for both tests.

	Printing spr.field gives the expected value -4 for x86_64, but that's an
	accident.  Change the actual spr.field value to -5, to make sure
	that we get the same number of xfails on x86_64 and s390x.

	Finally, make the xfails conditional on the compiler version.

	Tested using gcc 7.5.0 on both x86_64-linux and s390x-linux.

	Approved-By: Andrew Burgess <aburgess@redhat.com>

	PR testsuite/33042
	https://sourceware.org/bugzilla/show_bug.cgi?id=33042

2025-06-07  Georg-Johann Lay  <avr@gjlay.de>

	AVR: ld/32968 - Assert that .progmem data resides in the lower 64 KiB.
	This patch locates the linker stubs / trampolines *after* all the .progmem
	sections.  This is the natural placement since progmem data has to reside
	in the lower 64 KiB (it is accessed using LPM), whereas the linker stubs
	are only required to be located in the lower 128 KiB of program memory.
	(They must be in the range of EICALL / EIJMP with EIND = 0.)

	The current location of the linker stubs was motivated by an invalid test
	case from PR13812 that allocates more than 64 KiB of progmem data.

	The patch adds an assertion that makes sure that no progmem data is
	allocated past 0xffff.

	Data that is accessed using ELPM should be located to .progmemx so that
	no .progmem addresses are wasted.  .progmemx was introduced in 2017 and
	is used by __memx, __flashx and by the current AVR-LibC.
	(The compiler uses .jumptables.gcc for its jump dispatch tables since
	https://gcc.gnu.org/bugzilla/show_bug.cgi?id=63223 / GCC v4.9.2).

		PR ld/32968
	ld/
		* scripttempl/avr.sc: Move the trampolines section after the
		.progmem sections.  Assert that .progmem is in the lower 64 KiB.

2025-06-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2025-06-06  Andrew Burgess  <aburgess@redhat.com>

	gdb/guile: fix memory leak in gdbscm_parse_command_name
	For reference see the previous commit.

	Fix a memory leak in gdbscm_parse_command_name when a guile exception
	is thrown.  To reveal the memory leak I placed the following content
	into a file 'leak.scm':

	  (use-modules (gdb))
	  (register-command!
	   (make-command
	    "break cmd"
	    #:command-class COMMAND_OBSCURE
	    #:invoke (lambda (self arg from-tty)
	               (display "Hello World"))))

	Then in GDB:

	  (gdb) source leak.scm
	  ERROR: In procedure register-command!:
	  In procedure gdbscm_register_command_x: Out of range: 'break' is not a prefix command in position 1: "break cmd"
	  Error while executing Scheme code.

	Running this under valgrind reveals a memory leak for 'result' and
	'prefix_text' from gdbscm_parse_command_name.

	Another leak can be revealed with this input script:

	  (use-modules (gdb))
	  (register-command!
	   (make-command
	    "unknown-prefix cmd"
	    #:command-class COMMAND_OBSCURE
	    #:invoke (lambda (self arg from-tty)
	               (display "Hello World"))))

	This one occurs earlier in gdbscm_parse_command_name, and now only
	'result' leaks.

	The problem is that, when guile throws an exception then a longjmp is
	performed from the function that raise the exception back to the guile
	run-time.  A consequence of this is that no function local destructors
	will be run.

	In gdbscm_parse_command_name, this means that the two function locals
	`result` and `prefix_text` will not have their destructors run, and
	any memory managed by these objects will be leaked.

	Fix this by assigning nullptr to these two function locals before
	throwing an exception.  This will cause the managed memory to be
	deallocated.

	I could have implemented a fix that made use of Guile's dynwind
	mechanism to register a cleanup callback, however, this felt like
	overkill.  At the point the exception is being thrown we know that we
	no longer need the managed memory, so we might as well just free the
	memory at that point.

	With this fix in place, the two leaks are now fixed in the valgrind
	output.

	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-06  Andrew Burgess  <aburgess@redhat.com>

	gdb/python/guile: remove some explicit calls to xmalloc
	In gdbpy_parse_command_name (python/py-cmd.c) there is a call to
	xmalloc that can easily be replaced with a call to
	make_unique_xstrndup, which makes the code easier to read (I think).

	In gdbscm_parse_command_name (guile/scm-cmd.c) the same fix can be
	applied to remove an identical xmalloc call.  And there is an
	additional xmalloc call, which can also be replaced with
	make_unique_xstrndup in the same way.

	The second xmalloc call in gdbscm_parse_command_name was also present
	in gdbpy_parse_command_name at one point, but was replaced with a use
	of std::string by this commit:

	  commit 075c55e0cc0a68eeab777027213c2f545618e844
	  Date:   Wed Dec 26 11:05:57 2018 -0700

	      Remove more calls to xfree from Python

	I haven't changed the gdbscm_parse_command_name to use std::string
	though, as that doesn't work well with the guile exception model.
	Guile exceptions work by performing a longjmp from the function that
	raises the exception, back to the guile run-time.  The consequence of
	this is that destructors are not run.  For example, if
	gdbscm_parse_command_name calls gdbscm_out_of_range_error, then any
	function local objects in gdbscm_parse_command_name will not have
	their destructors called.

	What this means is that, for the existing `result` and `prefix_text`
	locals, any allocated memory managed by these objects will be leaked
	if an exception is called.  However, fixing this is pretty easy, one
	way is to just assign nullptr to these locals before raising the
	exception, this would cause the allocated memory to be released.

	But for std::string it is harder to ensure that the managed memory has
	actually been released.  We can call std::string::clear() and then
	maybe std::string::shrink_to_fit(), but this is still not guaranteed
	to release any managed memory.  In fact, I believe the only way to
	ensure all managed memory is released, is to call the std::string
	destructor.

	And so, for functions that can throw a guile exception, it is easier
	to just avoid std::string.

	As for the memory leak that I identify above; I'll fix that in a
	follow on commit.

	Approved-By: Tom Tromey <tom@tromey.com>

2025-06-06  Guinevere Larsen  <guinevere@redhat.com>

